/******************************************************************************
Copyright 2016 - 2019 Intel Corporation
 
For licensing information, see the file 'LICENSE' in the root folder of
  this software module. 
******************************************************************************/

#include <StdAfx.h>
#include "PObject.h"


PObject::PObject()
    : _lRefCnt(1)
{
    DBG(D_FUNC, (L"%s\n", FULL_FUNC_NAME));
}

PObject::~PObject()
{
    assert(!_lRefCnt);
}

LONG PObject::AddRef()
{
    return InterlockedIncrement(&_lRefCnt);
}

LONG PObject::Release()
{
    LONG  lRef;

    lRef = InterlockedDecrement(&_lRefCnt);

    if ( !lRef )
    {
        delete this;
    }

    return lRef;
}

