/******************************************************************************
Copyright 2016 - 2019 Intel Corporation
 
For licensing information, see the file 'LICENSE' in the root folder of
  this software module. 
******************************************************************************/

#ifndef _BUFFER_ITEM_H
#define _BUFFER_ITEM_H


class BufferItem
{
public:
    BufferItem();
    BufferItem(UINT size);
    ~BufferItem();

    void Alloc(UINT size);
    void Expand(UINT len);
    void Reset(UINT len = 0);

    void Reserve(UINT len);
    void Retain(UINT len);
    PBYTE Put(UINT len);
    PBYTE Push(UINT len);
    PBYTE Pull(UINT len);

    void Save(UINT len);
    void Restore();

    UINT room() const;
    PBYTE data() const;
    UINT data_size() const;
    PBYTE head() const;
    UINT head_size() const;
    PBYTE tail() const;
    UINT tail_size() const;

private:
    void Init();

private:
    UINT                        _data_len;
    PBYTE                       _head;
    PBYTE                       _data;
    PBYTE                       _tail;
    PBYTE                       _end;

    UINT                        _data_len_saved;
};


#endif

