/******************************************************************************
Copyright 2016 - 2019 Intel Corporation
 
For licensing information, see the file 'LICENSE' in the root folder of
  this software module. 
******************************************************************************/

#ifndef _CONNECT_CENTER_H
#define _CONNECT_CENTER_H


class Connection;


class ConnectCenter
{
public:
    static ConnectCenter *Instance();
    static void Destroy();

private:
    static ConnectCenter      * _instance;

protected:
    ConnectCenter();
    ~ConnectCenter();

public:
    DWORD Load();
    void Unload();

    DWORD CreateListener(PSOCK_ADDR pLocalAddr, UINT nBacklogNum, Connection **ppListenConnection);
    DWORD AcceptConnection(Connection *pListenConnection, bool bAsync, Connection **ppConnection);

    DWORD ConnectIn(PSOCK_ADDR pLocalAddr, bool bAsync, Connection **ppConnection);
    DWORD ConnectOut(PSOCK_ADDR pLocalAddr, const PSOCK_ADDR pRemoteAddr, bool bAsync, Connection **ppConnection);
    DWORD ConnectOut(PSOCK_ADDR pLocalAddr, const PSOCK_ADDR pRemoteAddr, const PSOCK_ADDR pProxyAddr, bool bAsync, Connection **ppConnection);

#ifdef CONFIG_TLS_SUPPORT
    DWORD AcceptConnectionTLS(Connection *pListenConnection, bool bAsync, Connection **ppConnection);
    DWORD ConnectOutTLS(PSOCK_ADDR pLocalAddr, const PSOCK_ADDR pRemoteAddr, bool bAsync, Connection **ppConnection);
    DWORD ConnectOutTLS(PSOCK_ADDR pLocalAddr, const PSOCK_ADDR pRemoteAddr, const PSOCK_ADDR pProxyAddr, bool bAsync, Connection **ppConnection);
#endif

    void FinishConnection(Connection *pConnection);

private:
    DWORD CreateAndBind(PSOCK_ADDR pLocalAddr, bool bAsync, bool bMCast, SOCKET &rs);

    DWORD AllocConnection(SOCKET s, bool bListener, bool bAsyncConnect, bool bUdpConnectIn, const PSOCK_ADDR pMCastAddr, Connection **ppConnection);
};


#endif
