/******************************************************************************
Copyright 2016 - 2019 Intel Corporation
 
For licensing information, see the file 'LICENSE' in the root folder of
  this software module. 
******************************************************************************/

#ifndef _CONNECTION_H
#define _CONNECTION_H


#include "BufferItem.h"

class ProtocolHandler;


class Connection
{
public:
    // see issues_virtual.txt
    Connection() { DBG(D_INFO, (L"%s\n", FULL_FUNC_NAME)); }
    virtual ~Connection() { DBG(D_INFO, (L"%s\n", FULL_FUNC_NAME)); }

    virtual DWORD Attach(ProtocolHandler *pHandler, UINT nRecvBufCnt, UINT nSendItemCnt) = 0;
    virtual void Detach() = 0;

    virtual DWORD EnableKeepAlive(UINT nInterval) = 0;

    virtual void ResetRecv(UINT nBufCnt) = 0;
    virtual void ResetSend(UINT nItemCnt) = 0;
    virtual void ResumeRecv(UINT nBufCnt) = 0;
    virtual void ResumeSend(UINT nItemCnt) = 0;

    virtual DWORD GetLocalAddr(PSOCK_ADDR pAddr) = 0;
    virtual DWORD GetPeerAddr(PSOCK_ADDR pAddr) = 0;

    virtual DWORD SetRecvBufSize(DWORD dwSize) = 0;
    virtual DWORD SetSendBufSize(DWORD dwSize) = 0;

    virtual DWORD PollRecv(DWORD dwMilliseconds) = 0;
    virtual DWORD PollSend(DWORD dwMilliseconds) = 0;

    virtual DWORD Recv(BufferItem *pBufItem) = 0;
    virtual DWORD Send(BufferItem *pBufItem) = 0;

    DWORD Recv(BufferItem *pBufItem, DWORD dwMilliseconds);
    DWORD Send(BufferItem *pBufItem, DWORD dwMilliseconds);
};


#endif
