/******************************************************************************
Copyright 2016 - 2019 Intel Corporation
 
For licensing information, see the file 'LICENSE' in the root folder of
  this software module. 
******************************************************************************/

#ifndef _EP_BRIDGE_HANDLER_H
#define _EP_BRIDGE_HANDLER_H


#include "EpPDUHandler.h"


class EpBridgeHandler : public EpPDUHandler
{
public:
    EpBridgeHandler();
    virtual ~EpBridgeHandler();

    virtual DWORD Bind(Connection *pConnection, PCondEvent *pEvent, UINT nSigIdx);
    virtual void Unbind();

    virtual void OnAsyncConnected(Connection *pConnection);
    virtual void OnDisconnectedOrError(Connection *pConnection);
    virtual UINT OnRecvReady(Connection *pConnection);
    virtual UINT OnSendReady(Connection *pConnection);

    virtual DWORD GetFlags();

    virtual void PrepareSend();

protected:
    void ReqEndSession();

    virtual void ProcessRecvPDU(BYTE bCode, bool bReq, DWORD dwParam, BufferItem *pbiBody);
    virtual void ProcessRecvPDU(BYTE bCode, bool bReq, DWORD dwParam, const PBYTE pData, UINT nDataBytes, UINT nLeftBytes);

private:
    void EnterBridgeMode();

    void OnOpenBridgeReq(PREQ_BRIDGE_OPEN pOpenReq);
    DWORD OpenConnection(const PSOCK_ADDR pRemoteAddr);

private:
    BRIDGE_STATE                _CurState;

    bool                        _bReqConnect;
    SOCK_ADDR                   _RemoteAddr;
    Connection                * _pOutConnection;

    ProducerQueue               _ForwardQueue;
    ProducerQueue               _ReplyQueue;
};


#endif
