/******************************************************************************
Copyright 2016 - 2019 Intel Corporation
 
For licensing information, see the file 'LICENSE' in the root folder of
  this software module. 
******************************************************************************/

#ifndef _EP_PDU_HANDLER_H
#define _EP_PDU_HANDLER_H


#include "EpProtocolHandler.h"


class EpPDUHandler : public EpProtocolHandler
{
public:
    EpPDUHandler
        (
            UINT nRecvQSize, UINT nRecvBSize,
            UINT nSendQSize, UINT nSendBSize,
            UINT nEvtQSize, UINT nEvtBSize, bool bEvtLock = false
        );
    virtual ~EpPDUHandler();

    virtual void Unbind();

protected:
    virtual bool ProcessRecvData(BufferItem *pbiData);
    virtual void ProcessRecvPDU(BYTE bCode, bool bReq, DWORD dwParam, BufferItem *pbiBody) = 0;
    virtual void ProcessRecvPDU(BYTE bCode, bool bReq, DWORD dwParam, const PBYTE pData, UINT nDataBytes, UINT nLeftBytes) = 0;

    void BuildPDU(BYTE bCode, bool bReq, bool bBodyPDU, DWORD dwParam, BufferItem *pbiBody);

private:
    BufferItem                  _biHdr;
    PPDU_COMM_HDR               _pHdr;

    UINT                        _nCurBodySize;
    BufferItem                  _biBody;
};


#endif
