/******************************************************************************
Copyright 2016 - 2019 Intel Corporation
 
For licensing information, see the file 'LICENSE' in the root folder of
  this software module. 
******************************************************************************/

#ifndef _FILTER_PROTOCOL_H
#define _FILTER_PROTOCOL_H


#include "Connection.h"
#include "ProtocolHandler.h"


class FilterProtocol : public Connection, public ProtocolHandler
{
public:
    FilterProtocol(Connection *pConnection);
    virtual ~FilterProtocol();

public:
    virtual DWORD Attach(ProtocolHandler *pHandler, UINT nRecvBufCnt, UINT nSendItemCnt);
    virtual void Detach();

    virtual DWORD EnableKeepAlive(UINT nInterval);

    virtual void ResetRecv(UINT nBufCnt);
    virtual void ResetSend(UINT nItemCnt);
    virtual void ResumeRecv(UINT nBufCnt);
    virtual void ResumeSend(UINT nItemCnt);

    virtual DWORD GetLocalAddr(PSOCK_ADDR pAddr);
    virtual DWORD GetPeerAddr(PSOCK_ADDR pAddr);

    virtual DWORD SetRecvBufSize(DWORD dwSize);
    virtual DWORD SetSendBufSize(DWORD dwSize);

    virtual DWORD PollRecv(DWORD dwMilliseconds);
    virtual DWORD PollSend(DWORD dwMilliseconds);

    virtual DWORD Recv(BufferItem *pBufItem);
    virtual DWORD Send(BufferItem *pBufItem);

public:
    virtual void OnAsyncConnected(Connection *pConnection);

    virtual void OnDisconnectedOrError(Connection *pConnection);

    virtual UINT OnRecvReady(Connection *pConnection);
    virtual UINT OnSendReady(Connection *pConnection);

protected:
    Connection                * _pConnection;

    ProtocolHandler           * _pHandler;
};


#endif
