/******************************************************************************
Copyright 2016 - 2019 Intel Corporation
 
For licensing information, see the file 'LICENSE' in the root folder of
  this software module. 
******************************************************************************/

#ifndef _GLOBAL_DEF_H
#define _GLOBAL_DEF_H


#define  CONFIG_DEFLATE_CODEC_ID    3

#if (CONFIG_DEFLATE_CODEC_ID == 3)
#define  CONFIG_USE_LZ4             1
#elif (CONFIG_DEFLATE_CODEC_ID == 2)
#define  CONFIG_USE_ZLIB_NG         1
#elif (CONFIG_DEFLATE_CODEC_ID == 1)
#define  CONFIG_USE_ZLIB            1
#else
#define  CONFIG_DEFLATE_USE_ZNULL   1
#endif

//#define  CONFIG_TLS_SUPPORT         1
//#define  CONDIF_TLS_MUTUAL          1
#define  ENV_CA_PATH                "cafile"
#define  ENV_CERT_PATH              "certfile"
#define  ENV_KEY_PATH               "keyfile"
const UINT  TLS_BUF_SIZE          = (20 * 1024);

#ifdef _LINUX_
#define  CONFIG_REACTOR_EPOLL       1
#else
#define  CONFIG_REACTOR_SELECT      1
#endif

#ifdef CONFIG_REACTOR_EPOLL
#define  CONFIG_EPOLL_EDGETRIGGER   1
#define  CONFIG_EPOLL_ET_YIELD_NUM  16
#endif

#ifdef CONFIG_REACTOR_SELECT
#define  ReactorSocket              ReactorSelect
#endif
#ifdef CONFIG_REACTOR_EPOLL
#define  ReactorSocket              ReactorEPoll
#endif

#define  CONFIG_MCAST_SUPPORT       1

#define  CONFIG_ST_BLK_COMPACT      1
const UINT  COMPACT_CLUSTER_SIZE  = (64*1024);

//#define  CONFIG_ST_BLK_WR_VERIFY    1

//#define  CONFIG_ST_BLK_RD_MMAP      1
//#define  CONFIG_ST_BLK_WR_MMAP      1

#ifndef CONFIG_ST_BLK_RD_MMAP
#define  CONFIG_ST_BLK_RD_AHEAD     1
#define  CONFIG_ST_BLK_RD_FIO       1
#define  CONFIG_ST_BLK_RD_BUF       1
const UINT  ST_BLK_RD_BUF_SIZE    = (1*1024*1024);
#endif

#ifndef CONFIG_ST_BLK_WR_MMAP
#define  CONFIG_ST_BLK_WR_FIO       1
#define  CONFIG_ST_BLK_WR_BUF       1
const UINT  ST_BLK_WR_BUF_SIZE    = (1*1024*1024);
#endif

const UINT  MAX_SOCKADDR_STR_LEN  = 32;
const UINT  MAX_FILE_NAME_LEN     = 256;

const DWORD  INVALID_MUX_ID       = -1;

const UINT  MAX_EPOLL_NUM         = 1024;
const UINT  EPOLL_EVT_NUM         = 64;
const UINT  EPOLL_MSG_NUM         = 64;

const UINT  KEEP_ALIVE_TIMEOUT    = 60;

const UINT  REACTOR_SELECT_LIMIT  = FD_SETSIZE;

const UINT  DEFAULT_BACKLOG_NUM   = 5;

const UINT  MAX_RUNNABLE_NUM      = 1000;

const UINT  MAX_TIMER_NUM         = 1000;
const DWORD  INVALID_TIMER_ID     = -1;

const UINT  INVALID_RUNNABLE_ID   = -1;

const UINT  PDU_HEAD_RESERVE      = 64;
const UINT  DEFAULT_PDU_SIZE      = 1440;
const UINT  MAX_PDU_SIZE          = (40 * 1024);
const DWORD  PDU_MAGIC_NUM        = 0x5544505F;  // '_PDU'

const UINT  MSG_HEAD_RESERVE      = 64;

const UINT  INVALID_PCOND_IDX     = -1;

const DWORD  INVALID_LISTENER_ID  = -1;
const UINT  INVALID_EP_CONN_ID    = -1;


typedef enum _ADDR_TYPE
{
    ADDR_TYPE_IPV4 = 1,
    ADDR_TYPE_UNKNOWN
}
ADDR_TYPE;

typedef enum _CONN_CMD_BITS
{
    C_CONN_RESUME_LISTEN      = 0x01,

    C_CONN_MCAST_START        = 0x02,
    C_CONN_MCAST_TIMER        = 0x04
}
CONN_CMD_BITS;

typedef enum _EPMSG_CODE
{
    C_EPMSG_BASE              = 1,
    C_EPMSG_END               = C_EPMSG_BASE + 0x0100,

    C_LP2PMSG_BASE,
    C_LP2PMSG_END             = C_LP2PMSG_BASE + 0x0100
}
EPMSG_CODE;

typedef struct _EP_MSG_HDR
{
    UINT                            nCode;
    DWORD                           dwCookie;
    DWORD                           dwParam;
    DWORD                           dwReserved;
}
EP_MSG_HDR, *PEP_MSG_HDR;

#pragma pack(1)

typedef struct _IPV4_ADDR
{
    BYTE                            bStream;
    WORD                            wPort;  // network order
    DWORD                           dwIP;   // network order
}
IPV4_ADDR, *PIPV4_ADDR;

typedef struct _SOCK_ADDR
{
    BYTE                            bType;
    union
    {
        IPV4_ADDR                   IPv4Addr;
    };
}
SOCK_ADDR, *PSOCK_ADDR;

typedef struct _PDU_COMM_HDR
{
    DWORD                           dwMagic;
    WORD                            wBodySize;
    BYTE                            bCode;
    BYTE                            bReq : 1;
    BYTE                            bBodyPDU : 1;
    BYTE                            bReserved : 6;
    DWORD                           dwParam;
}
PDU_COMM_HDR, *PPDU_COMM_HDR;

#pragma pack()


/*--------------------------------------------------------*/

const WORD  BRIDGE_SERVICE_PORT   = 5000;

const UINT  BRIDGE_DATAQSIZE = 16;
const UINT  BRIDGE_DATABSIZE = MAX_PDU_SIZE;

typedef enum _BRIDGE_STATE
{
    S_BRIDGE_CMD = 1,
    S_BRIDGE_ENABLED,
    S_BRIDGE_END
}
BRIDGE_STATE;

typedef enum _PDU_BRIDGE_CODE
{
    C_BRIDGE_OPEN = 1
}
PDU_BRIDGE_CODE;

#pragma pack(1)

typedef struct _REQ_BRIDGE_OPEN
{
    SOCK_ADDR                       addr;
}
REQ_BRIDGE_OPEN, *PREQ_BRIDGE_OPEN;

#pragma pack()

/*--------------------------------------------------------*/


/*--------------------------------------------------------*/

const WORD  SEED_TRACK_PORT       = 4620;
const WORD  SEED_MON_PORT         = 4622;
const WORD  STATIC_TRACK_PORT     = 4624;
#if 1//ndef NDEBUG
const WORD  LP2P_DOWNLOAD_PORT    = 4630;
#else
const WORD  LP2P_DOWNLOAD_PORT    = 0;
#endif

const DWORD  LP2P_EP_TIMER        = 5000;

const DWORD  LP2P_SESSION_TIMER   = 5000;
const UINT  LP2P_SESSION_RETRYNUM = 5;

const UINT  LP2P_MCAST_WAIT_CNT   = (90 * 1000 / LP2P_SESSION_TIMER);
const UINT  LP2P_MCAST_ALIVE_CNT  = 1;

const UINT  LP2P_MAX_PEER_NUM     = 500;

const UINT  SEED_TRACK_NETQSIZE   = 2;  // see misc_recvq.txt
const UINT  SEED_TRACK_REQBSIZE   = 100;
const UINT  SEED_TRACK_REPBSIZE   = MAX_PDU_SIZE;
const UINT  SEED_TRACK_EVTQSIZE   = 2;
const UINT  SEED_TRACK_EVTBSIZE   = MAX_PDU_SIZE;

const UINT  SEED_MON_NETQSIZE     = 200;
const UINT  SEED_MON_NETBSIZE     = 100;

const UINT  LP2P_UPDOWN_CTRLQSIZE = 2;  // see misc_recvq.txt
const UINT  LP2P_UPDOWN_CTRLBSIZE = 100;
const UINT  LP2P_UPDOWN_DATAQSIZE = 16;
const UINT  LP2P_UPDOWN_DATABSIZE = MAX_PDU_SIZE;

const UINT  LP2P_UPDOWN_EVTQSIZE  = 1;
const UINT  LP2P_UPDOWN_EVTBSIZE  = MSG_HEAD_RESERVE + 60;

const DWORD  LP2P_MCAST_ADDR      = 0xE6000010;  // 230.0.0.16
const WORD  LP2P_MCAST_PORT       = 4720;
const UINT  LP2P_MCAST_RANGE      = 200;

const UINT  LP2P_MCAST_SENDQSIZE  = 8;
const UINT  LP2P_MCAST_RECVQSIZE  = 256;
const UINT  LP2P_MCAST_DATABSIZE  = (1500 - 20 - 8);

const DWORD  LP2P_SOCKBUF_SIZE    = (1 * 1024 * 1024);
const DWORD  MCAST_R_SOCKBUF_SIZE = (64 * 1024 * 1024);

const UINT  INVALID_INDEX_VALUE   = -1;
const DWORD  INVALID_OFFSET_VALUE = -1;

const DWORD  INVALID_COOKIE       = -1;

const DWORD  INVALID_NODE_ID      = -1;
const DWORD  INVALID_N4S_ID       = -1;

const DWORD  INVALID_ST_SESS_ID   = -1;
const DWORD  INVALID_ST_BLK_ID    = -1;

const DWORD  INVALID_LP2P_ST_ID   = -1;

const UINT  MAX_NODE_NAME_LEN     = 16;
const UINT  MAX_SEED_NAME_LEN     = 60;

const DWORD  SEED_MAGIC_NUM       = 0x4445535F;  // '_SED'
const UINT  SHA1_VAL_LEN          = 20;


typedef enum _PDU_SEEDTRACK_CODE
{
    C_ST_REG_NODE = 1,
    C_ST_UNREG_NODE,
    C_ST_ADD_N4S,
    C_ST_REMOVE_N4S,
    C_ST_UPDATE_N4S_STATE,
    C_ST_ENUM_NODES4SEED
}
PDU_SEEDTRACK_CODE;

typedef enum _PDU_SEEDMON_CODE
{
    C_SM_ON_NODE_REG = 1,
    C_SM_ON_NODE_UNREG,
    C_SM_ON_SEED_ADD,
    C_SM_ON_SEED_REMOVE,
    C_SM_ON_N4S_ADD,
    C_SM_ON_N4S_REMOVE,
    C_SM_ON_N4S_STATE_UPDATE
}
PDU_SEEDMON_CODE;

typedef enum _PDU_SEEDTARGET_CODE
{
    C_SEEDTARGET_OPEN = 1,
    C_SEEDTARGET_GET_BITMASK,
    C_SEEDTARGET_READ_BLOCK,
    C_SEEDTARGET_BLOCK_END
}
PDU_SEEDTARGET_CODE;

#pragma pack(1)

typedef struct _SHA1_VAL
{
    BYTE                            bVal[SHA1_VAL_LEN];
}
SHA1_VAL, *PSHA1_VAL;

typedef struct _SEED_HDR
{
    DWORD                           dwMagic;                        // 4 bytes

    char                            szFileName[MAX_FILE_NAME_LEN];  // 60 bytes
    QWORD                           qwFileSize;                     // 8 bytes

    DWORD                           dwBlockSize;                    // 4 bytes

    SHA1_VAL                        SHA1ValSeed;                    // 20 bytes

    DWORD                           dwSHA1Num;                      // 4 bytes
    SHA1_VAL                        SHA1ValBlk[1];
}
SEED_HDR, *PSEED_HDR;

#pragma pack()

#pragma pack(4)

typedef struct _NODE_INFO
{
    char                            name[MAX_NODE_NAME_LEN];  // 16 bytes
    SOCK_ADDR                       addr;                     //  8 bytes
}
NODE_INFO, *PNODE_INFO;

typedef struct _SEED_INFO
{
    char                            name[MAX_SEED_NAME_LEN];  // 60 bytes
    SHA1_VAL                        sha1;                     // 20 bytes
}
SEED_INFO, *PSEED_INFO;

typedef struct _SEED_STATE
{
    QWORD                           qwProgressMask;           // 8 bytes
    BYTE                            bProgressDegree;          // (1+3) bytes
}
SEED_STATE, *PSEED_STATE;

#pragma pack()

#pragma pack(1)

typedef struct _NODE4SEED_INFO
{
    SOCK_ADDR                       NodeAddr;                 //  8 bytes
    QWORD                           qwProgressMask;           //  8 bytes
}
NODE4SEED_INFO, *PNODE4SEED_INFO;

typedef struct _RET_REG_NODE
{
    DWORD                           dwNodeId;
}
RET_REG_NODE, *PRET_REG_NODE;

typedef struct _RET_ADD_NODE4SEED
{
    DWORD                           dwN4SId;
}
RET_ADD_NODE4SEED, *PRET_ADD_NODE4SEED;

typedef struct _REQ_ENUM_NODE4SEED
{
    DWORD                           dwStartIdx;
}
REQ_ENUM_NODE4SEED, *PREQ_ENUM_NODE4SEED;

typedef struct _RET_ENUM_NODE4SEED
{
    DWORD                           dwNextIdx;

    DWORD                           dwCount;
    NODE4SEED_INFO                  N4SInfo[1];
}
RET_ENUM_NODE4SEED, *PRET_ENUM_NODE4SEED;

typedef struct _EVT_NODE4SEED_OP
{
    DWORD                           dwNodeIdx;
    DWORD                           dwSeedIdx;
}
EVT_NODE4SEED_OP, *PEVT_NODE4SEED_OP;

typedef struct _EVT_NODE4SEED_STATE_UP
{
    DWORD                           dwNodeIdx;
    DWORD                           dwSeedIdx;
    SEED_STATE                      SeedState;
}
EVT_NODE4SEED_STATE_UP, *PEVT_NODE4SEED_STATE_UP;

typedef struct _REQ_OPEN_SEEDTARGET
{
    SHA1_VAL                        SHA1ValSeed;
}
REQ_OPEN_SEEDTARGET, *PREQ_OPEN_SEEDTARGET;

typedef struct _RET_GET_SEEDTARGET_BITMASK
{
    DWORD                           dwBitsCnt;
}
RET_GET_SEEDTARGET_BITMASK, *PRET_GET_SEEDTARGET_BITMASK;

typedef struct _UDPCAST_BLK_HDR
{
    DWORD                           dwBlkIdx;
    DWORD                           dwOffset;
}
UDPCAST_BLK_HDR, *PUDPCAST_BLK_HDR;

#pragma pack()

typedef enum _LP2P_EPMSG_CODE
{
    C_LP2P_NODE_REG = C_LP2PMSG_BASE,
    C_LP2P_SEED_ADD,
    C_LP2P_SEED_STATE_UPDATE,
    C_LP2P_N4S_ENUM,

    C_LP2P_SEEDTARGET_OPEN,

    C_LP2P_ERROR_DISK_FULL
}
LP2P_EPMSG_CODE;

typedef struct _EVT_NODE4SEED_ENUM
{
    SOCK_ADDR                       LocalAddr;
    UINT                            nCount;
    NODE4SEED_INFO                  N4SInfo[1];
}
EVT_NODE4SEED_ENUM, *PEVT_NODE4SEED_ENUM;

typedef struct _EVT_SEEDTARGET_OPEN
{
    SHA1_VAL                        SHA1ValSeed;
}
EVT_SEEDTARGET_OPEN, *PEVT_SEEDTARGET_OPEN;

/*--------------------------------------------------------*/


#endif
