/******************************************************************************
Copyright 2016 - 2019 Intel Corporation
 
For licensing information, see the file 'LICENSE' in the root folder of
  this software module. 
******************************************************************************/

#ifndef _LP2P_MCAST_ENDPOINT_H
#define _LP2P_MCAST_ENDPOINT_H


#include "Endpoint.h"

class SeedTarget;
class SeedAgentHandler;


class LP2PMCastEpObserver
{
public:
    virtual void OnFinished() = 0;
};


class LP2PMCastEndpoint : protected Endpoint
{
public:
    static LP2PMCastEndpoint *Instance();
    static void Destroy();

private:
    static LP2PMCastEndpoint  * _instance;

protected:
    LP2PMCastEndpoint();
    virtual ~LP2PMCastEndpoint();

public:
    DWORD Load(const char *szTrackerIP, const char* szNodeName, const char *szIntfIP, SeedTarget *pSeedTarget, LP2PMCastEpObserver *pObserver);
    void Unload();

    DWORD Start();

protected:
    virtual void OnListenerEnded(DWORD hListener);

    virtual EpProtocolHandler *OnNewHandler(DWORD hListener, Connection *pConnection, DWORD dwConnId);
    virtual void OnAsyncConnected(DWORD dwConnId, EpProtocolHandler *pHandler);
    virtual void OnDisconnected(DWORD dwConnId, EpProtocolHandler *pHandler);
    virtual void OnConnEvent(DWORD dwConnId, EpProtocolHandler *pHandler, PEP_MSG_HDR pEvtHdr, BufferItem *pEvtBody);

    virtual void ProcessEpWork(UINT nSigIdx);

private:
    LP2PMCastEpObserver       * _pObserver;

    SeedTarget                * _pSeedTarget;

    DWORD                       _dwMCastConnId;

    DWORD                       _dwSAHConnId;
    DWORD                       _dwSASTId;
};


#endif
