/******************************************************************************
Copyright 2016 - 2019 Intel Corporation
 
For licensing information, see the file 'LICENSE' in the root folder of
  this software module. 
******************************************************************************/

#ifndef _LP2P_MCAST_RECVER_H
#define _LP2P_MCAST_RECVER_H


#include "EpProtocolHandler.h"
#include "SeedTarget.h"


class LP2PMCastRecver : public EpProtocolHandler
{
public:
    LP2PMCastRecver(SeedTarget *pSeedTarget);
    virtual ~LP2PMCastRecver();

    virtual DWORD Bind(Connection *pConnection, PCondEvent *pEvent, UINT nSigIdx);
    virtual void Unbind();

    virtual void ProcessCmd(DWORD dwCmdMask);

    virtual void PrepareSend();

protected:
    virtual bool ProcessRecvData(BufferItem *pbiData);

    DWORD OpenNextBlock(UINT nBlkIdx);
    void CloseCurBlock();

private:
    SeedTarget                * _pSeedTarget;

    DWORD                       _dwSessionId;
    DWORD                       _dwBlkId;

    UINT                        _nBlkIdx;
    DWORD                       _dwBlkOff;

    volatile bool               _bStarted;
    volatile UINT               _nKickCnt;
};


#endif
