/******************************************************************************
Copyright 2016 - 2019 Intel Corporation
 
For licensing information, see the file 'LICENSE' in the root folder of
  this software module. 
******************************************************************************/

#ifndef _LP2P_MCAST_SENDER_H
#define _LP2P_MCAST_SENDER_H


#include "EpProtocolHandler.h"
#include "SeedTarget.h"


class LP2PMCastSender : public EpProtocolHandler
{
public:
    LP2PMCastSender(SeedTarget *pSeedTarget);
    virtual ~LP2PMCastSender();

    virtual DWORD Bind(Connection *pConnection, PCondEvent *pEvent, UINT nSigIdx);
    virtual void Unbind();

    virtual void ProcessCmd(DWORD dwCmdMask);

    virtual void PrepareSend();

protected:
    virtual bool ProcessRecvData(BufferItem *pbiData);

private:
    bool OpenBlock();

    void SendDone(BufferItem *pbi);
    void SendData(BufferItem *pbi);

private:
    SeedTarget                * _pSeedTarget;

    DWORD                       _dwSessionId;
    DWORD                       _dwBlkId;

    UINT                        _nBlkIdx;
    DWORD                       _dwBlkOff;
};


#endif
