/******************************************************************************
Copyright 2016 - 2019 Intel Corporation
 
For licensing information, see the file 'LICENSE' in the root folder of
  this software module. 
******************************************************************************/

#ifndef _LP2P_UPLOAD_HANDLER_H
#define _LP2P_UPLOAD_HANDLER_H


#include "EpPDUHandler.h"
#include "DeflateCodec.h"
#include "SeedTarget.h"


class LP2PUploadHandler : public EpPDUHandler
{
public:
    LP2PUploadHandler();
    virtual ~LP2PUploadHandler();

    virtual DWORD Bind(Connection *pConnection, PCondEvent *pEvent, UINT nSigIdx);
    virtual void Unbind();

    virtual void PrepareSend();

    DWORD GetCookie() const;
    void Attach(DWORD dwResult, SeedTarget *pSeedTarget, DWORD dwCookie);

protected:
    virtual void ProcessRecvPDU(BYTE bCode, bool bReq, DWORD dwParam, BufferItem *pbiBody);
    virtual void ProcessRecvPDU(BYTE bCode, bool bReq, DWORD dwParam, const PBYTE pData, UINT nDataBytes, UINT nLeftBytes);

private:
    void OnOpenSeedTarget(const PREQ_OPEN_SEEDTARGET pReqOpenST);
    void OnGetSeedTargetBitmask();
    void OnReadSeedTargetBlock(DWORD dwBlkIdx);

#ifdef CONFIG_ST_BLK_COMPACT
    DWORD DeflateBlock(BufferItem *pbi, bool &rbLast);
    DWORD DeflateCluster();
#endif

private:
    SeedTarget                * _pSeedTarget;
    const BitArray            * _pBitMask;
    DWORD                       _dwCookie;

    DWORD                       _dwSessionId;
    DWORD                       _dwBlkId;

#ifdef CONFIG_ST_BLK_COMPACT
    DeflateAlg                  _CompAlg;
    BufferItem                  _CompBuf;
    BufferItem                  _ReadBuf;
    bool                        _bEndOfBlk;
#endif
};


#endif
