/******************************************************************************
Copyright 2016 - 2019 Intel Corporation
 
For licensing information, see the file 'LICENSE' in the root folder of
  this software module. 
******************************************************************************/

#ifndef _PCOND_EVENT_H
#define _PCOND_EVENT_H


#include "RingBuffer.h"


typedef enum _PCOND_SIG_STATE
{
    SIG_STATE_NONE,
    SIG_STATE_DONE = SIG_STATE_NONE,
    SIG_STATE_SUBMITED,
    SIG_STATE_PROCESSING
}
PCOND_SIG_STATE;

typedef struct _PCOND_SIGMAP_ITEM
{
	volatile PCOND_SIG_STATE    state;
	volatile bool               bSignaled;
	volatile UINT               nSlotIdx;
}
PCOND_SIGMAP_ITEM, *PPCOND_SIGMAP_ITEM;


class PCondEvent
{
public:
    PCondEvent(UINT nSigNum);
    ~PCondEvent();

    void Signal(UINT nSigIdx);
    UINT Wait(UINT nSlotIdx, bool bNonBlock = false);
    bool Finish(UINT nSigIdx, UINT nSlotIdx);
    void Reset(UINT nSigIdx, UINT nSlotIdx);

    void Release();

private:
    pthread_mutex_t             _hLock;
    pthread_cond_t              _hCond;

    volatile bool               _bQuit;

    vector<PCOND_SIGMAP_ITEM>   _SigSlotMap;
    RingBuffer<UINT>            _SigPipe;
};


#endif
