/******************************************************************************
Copyright 2016 - 2019 Intel Corporation
 
For licensing information, see the file 'LICENSE' in the root folder of
  this software module. 
******************************************************************************/

#ifndef _PROXY_FILTER_AGENT_H
#define _PROXY_FILTER_AGENT_H


#include "FilterProtocol.h"


class ProxyFilterAgent : public FilterProtocol
{
public:
    ProxyFilterAgent(Connection *pConnection, const PSOCK_ADDR pRemoteAddr);
    virtual ~ProxyFilterAgent();

    virtual DWORD Attach(ProtocolHandler *pHandler, UINT nRecvBufCnt, UINT nSendItemCnt);

    virtual void ResumeRecv(UINT nBufCnt);
    virtual void ResumeSend(UINT nItemCnt);

    virtual UINT OnRecvReady(Connection *pConnection);
    virtual UINT OnSendReady(Connection *pConnection);

private:
    UINT SendOpenBridgeReq();
    UINT OnOpenBridgeRep();
    void EnterBridgeMode();

private:
    SOCK_ADDR                   _RemoteAddr;

    pthread_mutex_t             _hStateLock;
    BRIDGE_STATE                _CurState;
    UINT                        _nRecvBufCnt;
    UINT                        _nSendItemCnt;

    BufferItem                  _biSendBuf;
    BufferItem                  _biRecvBuf;
};


#endif
