/******************************************************************************
Copyright 2016 - 2019 Intel Corporation
 
For licensing information, see the file 'LICENSE' in the root folder of
  this software module. 
******************************************************************************/

#ifndef _SHA1_HASH_H
#define _SHA1_HASH_H


#if defined(_WINCE_) || defined(_WIN32_)
#include "Wincrypt.h"
#endif
#if defined(_ANDROID_) || defined(_LINUX_)
#include <openssl/sha.h>
#endif


class SHA1Hash
{
public:
    static DWORD Startup();
    static void Cleanup();

private:
#if defined(_WINCE_) || defined(_WIN32_)
    static HCRYPTPROV           _hProv;
#endif

public:
    SHA1Hash();
    ~SHA1Hash();

    DWORD BeginHash();
    DWORD DoHash(PBYTE pData, UINT nSize);
    DWORD GetHashVal(PSHA1_VAL pValSHA1);
    void EndHash();

private:
#if defined(_WINCE_) || defined(_WIN32_)
    HCRYPTHASH                  _hHash;
#endif
#if defined(_ANDROID_) || defined(_LINUX_)
    SHA_CTX                     _hHash;
#endif
};


#endif
