/******************************************************************************
Copyright 2016 - 2019 Intel Corporation
 
For licensing information, see the file 'LICENSE' in the root folder of
  this software module. 
******************************************************************************/

#ifndef _SECURE_CENTER_H
#define _SECURE_CENTER_H


#include <openssl/ssl.h>


class SecureCenter
{
public:
    static SecureCenter *Instance();
    static void Destroy();

private:
    static SecureCenter       * _instance;

protected:
    SecureCenter();
    ~SecureCenter();

public:
    DWORD Load(const char *szCAPath, const char *szCertPath, const char *szKeyPath);
    void Unload();

    DWORD InstallRootCert(SSL_CTX *ctx);
    DWORD InstallCertAndKey(SSL_CTX *ctx);

private:
    string                      _CAPath;
    string                      _CertPath;
    string                      _KeyPath;
};


#endif
