/******************************************************************************
Copyright 2016 - 2019 Intel Corporation
 
For licensing information, see the file 'LICENSE' in the root folder of
  this software module. 
******************************************************************************/

#ifndef _SEED_MON_CLIENT_H
#define _SEED_MON_CLIENT_H


#include "Endpoint.h"
#include "SeedTrackObserver.h"


class SeedMonClient : protected Endpoint
{
public:
    static SeedMonClient *Instance();
    static void Destroy();

private:
    static SeedMonClient      * _instance;

protected:
    SeedMonClient();
    virtual ~SeedMonClient();

public:
    DWORD Load(const char *szIP, SeedTrackObserver *pObserver);
    virtual void Unload();

protected:
    virtual void OnListenerEnded(DWORD hListener);

    virtual EpProtocolHandler *OnNewHandler(DWORD hListener, Connection *pConnection, DWORD dwConnId);
    virtual void OnAsyncConnected(DWORD dwConnId, EpProtocolHandler *pHandler);
    virtual void OnDisconnected(DWORD dwConnId, EpProtocolHandler *pHandler);
    virtual void OnConnEvent(DWORD dwConnId, EpProtocolHandler *pHandler, PEP_MSG_HDR pEvtHdr, BufferItem *pEvtBody);

    virtual void ProcessEpWork(UINT nSigIdx);

private:
    DWORD DoConnect(EpProtocolHandler *pHandler);

private:
    volatile bool               _bQuit;
    SOCK_ADDR                   _TrackerAddr;
};


#endif
