/******************************************************************************
Copyright 2016 - 2019 Intel Corporation
 
For licensing information, see the file 'LICENSE' in the root folder of
  this software module. 
******************************************************************************/

#ifndef _SEED_MON_SVR_HANDLER_H
#define _SEED_MON_SVR_HANDLER_H


#include "EpPDUHandler.h"
#include "SeedCenter.h"


class SeedMonSvrHandler : public EpPDUHandler, public SeedTrackObserver
{
public:
    SeedMonSvrHandler(UINT nSendQSize = SEED_MON_NETQSIZE);
    virtual ~SeedMonSvrHandler();

    virtual DWORD Bind(Connection *pConnection, PCondEvent *pEvent, UINT nSigIdx);
    virtual void Unbind();

    virtual void PrepareSend();

    virtual void OnNodeRegistered(UINT nNodeIdx, const PNODE_INFO pNodeInfo);
    virtual void OnNodeUnregistered(UINT nNodeIdx);
    virtual void OnSeedAdded(UINT nSeedIdx, const PSEED_INFO pSeedInfo);
    virtual void OnSeedRemoved(UINT nSeedIdx);
    virtual void OnNode4SeedAdded(UINT nNodeIdx, UINT nSeedIdx);
    virtual void OnNode4SeedRemoved(UINT nNodeIdx, UINT nSeedIdx);
    virtual void OnNode4SeedStateUpdated(UINT nNodeIdx, UINT nSeedIdx, const PSEED_STATE pSeedState);

private:
    BufferItem *AllocSendBuf(bool bRetry);

protected:
    virtual void ProcessRecvPDU(BYTE bCode, bool bReq, DWORD dwParam, BufferItem *pbiBody);
    virtual void ProcessRecvPDU(BYTE bCode, bool bReq, DWORD dwParam, const PBYTE pData, UINT nDataBytes, UINT nLeftBytes);
};


#endif
