/******************************************************************************
Copyright 2016 - 2019 Intel Corporation
 
For licensing information, see the file 'LICENSE' in the root folder of
  this software module. 
******************************************************************************/

#ifndef _SEED_TRACK_OBSERVER_H
#define _SEED_TRACK_OBSERVER_H


class SeedTrackObserver
{
    // serialization and synchronization, but should return in a short and foreseeable time
public:
    virtual void OnNodeRegistered(UINT nNodeIdx, const PNODE_INFO pNodeInfo) = 0;
    virtual void OnNodeUnregistered(UINT nNodeIdx) = 0;

    virtual void OnSeedAdded(UINT nSeedIdx, const PSEED_INFO pSeedInfo) = 0;
    virtual void OnSeedRemoved(UINT nSeedIdx) = 0;

    virtual void OnNode4SeedAdded(UINT nNodeIdx, UINT nSeedIdx) = 0;
    virtual void OnNode4SeedRemoved(UINT nNodeIdx, UINT nSeedIdx) = 0;
    virtual void OnNode4SeedStateUpdated(UINT nNodeIdx, UINT nSeedIdx, const PSEED_STATE pSeedState) = 0;
};


#endif
