/******************************************************************************
Copyright 2016 - 2019 Intel Corporation
 
For licensing information, see the file 'LICENSE' in the root folder of
  this software module. 
******************************************************************************/

#ifndef _SEED_TRACKER_HANDLER_H
#define _SEED_TRACKER_HANDLER_H


#include "EpPDUHandler.h"


class SeedTrackerHandler : public EpPDUHandler
{
public:
    SeedTrackerHandler();
    virtual ~SeedTrackerHandler();

    virtual void Unbind();

    virtual void PrepareSend();

protected:
    virtual void ProcessRecvPDU(BYTE bCode, bool bReq, DWORD dwParam, BufferItem *pbiBody);
    virtual void ProcessRecvPDU(BYTE bCode, bool bReq, DWORD dwParam, const PBYTE pData, UINT nDataBytes, UINT nLeftBytes);

private:
    DWORD OnRegisterNode(const PNODE_INFO pNodeInfo, BufferItem *pbiSend);
    DWORD OnUnregisterNode(DWORD dwNodeId, BufferItem *pbiSend);
    DWORD OnAddNode4Seed(DWORD dwNodeId, const PSEED_INFO pSeedInfo, BufferItem *pbiSend);
    DWORD OnRemoveNode4Seed(DWORD dwN4SId, BufferItem *pbiSend);
    DWORD OnUpdateNode4SeedState(DWORD dwN4SId, const PSEED_STATE pSeedState, BufferItem *pbiSend);
    DWORD OnEnumNodes4Seed(DWORD dwN4SId, const PREQ_ENUM_NODE4SEED pReqEnumN4S, BufferItem *pbiSend);

private:
    DWORD                       _dwNodeId;
};


#endif
