/******************************************************************************
Copyright 2016 - 2019 Intel Corporation
 
For licensing information, see the file 'LICENSE' in the root folder of
  this software module. 
******************************************************************************/

#ifndef _TRACKER_SERVER_H
#define _TRACKER_SERVER_H


#include "Endpoint.h"


class TrackerServer : protected Endpoint
{
public:
    static TrackerServer *Instance();
    static void Destroy();

private:
    static TrackerServer      * _instance;

protected:
    TrackerServer();
    virtual ~TrackerServer();

public:
    DWORD Load(UINT nMaxNodeNum);
    virtual void Unload();

protected:
    virtual void OnListenerEnded(DWORD hListener);

    virtual EpProtocolHandler *OnNewHandler(DWORD hListener, Connection *pConnection, DWORD dwConnId);
    virtual void OnAsyncConnected(DWORD dwConnId, EpProtocolHandler *pHandler);
    virtual void OnDisconnected(DWORD dwConnId, EpProtocolHandler *pHandler);
    virtual void OnConnEvent(DWORD dwConnId, EpProtocolHandler *pHandler, PEP_MSG_HDR pEvtHdr, BufferItem *pEvtBody);

    virtual void ProcessEpWork(UINT nSigIdx);

private:
    DWORD                       _hSTListener;
    DWORD                       _hSMListener;
};


#endif
