/******************************************************************************
Copyright 2016 - 2019 Intel Corporation
 
For licensing information, see the file 'LICENSE' in the root folder of
  this software module. 
******************************************************************************/

#ifndef _VECTOR_MATE_H
#define _VECTOR_MATE_H


#include "RingBuffer.h"


class VectorMate
{
public:
    VectorMate(bool bEnableLock);
    ~VectorMate();

    DWORD Init(UINT nSize, UINT nBase = 0);
    void Fini();

    bool IsEmpty() const;
    bool IsFull() const;

    DWORD GetFreeIndex(UINT &nIndex);
    void PutFreeIndex(UINT nIndex);

private:
    bool                        _bEnableLock;
    pthread_mutex_t             _hLock;
    RingBuffer<UINT>          * _pFreeList;
};


#endif
