/******************************************************************************
Copyright 2016 - 2019 Intel Corporation
 
For licensing information, see the file 'LICENSE' in the root folder of
  this software module. 
******************************************************************************/

#ifndef _LINUX_DEP_H
#define _LINUX_DEP_H


typedef  unsigned int               UINT, *PUINT;
typedef  uint8_t                    BYTE, *PBYTE;
typedef  uint16_t                   WORD, *PWORD;
typedef  uint32_t                   DWORD, *PDWORD;
typedef  uint64_t                   QWORD, *PQWORD;

typedef  long                       LONG;
typedef  long long                  LONGLONG;

typedef  int                        BOOL;
#define  FALSE                      0
#define  TRUE                       1

typedef  char                      *LPSTR, *PSTR;
typedef  const char                *LPCSTR, *PCSTR;

typedef  void                      *HANDLE;
#define  INVALID_HANDLE_VALUE       (void*)(-1)

typedef  int                        SOCKET;


#define  MAX_PATH                   500

#define  INVALID_FD                 int(-1)

#define  INVALID_SOCKET             (SOCKET)(-1)
#define  SOCKET_ERROR               (-1)

#define  WSAEWOULDBLOCK             EINPROGRESS

#define  ERROR_SUCCESS              0L
#define  ERROR_ACCESS_DENIED        EACCES
#define  ERROR_NOT_ENOUGH_MEMORY    ENOBUFS
#define  ERROR_INVALID_DATA         EINVAL
#define  ERROR_OUTOFMEMORY          ENOMEM
#define  ERROR_NOT_READY            EPERM
#define  ERROR_NOT_SUPPORTED        EPROTONOSUPPORT
#define  ERROR_INVALID_PARAMETER    EINVAL
#define  ERROR_DISK_FULL            ENOSPC
#define  ERROR_BUSY                 EBUSY
#define  ERROR_ALREADY_EXISTS       EEXIST
#define  ERROR_NOT_FOUND            ENOENT
#define  ERROR_CANCELLED            ECANCELED
#define  ERROR_CONNECTION_ABORTED   ECONNABORTED
#define  ERROR_TIMEOUT              ETIME
#define  ERROR_NOT_CONNECTED        ENOTCONN
#define  ERROR_INVALID_STATE        EINVAL

#define  MemoryBarrier()            asm volatile("mfence" ::: "memory")

#define  INFINITE                   0xFFFFFFFF

#define  WAIT_TIMEOUT               258L
#define  WAIT_FAILED                0xffffffffL

#define  FULL_FUNC_NAME             __PRETTY_FUNCTION__

#define  GetLastError()             errno
#define  WSAGetLastError()          errno

#define  _countof(_Array)           (sizeof(_Array)/sizeof(_Array[0]))

#define  _atoi64(s)                 atoll(s)

#define  Sleep(ms)                  usleep(ms*1000)
#define  SleepForSeconds(sec)       sleep(sec)

#define  _snprintf                  snprintf
#define  _snwprintf                 swprintf

#define  closesocket(s)             close(s)
#define  _access(f, m)              access(f, m)

#define  _fileno(h)                 fileno(h)

#define  InterlockedIncrement(x)    __sync_add_and_fetch(x, 1)
#define  InterlockedDecrement(x)    __sync_sub_and_fetch(x, 1);

#define  InterlockedIncrement64(x)  __sync_add_and_fetch(x, 1)
#define  InterlockedDecrement64(x)  __sync_sub_and_fetch(x, 1);

#define  MAKEWORD(a, b)             ((WORD)(((BYTE)(((WORD)(a)) & 0xff)) | ((WORD)((BYTE)(((WORD)(b)) & 0xff))) << 8))
#define  MAKELONG(a, b)             ((DWORD)(((WORD)(((DWORD)(a)) & 0xffff)) | ((DWORD)((WORD)(((DWORD)(b)) & 0xffff))) << 16))
#define  LODWORD(q)                 ((DWORD)(((QWORD)(q)) & 0xffffffff))
#define  HIDWORD(q)                 ((DWORD)((((QWORD)(q)) >> 32) & 0xffffffff))
#define  LOWORD(l)                  ((WORD)(((DWORD)(l)) & 0xffff))
#define  HIWORD(l)                  ((WORD)((((DWORD)(l)) >> 16) & 0xffff))
#define  LOBYTE(w)                  ((BYTE)(((WORD)(w)) & 0xff))
#define  HIBYTE(w)                  ((BYTE)((((WORD)(w)) >> 8) & 0xff))


DWORD GetTickCount();


#endif
