/******************************************************************************
Copyright 2016 - 2019 Intel Corporation
 
For licensing information, see the file 'LICENSE' in the root folder of
  this software module. 
******************************************************************************/

#ifndef _WIN32_DEP_H
#define _WIN32_DEP_H


typedef  unsigned long long         QWORD, *PQWORD;

typedef  __int64                    off64_t;
typedef  SSIZE_T                    ssize_t;

typedef  int                        socklen_t;
#define  MSG_NOSIGNAL               0

#ifndef EWOULDBLOCK
#define  EWOULDBLOCK                WSAEWOULDBLOCK
#endif

#define  SO_RCVBUFFORCE             SO_RCVBUF
#define  SO_SNDBUFFORCE             SO_SNDBUF

#ifndef _STR2WSTR
#define  _STR2WSTR_(str)            L##str
#define  _STR2WSTR(str)             _STR2WSTR_(str)
#endif

#define  STDOUT_FILENO              1

#define  SleepForSeconds(sec)       Sleep(sec*1000)

#define  lseek(fd, off, org)        _lseeki64(fd, off, org)

#define  fseeko(h, off, org)        _fseeki64(h, off, org)
#define  ftello(h)                  _ftelli64(h)

#define  S_ISREG(m)                 ((m & S_IFMT) == S_IFREG)

#define  FULL_FUNC_NAME             _STR2WSTR(__FUNCTION__)

#ifndef LODWORD
#define  LODWORD(q)                 ((DWORD)(((QWORD)(q)) & 0xffffffff))
#define  HIDWORD(q)                 ((DWORD)((((QWORD)(q)) >> 32) & 0xffffffff))
#endif

#define  CLOCK_REALTIME             0
#define  CLOCK_MONOTONIC            0
int clock_gettime(int, struct timespec *tp);


#endif

