/******************************************************************************
Copyright 2016 - 2019 Intel Corporation
 
For licensing information, see the file 'LICENSE' in the root folder of
  this software module. 
******************************************************************************/

#include <StdAfx.h>
#include "ListenerHandler.h"


ListenerHandler::ListenerHandler(bool bOneShot)
    : EpProtocolHandler(1, 0, 0, 0, 0, 0)
    , _bOneShot(bOneShot)
    , _bNewConnection(false)
{
    DBG(D_VERB, (L"%s\n", FULL_FUNC_NAME));
}

ListenerHandler::~ListenerHandler()
{
    DBG(D_VERB, (L"%s\n", FULL_FUNC_NAME));
}

UINT ListenerHandler::OnRecvReady(Connection *pConnection)
{
    DBG(D_INFO, (L"%s: new connection in\n", FULL_FUNC_NAME));

    assert(!_bNewConnection);
    _bNewConnection = true;

    SignalEp();

    // will ignore the RecvInd
    return 1;
}

void ListenerHandler::ProcessCmd(DWORD dwCmdMask)
{
    DBG(D_INFO, (L"%s: %d\n", FULL_FUNC_NAME, _bOneShot));

    if ( dwCmdMask & C_CONN_RESUME_LISTEN )
    {
        if ( _bOneShot )
        {
            ReqEndSession();
        }
        else
        {
            assert(_pConnection);
            _pConnection->ResumeRecv(1);
        }
    }

    EpProtocolHandler::ProcessCmd(dwCmdMask);
}

DWORD ListenerHandler::GetFlags()
{
    DWORD  dwFlags;

    DBG(D_FUNC, (L"%s\n", FULL_FUNC_NAME));

    dwFlags = EpProtocolHandler::GetFlags();

    if ( _bNewConnection )
    {
        _bNewConnection = false;
        dwFlags |= F_EPH_NEWCONNECTION;
    }

    return dwFlags;
}

void ListenerHandler::PrepareSend()
{
    DBG(D_FUNC, (L"%s\n", FULL_FUNC_NAME));

    assert(0);
}

bool ListenerHandler::ProcessRecvData(BufferItem *pbiData)
{
    DBG(D_FUNC, (L"%s\n", FULL_FUNC_NAME));

    assert(0);

    return true;
}
