/******************************************************************************
Copyright 2016 - 2019 Intel Corporation
 
For licensing information, see the file 'LICENSE' in the root folder of
  this software module. 
******************************************************************************/

#include <StdAfx.h>
#include "MCastConnection.h"


MCastConnection::MCastConnection(SOCKET s, const PSOCK_ADDR pAddr)
    : SocketConnection(s, false, false)
{
    DBG(D_VERB, (L"%s\n", FULL_FUNC_NAME));

    _addr.sin_family = AF_INET;
    _addr.sin_addr.s_addr = pAddr->IPv4Addr.dwIP;
    _addr.sin_port = pAddr->IPv4Addr.wPort;
}

MCastConnection::~MCastConnection()
{
    DBG(D_VERB, (L"%s\n", FULL_FUNC_NAME));
}

DWORD MCastConnection::Send(BufferItem *pBufItem)
{
    DWORD  dwRet;
    int  len;

    DBG(D_FUNC, (L"%s: %d @ %p\n", FULL_FUNC_NAME, pBufItem->data_size(), pBufItem->data()));

    len = sendto(_s, (char*)pBufItem->data(), pBufItem->data_size(), 0, (struct sockaddr*)&_addr, sizeof(_addr));
    if ( len == SOCKET_ERROR )
    {
        dwRet = WSAGetLastError();
        DBG(D_VERB, (L"%s: sendto failed: %d\n", FULL_FUNC_NAME, dwRet));
        return dwRet;
    }

    pBufItem->Pull(len);
    assert(!pBufItem->data_size());

    return ERROR_SUCCESS;
}

