/******************************************************************************
Copyright 2016 - 2019 Intel Corporation
 
For licensing information, see the file 'LICENSE' in the root folder of
  this software module. 
******************************************************************************/

#ifndef _MUDF_COMM_DEF_H
#define _MUDF_COMM_DEF_H


#define  CONFIG_MUT_BLK_COMPACT     1


const WORD  MUDFPS_UPLOAD_PORT    = 4820;
const WORD  MUDFOS_UPLOAD_PORT    = 4822;
const WORD  MUDFPS_DOWNLOAD_PORT  = 4824;
const WORD  MUDFOS_DOWNLOAD_PORT  = 4826;

const DWORD  INVALID_MDFIDX_VAL   = 0xFFFFFFFF;
const DWORD  INVALID_UDFOFF_VAL   = 0xFFFFFFFF;
const UINT  MUDF_BLOCK_SIZE       = (2*1024*1024);

const DWORD  INVALID_MUT_BLK_ID   = -1;

const UINT  MAX_MUDF_PATH_LEN     = 256;

const UINT  MUDF_UPDOWN_CTRLQSIZE = 2;
const UINT  MUDF_UPDOWN_CTRLBSIZE = 64;
const UINT  MUDF_UPDOWN_DATAQSIZE = 16;
const UINT  MUDF_UPDOWN_DATABSIZE = MAX_PDU_SIZE;

const UINT  MUDF_UPDOWN_EVTQSIZE  = 1;
const UINT  MUDF_UPDOWN_EVTBSIZE  = MSG_HEAD_RESERVE + 60;

const DWORD  INVALID_MUEP_RETVAL  = 0xE1F2C3D4;


typedef enum _PDU_MUDFTARGET_CODE
{
    C_MUDFTARGET_UPLOAD_UPDATE = 1,
    C_MUDFTARGET_UPLOAD_OVERWRITE,
    C_MUDFTARGET_DOWNLOAD,

    C_MUDFTARGET_BLOCK_START,
    C_MUDFTARGET_BLOCK_DATA,
    C_MUDFTARGET_BLOCK_END,

    C_MUDFTARGET_FILE_END
}
PDU_MUDFTARGET_CODE;

typedef enum _MUDF_EPMSG_CODE
{
    C_MUDF_TRANS_END          = C_EPMSG_END + 1
}
MUDF_EPMSG_CODE;

typedef enum _MUDF_UPAGENT_STATE
{
    S_MUDF_UPAGENT_IDLE       = 1,
    S_MUDF_UPAGENT_START,
    S_MUDF_UPAGENT_TRANS,
    S_MUDF_UPAGENT_WAITACK
}
MUDF_UPAGENT_STATE;

#pragma pack(1)

typedef struct _REQ_UPLOAD_MUDFTARGET
{
    DWORD                           dwMdfSize;
    BYTE                            bBlkEndAck;
    char                            szMdfPath[MAX_MUDF_PATH_LEN];
    char                            szUdfPath[MAX_MUDF_PATH_LEN];
}
REQ_UPLOAD_MUDFTARGET, *PREQ_UPLOAD_MUDFTARGET;

typedef struct _REQ_DOWNLOAD_MUDFTARGET
{
    char                            szMdfPath[MAX_MUDF_PATH_LEN];
    char                            szUdfPath[MAX_MUDF_PATH_LEN];
}
REQ_DOWNLOAD_MUDFTARGET, *PREQ_DOWNLOAD_MUDFTARGET;

typedef struct _REP_DOWNLOAD_MUDFTARGET
{
    DWORD                           dwMdfSize;
}
REP_DOWNLOAD_MUDFTARGET, *PREP_DOWNLOAD_MUDFTARGET;

typedef struct _MUDFTARGET_BLOCK_INFO
{
    DWORD                           dwMdfIdx;
    DWORD                           dwUdfOff;
}
MUDFTARGET_BLOCK_INFO, *PMUDFTARGET_BLOCK_INFO;

#pragma pack()


#endif
