/******************************************************************************
Copyright 2016 - 2019 Intel Corporation
 
For licensing information, see the file 'LICENSE' in the root folder of
  this software module. 
******************************************************************************/

#ifndef _MUDF_DOWNLOAD_AGENT_H
#define _MUDF_DOWNLOAD_AGENT_H


#include "EpPDUHandler.h"
#include "DeflateCodec.h"
#include "MUdfTarget.h"


class MUdfDownloadAgent : public EpPDUHandler
{
public:
    MUdfDownloadAgent(MUdfTarget *pMUdfTarget, const char *szLocalMdf, const char *szLocalUdf, const char *szRemoteMdf, const char *szRemoteUdf);
    virtual ~MUdfDownloadAgent();

    virtual DWORD Bind(Connection *pConnection, PCondEvent *pEvent, UINT nSigIdx);
    virtual void Unbind();

    virtual void OnAsyncConnected(Connection *pConnection);

    virtual void PrepareSend();

protected:
    virtual void ProcessRecvPDU(BYTE bCode, bool bReq, DWORD dwParam, BufferItem *pbiBody);
    virtual void ProcessRecvPDU(BYTE bCode, bool bReq, DWORD dwParam, const PBYTE pData, UINT nDataBytes, UINT nLeftBytes);

private:
    DWORD DownloadStartReq();

    DWORD OnInitMUdfTarget(const PREP_DOWNLOAD_MUDFTARGET pRepOpenMUT);
    DWORD OnFiniMUdfTarget();
    DWORD OnOpenMUdfBlock(const PMUDFTARGET_BLOCK_INFO pMUTBlkInfo);

    void OnDownloadFinished(DWORD dwErrCode);

#ifdef CONFIG_MUT_BLK_COMPACT
    DWORD InflateBlock(const PBYTE pData, UINT nDataBytes, bool bLast, bool &rbEndOfBlk);
#endif

private:
    MUdfTarget                * _pMUdfTarget;
    string                      _strLocalMdf;
    string                      _strLocalUdf;
    string                      _strRemoteMdf;
    string                      _strRemoteUdf;

    UINT                        _nBlkIdx;
    DWORD                       _dwBlkId;

#ifdef CONFIG_MUT_BLK_COMPACT
    InflateAlg                  _DecompAlg;
    BufferItem                  _DecompBuf;
#endif
};


#endif
