/******************************************************************************
Copyright 2016 - 2019 Intel Corporation
 
For licensing information, see the file 'LICENSE' in the root folder of
  this software module. 
******************************************************************************/

#ifndef _MUDF_DOWNLOAD_AGENT_H
#define _MUDF_DOWNLOAD_AGENT_H


#include "EpPDUHandler.h"
#include "DeflateCodec.h"
#include "MUdfTarget.h"


class MUdfDownloadHandler : public EpPDUHandler
{
public:
    MUdfDownloadHandler(const char *szRootDir);
    virtual ~MUdfDownloadHandler();

    virtual DWORD Bind(Connection *pConnection, PCondEvent *pEvent, UINT nSigIdx);
    virtual void Unbind();

    virtual void PrepareSend();

protected:
    virtual void ProcessRecvPDU(BYTE bCode, bool bReq, DWORD dwParam, BufferItem *pbiBody);
    virtual void ProcessRecvPDU(BYTE bCode, bool bReq, DWORD dwParam, const PBYTE pData, UINT nDataBytes, UINT nLeftBytes);

private:
    void OnDownloadReq(const PREQ_DOWNLOAD_MUDFTARGET pReqOpenMUT);

    DWORD DownloadEndReq();
    DWORD DownloadBlockReq();

    void SendResponse(BYTE bCode, DWORD dwParam);

#ifdef CONFIG_MUT_BLK_COMPACT
    DWORD DeflateBlock(BufferItem *pbi, bool &rbLast);
    DWORD DeflateCluster();
#endif

private:
    string                      _strRootDir;

    MUdfTarget                * _pMUdfTarget;

    UINT                        _nBlkIdx;
    DWORD                       _dwBlkId;

#ifdef CONFIG_MUT_BLK_COMPACT
    DeflateAlg                  _CompAlg;
    BufferItem                  _CompBuf;
    BufferItem                  _ReadBuf;
    bool                        _bEndOfBlk;
#endif
};


#endif
