/******************************************************************************
Copyright 2016 - 2019 Intel Corporation
 
For licensing information, see the file 'LICENSE' in the root folder of
  this software module. 
******************************************************************************/

#ifndef _MUDF_SERVER_EP_H
#define _MUDF_SERVER_EP_H


#include "Endpoint.h"


class MUdfServerEp : protected Endpoint
{
public:
    static MUdfServerEp *Instance();
    static void Destroy();

private:
    static MUdfServerEp       * _instance;

protected:
    MUdfServerEp();
    virtual ~MUdfServerEp();

public:
    DWORD Load(UINT nMaxConnNum, const char *szPsUpRootDir, const char *szPsDownRootDir, const char *szOsRootDir);
    virtual void Unload();

protected:
    virtual void OnListenerEnded(DWORD hListener);

    virtual EpProtocolHandler *OnNewHandler(DWORD hListener, Connection *pConnection, DWORD dwConnId);
    virtual void OnAsyncConnected(DWORD dwConnId, EpProtocolHandler *pHandler);
    virtual void OnDisconnected(DWORD dwConnId, EpProtocolHandler *pHandler);
    virtual void OnConnEvent(DWORD dwConnId, EpProtocolHandler *pHandler, PEP_MSG_HDR pEvtHdr, BufferItem *pEvtBody);

    virtual void ProcessEpWork(UINT nSigIdx);

private:
    string                      _strPsUpRootDir;
    string                      _strPsDownRootDir;
    string                      _strOsRootDir;

    DWORD                       _hPsUploadListener;
    DWORD                       _hOsUploadListener;
    DWORD                       _hPsDownloadListener;
    DWORD                       _hOsDownloadListener;
};


#endif
