/******************************************************************************
Copyright 2016 - 2019 Intel Corporation
 
For licensing information, see the file 'LICENSE' in the root folder of
  this software module. 
******************************************************************************/

#ifndef _MUDF_UPLOAD_AGENT_H
#define _MUDF_UPLOAD_AGENT_H


#include "EpPDUHandler.h"
#include "DeflateCodec.h"
#include "MUdfTarget.h"


class MUdfUploadAgent : public EpPDUHandler
{
public:
    MUdfUploadAgent(MUdfTarget *pMUdfTarget, const char *szRemoteMdf, const char *szRemoteUdf, bool bUpdateMode);
    virtual ~MUdfUploadAgent();

    virtual DWORD Bind(Connection *pConnection, PCondEvent *pEvent, UINT nSigIdx);
    virtual void Unbind();

    virtual void OnAsyncConnected(Connection *pConnection);

    virtual void PrepareSend();

protected:
    virtual void ProcessRecvPDU(BYTE bCode, bool bReq, DWORD dwParam, BufferItem *pbiBody);
    virtual void ProcessRecvPDU(BYTE bCode, bool bReq, DWORD dwParam, const PBYTE pData, UINT nDataBytes, UINT nLeftBytes);

private:
    DWORD UploadStartReq();
    DWORD UploadEndReq();
    DWORD UploadBlockReq();

    void OnUploadFinished(DWORD dwErrCode);

#ifdef CONFIG_MUT_BLK_COMPACT
    DWORD DeflateBlock(BufferItem *pbi, bool &rbLast);
    DWORD DeflateCluster();
#endif

private:
    MUdfTarget                * _pMUdfTarget;
    string                      _strRemoteMdf;
    string                      _strRemoteUdf;
    bool                        _bUpdateMode;

    UINT                        _nBlkIdx;
    DWORD                       _dwBlkId;

#ifdef CONFIG_MUT_BLK_COMPACT
    DeflateAlg                  _CompAlg;
    BufferItem                  _CompBuf;
    BufferItem                  _ReadBuf;
    bool                        _bEndOfBlk;
#endif
};


#endif
