/******************************************************************************
Copyright 2016 - 2019 Intel Corporation
 
For licensing information, see the file 'LICENSE' in the root folder of
  this software module. 
******************************************************************************/

#ifndef _MUDF_UPLOAD_AGENT_NT_H
#define _MUDF_UPLOAD_AGENT_NT_H


#include "EpPDUHandler.h"
#include "DeflateCodec.h"


class MUdfUploadAgentNt : public EpPDUHandler
{
public:
    MUdfUploadAgentNt(HANDLE hPsMUdfCtrl, HANDLE hPsMUdfFile, const char *szRemoteMdf, const char *szRemoteUdf);
    virtual ~MUdfUploadAgentNt();

    virtual DWORD Bind(Connection *pConnection, PCondEvent *pEvent, UINT nSigIdx);
    virtual void Unbind();

    virtual void OnAsyncConnected(Connection *pConnection);

    virtual void PrepareSend();

protected:
    virtual void ProcessRecvPDU(BYTE bCode, bool bReq, DWORD dwParam, BufferItem *pbiBody);
    virtual void ProcessRecvPDU(BYTE bCode, bool bReq, DWORD dwParam, const PBYTE pData, UINT nDataBytes, UINT nLeftBytes);

private:
    DWORD UploadStartReq();
    DWORD UploadEndReq();
    DWORD UploadBlockReq();
    DWORD UploadBlockData(BufferItem *pbi);

    void OnUploadFinished(DWORD dwErrCode);

    DWORD OpenAndReadBlock();

    DWORD WorkThread();
    static void *WorkThreadProc(void *arg);

#ifdef CONFIG_MUT_BLK_COMPACT
    DWORD DeflateBlock(BufferItem *pbi, bool &rbLast);
    DWORD DeflateCluster();
#endif

private:
    HANDLE                      _hPsMUdfCtrl;
    HANDLE                      _hPsMUdfFile;
    string                      _strRemoteMdf;
    string                      _strRemoteUdf;

    volatile bool               _bQuit;
    volatile MUDF_UPAGENT_STATE _CurState;
    sem_t                       _hWorkEvent;
    pthread_t                   _hWorkThread;

    DWORD                       _dwBlkIdx;
    DWORD                       _dwUdfOff;
    BufferItem                  _biBlkBuf;

#ifdef CONFIG_MUT_BLK_COMPACT
    DeflateAlg                  _CompAlg;
    BufferItem                  _CompBuf;
    bool                        _bEndOfBlk;
#endif
};


#endif
