/******************************************************************************
Copyright 2016 - 2019 Intel Corporation
 
For licensing information, see the file 'LICENSE' in the root folder of
  this software module. 
******************************************************************************/

#ifndef _MUDF_UPLOAD_HANDLER_H
#define _MUDF_UPLOAD_HANDLER_H


#include "EpPDUHandler.h"
#include "DeflateCodec.h"
#include "MUdfTarget.h"


class MUdfUploadHandler : public EpPDUHandler
{
public:
    MUdfUploadHandler(const char *szRootDir);
    virtual ~MUdfUploadHandler();

    virtual DWORD Bind(Connection *pConnection, PCondEvent *pEvent, UINT nSigIdx);
    virtual void Unbind();

    virtual void PrepareSend();

protected:
    virtual void ProcessRecvPDU(BYTE bCode, bool bReq, DWORD dwParam, BufferItem *pbiBody);
    virtual void ProcessRecvPDU(BYTE bCode, bool bReq, DWORD dwParam, const PBYTE pData, UINT nDataBytes, UINT nLeftBytes);

private:
    DWORD OnInitMUdfTarget(const PREQ_UPLOAD_MUDFTARGET pReqOpenMUT, bool bOverwrite);
    DWORD OnFiniMUdfTarget();
    DWORD OnOpenMUdfBlock(const PMUDFTARGET_BLOCK_INFO pMUTBlkInfo);

    void SendResponse(BYTE bCode, DWORD dwParam, DWORD dwExtra);

#ifdef CONFIG_MUT_BLK_COMPACT
    DWORD InflateBlock(const PBYTE pData, UINT nDataBytes, bool bLast, bool &rbEndOfBlk);
#endif

private:
    string                      _strRootDir;

    MUdfTarget                * _pMUdfTarget;

    bool                        _bBlkEndAck;

    UINT                        _nBlkIdx;
    DWORD                       _dwBlkId;

#ifdef CONFIG_MUT_BLK_COMPACT
    InflateAlg                  _DecompAlg;
    BufferItem                  _DecompBuf;
#endif
};


#endif
