/******************************************************************************
Copyright 2016 - 2019 Intel Corporation
 
For licensing information, see the file 'LICENSE' in the root folder of
  this software module. 
******************************************************************************/

#include <StdAfx.h>
#if defined(_WIN32_) || defined(_WINCE_)
#include <vld.h>
#endif
#include <openssl/evp.h>


const int  KEY_LEN            = 32;

int main(int argc, char *argv[])
{
    unsigned char  buf[KEY_LEN];

    if ( argc < 4 )
    {
        log_wprintf(L"PBKDF2Passwd <password> <salt> <iteration>\n");
        return ERROR_INVALID_PARAMETER;
    }

    if ( PKCS5_PBKDF2_HMAC(argv[1], (int)strlen(argv[1]), (unsigned char*)argv[2], (int)strlen(argv[2]), atoi(argv[3]), EVP_sha256(), KEY_LEN, buf) == 0 )
    {
        log_wprintf(L"PKCS5_PBKDF2_HMAC failed\n");
        return ERROR_NOT_SUPPORTED;
    }

    for ( int i = 0; i < KEY_LEN; ++i )
    {
        log_wprintf(L"%02x", buf[i]);
    }
    log_wprintf(L"\n");

    return ERROR_SUCCESS;
}
