/******************************************************************************
Copyright 2016 - 2019 Intel Corporation
 
For licensing information, see the file 'LICENSE' in the root folder of
  this software module. 
******************************************************************************/

#include <windows.h>
#include <stdio.h>
#include <fcntl.h>
#include <io.h>
#include "NtFileLib.h"


DWORD DoOutFile(HANDLE hFile)
{
    DWORD  dwRet = ERROR_SUCCESS;
    BYTE  buf[1024];
    size_t  ulSize;

    _setmode(_fileno(stdin), _O_BINARY);

    while ( true )
    {
        ulSize = fread(buf, 1, sizeof(buf), stdin);
        if ( ulSize == 0 )
        {
            if ( !feof(stdin) )
            {
                dwRet = GetLastError();
                fwprintf(stderr, L"Input failed: %d\n", dwRet);
            }
            break;
        }

        ntWriteFile(hFile, buf, (ULONG)ulSize);
        if ( dwRet != ERROR_SUCCESS )
        {
            fwprintf(stderr, L"WriteFile failed: %d\n", dwRet);
            break;
        }
    }

    return dwRet;
}

int __cdecl wmain(int argc, wchar_t *argv[])
{
    DWORD  dwRet;
    HANDLE  hFile;

    if ( argc < 2 )
    {
        fwprintf(stderr, L"NtFileOut.exe <file_name>\n");
        return ERROR_INVALID_PARAMETER;
    }

    dwRet = ntOpenFileW(&hFile, argv[1], "wb");
    if ( dwRet != ERROR_SUCCESS )
    {
        fwprintf(stderr, L"OpenFile(%s) failed: %d\n", argv[1], dwRet);
        goto err1;
    }

    dwRet = DoOutFile(hFile);
    if ( dwRet != ERROR_SUCCESS )
    {
        fwprintf(stderr, L"OutFile(%s) failed: %d\n", argv[1], dwRet);
        goto err2;
    }

err2:
    ntCloseFile(hFile);

err1:
    return dwRet;
}
