/******************************************************************************
Copyright 2016 - 2019 Intel Corporation
 
For licensing information, see the file 'LICENSE' in the root folder of
  this software module. 
******************************************************************************/

#include <windows.h>
#include <stdio.h>
#include "NtFileLib.h"


int __cdecl wmain(int argc, wchar_t *argv[])
{
    DWORD  dwRet;
    HANDLE  hFile;

    if ( argc < 2 )
    {
        fwprintf(stderr, L"NtFileTest.exe <file_name>\n");
        return ERROR_INVALID_PARAMETER;
    }

    dwRet = ntOpenFileW(&hFile, argv[1], "rb");
    if ( dwRet != ERROR_SUCCESS )
    {
        fwprintf(stderr, L"OpenFile(%s) failed: %d\n", argv[1], dwRet);
        goto err1;
    }

    ntCloseFile(hFile);

err1:
    return dwRet;
}
