/******************************************************************************
Copyright 2016 - 2019 Intel Corporation
 
For licensing information, see the file 'LICENSE' in the root folder of
  this software module. 
******************************************************************************/

#include <windows.h>
#include <stdio.h>
#include "NtFileLib.h"


int __cdecl wmain(int argc, wchar_t *argv[])
{
    DWORD  dwRet;
    HANDLE  hFile;
    LONGLONG  llLength;

    if ( argc < 2 )
    {
        fwprintf(stderr, L"NtFileTrunc.exe <file_name> [new_length]\n");
        return ERROR_INVALID_PARAMETER;
    }

    dwRet = ntOpenFileW(&hFile, argv[1], ((argc==2) ? "rb" : "wb"));
    if ( dwRet != ERROR_SUCCESS )
    {
        fwprintf(stderr, L"OpenFile(%s) failed: %d\n", argv[1], dwRet);
        goto err1;
    }

    if ( argc == 2 )
    {
        dwRet = ntGetFileLength(hFile, &llLength);
        if ( dwRet != ERROR_SUCCESS )
        {
            fwprintf(stderr, L"GetFileLength(%s) failed: %d\n", argv[1], dwRet);
            goto err2;
        }
        fwprintf(stdout, L"%s: %lld\n", argv[1], llLength);
    }
    else
    {
        llLength = _wtoi64(argv[2]);
        dwRet = ntSetFileLength(hFile, llLength);
        if ( dwRet != ERROR_SUCCESS )
        {
            fwprintf(stderr, L"SetFileLength(%s) failed: %d\n", argv[1], dwRet);
            goto err2;
        }
    }

err2:
    ntCloseFile(hFile);

err1:
    return dwRet;
}
