/******************************************************************************
Copyright 2016 - 2019 Intel Corporation
 
For licensing information, see the file 'LICENSE' in the root folder of
  this software module. 
******************************************************************************/

#include <windows.h>
#include <stdio.h>
#include "NtFileLib.h"


int __cdecl wmain(int argc, wchar_t *argv[])
{
    DWORD  dwRet;
    HANDLE  hVol;
    int  nShift;
    LONGLONG  llTotalBytes, llFreeBytes;

    if ( argc < 2 )
    {
        fwprintf(stderr, L"NtVolInfo.exe <vol_path> [shift_num]\n");
        return ERROR_INVALID_PARAMETER;
    }

    nShift = (argc > 2) ? _wtoi(argv[2]) : 0;

    dwRet = ntOpenFileW(&hVol, argv[1], "rb");
    if ( dwRet != ERROR_SUCCESS )
    {
        fwprintf(stderr, L"OpenFile(%s) failed: %d\n", argv[1], dwRet);
        goto err1;
    }

    dwRet = ntGetVolumeSizeInfo(hVol, &llTotalBytes, &llFreeBytes);
    if ( dwRet != ERROR_SUCCESS )
    {
        fwprintf(stderr, L"GetVolumeSizeInfo(%s) failed: %d\n", argv[1], dwRet);
        goto err1;
    }

    fwprintf(stdout, L"%lld %lld\n", llTotalBytes >> nShift, llFreeBytes >> nShift);

    ntCloseFile(hVol);

err1:
    return dwRet;
}
