/******************************************************************************
Copyright 2012 - 2020 Intel Corporation

For licensing information, see the file 'LICENSE' in the root folder of
this software module.
******************************************************************************/
// TCUpdateDlg.h : header file
//

#pragma once
#include "afxwin.h"


// CTCUpdateDlg dialog
class CTCUpdateDlg : public CDialog
{
// Construction
public:
	CTCUpdateDlg(CWnd* pParent = NULL);	// standard constructor
	~CTCUpdateDlg();

// Dialog Data
	enum { IDD = IDD_TCUPDATE_DIALOG };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support


// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	virtual BOOL OnInitDialog();
    afx_msg void OnSize(UINT nType, int cx, int cy);
    afx_msg void OnClose();
    afx_msg void OnMenuShow();
    afx_msg void OnMenuQuit();
	afx_msg void OnDestroy();
    afx_msg void OnTimer(UINT_PTR nIDEvent);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnClickedBtnStart();
    afx_msg LRESULT OnNotifyIcon(WPARAM wParam, LPARAM lParam);
    afx_msg LRESULT OnUpdPsMsg(WPARAM wParam, LPARAM lParam);
    afx_msg LRESULT OnUpdPsEnd(WPARAM wParam, LPARAM lParam);
	DECLARE_MESSAGE_MAP()

private:
    CEdit                 m_edtMsg;

private:
    BOOL InitUpdate();
    VOID FiniUpdate();
    VOID StartUpdate();
    VOID StopUpdate();

private:
    CRITICAL_SECTION      m_csOutput;
    CString               m_strOutput;

private:
    DWORD WorkThread();
    static DWORD WINAPI WorkThreadProc(LPVOID lpParameter);

    DWORD PrepareUpdEnv();
    DWORD ExportUpdPkg(LPVOID pPkgData, DWORD dwPkgSize);

    DWORD RunUpdProcess();
    VOID EndUpdProcess();
    BOOL ReadUpdProcess();

private:
    bool                  m_bStarted;
    CButton               m_btnStart;

    NOTIFYICONDATA        m_nid;
    CMenu                 m_PopupMenu;

    HANDLE                m_hQuitEvent;
    HANDLE                m_hStartEvent;
    HANDLE                m_hStopEvent;
    HANDLE                m_hUpdQuitEvt;
    HANDLE                m_hWorkThread;

    char                  m_szWorkDir[MAX_PATH];

    HANDLE                m_hStdOutPipe;
    HANDLE                m_hUpdProcess;
};
