#ifndef TC_NT_LIB_H
#define TC_NT_LIB_H

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#if !defined(TC_STDCALL)
# if defined(_WIN32)
#  define TC_STDCALL __stdcall
# else
#  define TC_STDCALL
# endif
#endif

#if defined(__cplusplus)
extern "C"
{
#endif

	// function declaration

    // function:
    // open a file with multibyte string name `pmbFilePath' and 
    // try to read at most `nBytes' from the file, then save the
    // content to address pointed by `buf'.
    // return value:
    // if encounter errors, return -1
    // otherwise, return the number of bytes returned
    //
    // for Visual 2015, the key word extern is a must :(
    // 
	extern int TC_STDCALL TcOneTimeNtReadFile(unsigned char *buf, size_t nBytes, const char *szFilepath);
	extern int TC_STDCALL TcOneTimeNtReadFileW(unsigned char *buf, size_t nBytes, const wchar_t *wszFilepath);
	/**
	write buffer to file
	@return 0 on success
	**/
	extern int TC_STDCALL TcOneTimeNtWriteFile(unsigned char *buf, size_t nBytes, const char *szFilepath);
	extern int TC_STDCALL TcOneTimeNtWriteFileW(unsigned char *buf, size_t nBytes, const wchar_t *wszFilepath);

#if defined(__cplusplus)
}
#endif

#endif // TC_NT_LIB_H
