﻿/******************************************************************************
Copyright 2012 - 2020 Intel Corporation
 
For licensing information, see the file 'LICENSE' in the root folder of
  this software module. 
******************************************************************************/
#ifndef _TC_HELPERS_H_
#define _TC_HELPERS_H_

#include <wincred.h>
#include <ntsecapi.h>

HRESULT TcCopyProtectedString(LPWSTR lpStr, 
	LPWSTR lpProtectedStr, 
	DWORD *pCchProtectedStr);
HRESULT TcCopyProtectedStringIfNecessaryW(LPWSTR lpStr, 
	CREDENTIAL_PROVIDER_USAGE_SCENARIO cpus, 
	LPWSTR lpProtectedStr, 
	DWORD *pCchProtectedStr);
HRESULT TcUnicodeStringInitWithStringW(LPWSTR lpStr, 
	UNICODE_STRING *pStrUs);
HRESULT TcKerbInteractiveUnlockLogonInitW(LPWSTR lpDomain, 
	LPWSTR lpUsername, 
	LPWSTR lpPassword, 
	CREDENTIAL_PROVIDER_USAGE_SCENARIO cpus,
    KERB_INTERACTIVE_UNLOCK_LOGON *pObjKiul);
VOID TcUnicodeStringInitWithUnicodeStringCopy(
	CONST UNICODE_STRING& rus, 
	PWSTR lpBuffer, 
	UNICODE_STRING *pus);
HRESULT TcKerbInteractiveUnlockLogonPack(
	CONST KERB_INTERACTIVE_UNLOCK_LOGON &objKiul, 
	BYTE **pRgb, 
	DWORD *pcbRgb);
HRESULT TcRetrieveNegotiateAuthPackage(ULONG *pcbAuthPackage);
HRESULT TcSpliterDomainAndUsername(LPCWSTR lpDomainUsername, 
	LPWSTR lpDomain, 
	DWORD cchDomain, 
	LPWSTR lpUsername, 
	DWORD cchUsername);
HRESULT TcKerbChangePasswordRequestInitW(LPWSTR lpDomain, 
	LPWSTR lpUsername, 
	LPWSTR lpOldPassword, 
	LPWSTR lpNewPassword,
    KERB_CHANGEPASSWORD_REQUEST * pObjKcr);
HRESULT TcKerbChangePasswordRequestPack(
	CONST KERB_CHANGEPASSWORD_REQUEST &objKcr, 
	BYTE **pRgb, 
	DWORD *pcbRgb);

#endif
