﻿/******************************************************************************
Copyright 2012 - 2020 Intel Corporation
 
For licensing information, see the file 'LICENSE' in the root folder of
  this software module. 
******************************************************************************/
#ifndef _TC_PROVIDER_H_
#define _TC_PROVIDER_H_

#include "TcCredentialInterface.h"

//
HRESULT TcProviderCreateInstance(REFIID riid, void **ppv);
int TryCreateFirstLogonKey();

//
#define SSCRED_MAX_CREDENTIALS 10


class TcProvider : public ICredentialProvider
{
public:
  TcProvider();
  virtual ~TcProvider();

public:
  // IUnknown
  ISSUnknown_REF_DEFINE;

public:
  // ICredentialProvider
  STDMETHOD(SetUsageScenario)(CREDENTIAL_PROVIDER_USAGE_SCENARIO cpus, DWORD flags);
  STDMETHOD(SetSerialization)(CONST CREDENTIAL_PROVIDER_CREDENTIAL_SERIALIZATION* pcpcs);

  STDMETHOD(Advise)(ICredentialProviderEvents *pcpe, UINT_PTR advContext);
  STDMETHOD(UnAdvise)();

  STDMETHOD(GetFieldDescriptorCount)(DWORD *pdwCount);
  STDMETHOD(GetFieldDescriptorAt)(DWORD index, CREDENTIAL_PROVIDER_FIELD_DESCRIPTOR **ppcpfd);

  STDMETHOD(GetCredentialCount)(DWORD *pdwCount, DWORD *pdwDefault, BOOL *pfAutoLogonWithDefault);
  STDMETHOD(GetCredentialAt)(DWORD index, ICredentialProviderCredential **ppcpc);

public:
  HRESULT ChangeCredentials(ICredentialProviderCredential *pCredential);
  
protected:

  TcCredentialProviderCredential *m_pCredentials[SSCRED_MAX_CREDENTIALS];
  DWORD m_dwCredentials;

  DWORD m_dwAutoLogonCredentialIndex;

  ICredentialProviderEvents *m_pcpe;
  UINT_PTR m_uAdviseContext;
};

#endif
