﻿/******************************************************************************
Copyright 2012 - 2020 Intel Corporation
 
For licensing information, see the file 'LICENSE' in the root folder of
  this software module. 
******************************************************************************/
#include "stdafx.h"
#include "TcProviderFilter.h"

HRESULT TcProviderFilterCreateInstance(REFIID riid, void **ppv)
{
  HRESULT ret;

  if(ppv == NULL)
    return E_INVALIDARG;

  *ppv = NULL;

  TcProviderFilter *pProviderFilter = new TcProviderFilter;
  if(pProviderFilter == NULL)
    return E_OUTOFMEMORY;

  ret = pProviderFilter->QueryInterface(riid, ppv);

  pProviderFilter->Release();

  return ret;
}

ISSUnknown_REF_IMPL(TcProviderFilter)
TcProviderFilter::TcProviderFilter()
{
  DllAddRef();

  ISSUnknown_REF_INIT;
}

TcProviderFilter::~TcProviderFilter()
{
  DllRelease();
}


STDMETHODIMP TcProviderFilter::QueryInterface(
	REFIID riid, 
	void** ppv)
{
  if(ppv == NULL)
    return E_INVALIDARG;

  *ppv = NULL;


  //if(riid != IID_IUnknown && riid != IID_ICredentialProviderFilter)
  if (memcmp(&riid, &IID_IUnknown, sizeof(GUID)) && 
	  memcmp(&riid, &IID_ICredentialProviderFilter, sizeof(GUID)))
    return E_NOINTERFACE;

  *ppv = static_cast<IUnknown*>(this);
  reinterpret_cast<IUnknown*>(*ppv)->AddRef();

  return S_OK;
}

STDMETHODIMP TcProviderFilter::Filter(
	CREDENTIAL_PROVIDER_USAGE_SCENARIO cpus, 
	DWORD dwFlags, 
    GUID* rgclsidProviders, 
    BOOL* rgbAllow, 
    DWORD cProviders)
{
  switch (cpus)
  {
  case CPUS_LOGON:
  case CPUS_UNLOCK_WORKSTATION:
    {
      int i = 0;
      for (i = 0; i < (int)cProviders; i++)
      {
        //if (IsEqualGUID(rgclsidProviders[i], CLSID_SSCredProvider))
		if (!memcmp(&rgclsidProviders[i], &CLSID_SSCredProvider, sizeof(GUID)))
          break;
      }
      if(i != (int)cProviders)
      {
        int j = 0;
        for(j = 0; j < (int)cProviders; j++)
          rgbAllow[j] = FALSE;
        rgbAllow[i] = TRUE;
      }
    }
    return S_OK;
  case CPUS_CREDUI:
  case CPUS_CHANGE_PASSWORD:
    return E_NOTIMPL;
  default:
    return E_INVALIDARG;
  }
}

STDMETHODIMP TcProviderFilter::UpdateRemoteCredential(
	const CREDENTIAL_PROVIDER_CREDENTIAL_SERIALIZATION* pcpcsIn, 
	CREDENTIAL_PROVIDER_CREDENTIAL_SERIALIZATION* pcpcsOut)
{
  return E_NOTIMPL;
}
