/******************************************************************************
Copyright 2012 - 2020 Intel Corporation
 
For licensing information, see the file 'LICENSE' in the root folder of
  this software module. 
******************************************************************************/
/** @file
**/

#ifndef TC_WIN32_CTL_H
#define TC_WIN32_CTL_H

#include <Windows.h>

#define TC_WIN32_API __stdcall

// main.c
#define USBSTORAGE_CONF "\\Device\\Harddisk0\\Partition1\\usbstorage.config"

#ifdef __cplusplus
extern "C" {
#endif

//
// 0 indicates no command
// value above 0 indicates there exists command to handle
//
extern int gbCmdToSetResolution;
extern int gbCmdToSetUsbStorageAccess;
//
// value of screen Width & Height
//
extern int gnScreenWidth;
extern int gnScreenHeight;
extern int gnUsbAccessValue;

// TcLaunchApp.c
/**
Launch the process into a different session

@param szExeFilename   The executable file path to be loaded and run
@param szParamList     parameter list for the executable, multiple parameters separated with spaces
@return TRUE on success, FALSE on failure
**/
BOOL
TC_WIN32_API
LaunchAppIntoDifferentSession(
	LPCWSTR szExeFileName,
	LPCWSTR szParamList,
	LPDWORD pdwResult
  );

#ifdef __cplusplus
}
#endif

#endif /* TC_WIN32_CTL_H */
