/******************************************************************************
Copyright 2012 - 2020 Intel Corporation
 
For licensing information, see the file 'LICENSE' in the root folder of
  this software module. 
******************************************************************************/
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/un.h>
#include "TcDebugLib.h"
#include "localsock.h"

static int local_sock = -1;

int get_sock_local (){
    struct sockaddr_un local_sockaddr;
    struct local_notify_msg buf;

    if ((local_sock = socket (AF_UNIX, SOCK_DGRAM, 0)) < 0){
        DEBUG((D_ERROR, L"socket()\n"));
        exit (-1);
    }

    memset (&local_sockaddr, 0, sizeof (local_sockaddr));
    memset (&buf, 0, sizeof (buf));
    local_sockaddr.sun_family = AF_UNIX;
    strcpy (local_sockaddr.sun_path, NOTIFY_SOCK_PATH);
    unlink (NOTIFY_SOCK_PATH);

    if (bind (local_sock, (struct sockaddr*) &local_sockaddr, sizeof (local_sockaddr)) < 0){
        DEBUG((D_ERROR, L"bind()\n"));
        close_sock_local ();
        exit (-1);
    }

    return local_sock;
}

int close_sock_local (){
    close (local_sock);
    local_sock = -1;
    return 0;
}

