/******************************************************************************
Copyright 2012 - 2020 Intel Corporation
 
For licensing information, see the file 'LICENSE' in the root folder of
  this software module. 
******************************************************************************/
/** @file
**/

#ifndef TC_WIN32_CTL_H
#define TC_WIN32_CTL_H

#include <Windows.h>

#define TC_WIN32_API __stdcall

// main.c
extern HANDLE ghChgresEvent;

#ifdef __cplusplus
extern "C" {
#endif

// chgres.c
/**
  change resolution
  
  @return 0 on success, otherwise a non-zero value
**/
extern
DWORD
TC_WIN32_API
TcChangeDisplayResolution (
  VOID
  );

// parseip.c
/**
  Fetch ip addr from local hard drive

  @param ip        a buffer to store the result
  @param ip_len    size of the buffer
  @return          0 on success, negative value if error
**/
extern
int
TC_WIN32_API
ParseIpConfig (
  char *ip,
  size_t ip_len
  );

// chgres2.c
/**
Launch process as the currently logged-on user
**/
extern
BOOL
TC_WIN32_API
TcLaunchProcess(
  LPCWSTR exeName,
  LPCWSTR paramList
  );

// TcLaunchApp.c
/**
Launch the process into a different session

@param szExeFilename   The executable file path to be loaded and run
@param szParamList     parameter list for the executable, multiple parameters separated with spaces
@return TRUE on success, FALSE on failure
**/
extern
BOOL
TC_WIN32_API
LaunchAppIntoDifferentSession(
	LPCWSTR szExeFileName,
	LPCWSTR szParamList,
	LPDWORD pdwResult
  );

#ifdef __cplusplus
}
#endif

#endif /* TC_WIN32_CTL_H */
