/******************************************************************************
Copyright 2012 - 2020 Intel Corporation

For licensing information, see the file 'LICENSE' in the root folder of
this software module.
******************************************************************************/

#ifndef _BMAP_H_
#define _BMAP_H_

#include "tcd.h"

// each item of the bulkmap will have 64 bit, which stands for 64 slots of a bulk. 
typedef struct bulkmap_struct
{
	uint32 bits;

#define TOTALSZ 	(MAPSZ<<6)
#define LOGTOTALSZ	(MAPSZ+5)	// 2 ^ LOGTOTALSZ = TOTALSZ
	uint64 map[MAPSZ];
}BULKMAP;


extern int init_bulkmap(BULKMAP *bmp);
extern int set_bulkmap(BULKMAP *bmp, uint32 slot);
extern int clear_bulkmap(BULKMAP *bmp, uint32 slot);
extern int and_bulkmap(BULKMAP *bmp, BULKMAP *bmp0);
extern int isfull_bulkmap(BULKMAP *bmp, uint32 hasnext);
extern int print_bulkmap(BULKMAP *bmp);


#endif
