/******************************************************************************
Copyright 2012 - 2020 Intel Corporation

For licensing information, see the file 'LICENSE' in the root folder of
this software module.
******************************************************************************/

// @file
#ifndef CFG_SMALL_LIB_H
#define CFG_SMALL_LIB_H

//
// configuration file with Unicode encoding support
//
#if (defined(_UNICODE) || defined(UNICODE)) && !defined(CFG_FILE_PARSER_ANSI)
  #include <tchar.h>
#else
  #define TCHAR char
#endif

//
// buffer length
//
#if !defined CFG_BUFSZ
  #define CFG_BUFSZ  512
#endif

//
// C++ compatiable
//
#if defined(__cplusplus)
  extern "C" {
#endif

//
// library interface declarations for end users
//

extern int cfg_getstring(const TCHAR *section, const TCHAR *key, const TCHAR *default_value, TCHAR *buf, int buf_size, const TCHAR *filename);
extern long cfg_getlong(const TCHAR *section, const TCHAR *key, long default_value, const TCHAR *filename);
extern float cfg_getfloat(const TCHAR *section, const TCHAR *key, float default_value, const TCHAR *filename);
extern int cfg_getbool(const TCHAR *section, const TCHAR *key, int default_value, const TCHAR *filename);
extern int cfg_getsection(int index, TCHAR *buf, int buf_size, const TCHAR *filename);
extern int cfg_getkey(const TCHAR *section, int index, TCHAR *buf, int buf_size, const TCHAR *filename);

#if defined(__cplusplus)
  }
#endif

#endif

