/******************************************************************************
Copyright 2012 - 2020 Intel Corporation

For licensing information, see the file 'LICENSE' in the root folder of
this software module.
******************************************************************************/

#ifndef _CLTDB_H_
#define _CLTDB_H_

#include <sys/time.h>

#include "tcd.h"
#include "bmap.h"
// #include "tcdmsg.h"


/* detailed tracking record for each client */
typedef struct clt_struc
{
	// source ip address
	uint32 srcipadd;
	// UDP port for the peer client
	uint16 srcport;
	// hardware address/mac address
	unsigned char hwa[HWA_SZ];

	// current bulk# and the bulk bitmap
	uint32 cbulk;
	BULKMAP cbulkmap;

#define CLT_CBULK_EMPTY		0
#define CLT_CBULK_FULL		1
#define CLT_CBULK_PARTFULL	2
	uint32 cbulkfull;

/*
defined in tcdmsg.h ... 

#define CLT_MACHINE_STATUS_STR(x)	\
	(((x) == CLT_MACHINE_STATUS_UNKNOWN)? "CLT_MACHINE_STATUS_UNKNOWN":	\
	(((x) == CLT_MACHINE_STATUS_NORMAL)? "CLT_MACHINE_STATUS_NORMAL":	\
	(((x) == CLT_MACHINE_STATUS_UNMOUNT)? "CLT_MACHINE_STATUS_UNMOUNT":	\
	(((x) == CLT_MACHINE_STATUS_NOHD)? "CLT_MACHINE_STATUS_NOHD" : "CLT_MACHINE_STATUS_OTHER"	\
	))))


#define CLT_MACHINE_STATUS_UNKNOWN	0
#define CLT_MACHINE_STATUS_NORMAL	1
#define CLT_MACHINE_STATUS_UNMOUNT	2	// for unmount client, we can not deploy, but can format. 
#define CLT_MACHINE_STATUS_NOHD		3	// for nohd client, we can not do anything related with disk
#define CLT_MACHINE_STATUS_OTHER	9
*/

	uint32 machine_status;


	uint32 runacked;

	int used;
}CLT;

// # of tcd clients, which is defined in tcdmsg.h, struct scb_struct
#define MAXCLTS	128

/*
extern void init_clts(SCB *scbp);
extern CLT *find_clts(SCB *scbp, uint32 ip, uint16 port);
extern CLT *insert_clts(SCB *scbp, uint32 ip, uint16 port);
extern CLT *delete_clts(SCB *scbp, uint32 ip, uint16 port);
extern void print_clts_item(SCB *scbp, CLT *cp);
extern void print_clts(SCB *scbp);
extern void clearcbulk_clts(SCB *scbp);
*/




typedef struct actusr_struc
{
	// source ip address
	uint32 srcipadd;
	// UDP port for the peer client
	uint16 srcport;
	// hardware address/mac address
	unsigned char hwa[HWA_SZ];

	// user name
	uint8 uname[UNAME_SZ];
	// os name
	uint8 osname[OSNAME_SZ];

	struct timeval ts;

//	uint32 status;
#ifdef POST_REPORT_HWINFO
    int disksz;
    int memsz;
    char strcpu[CPU_STR_SZ];
#endif

	int used;
}ACTUSR;

// # of active users
#define MAXACTUSRS	128


#endif

