/******************************************************************************
Copyright 2012 - 2020 Intel Corporation

For licensing information, see the file 'LICENSE' in the root folder of
this software module.
******************************************************************************/

#include <stdio.h>
#include <stdarg.h>
#include <syslog.h>

static FILE *logstream;

FILE *log_init(char *logfilename)
{
	FILE *fp;

	if ((fp = fopen(logfilename, "w+")) == NULL)
	{
		perror("log_init");
		return NULL;
	}

	logstream = fp;
	return fp;
}

int log_printf(const char *fmt, ...)
{
	char logbuf[1024];
	va_list ap;

	va_start(ap, fmt);
	vsprintf(logbuf, fmt, ap);
	va_end(ap);

	fprintf(logstream, "%s", logbuf);

	return 0;
}

int log_close()
{
	fclose(logstream);
	return 0;
}

void tcd_syslog(const char *fmt, ...)
{
	va_list argp; 
	va_start(argp, fmt);

	openlog("[tcd]", 0, LOG_USER);
	// syslog(LOG_NOTICE, fmt);
	vsyslog(LOG_NOTICE, fmt, argp);
	closelog();

	va_end(argp);
	return;
}

/*
main()
{
	log_init("./tcd.log");
	log_printf("hello, the first log entry: %d\n", 123);

	log_close();
}
*/

