/******************************************************************************
Copyright 2012 - 2020 Intel Corporation

For licensing information, see the file 'LICENSE' in the root folder of
this software module.
******************************************************************************/


#ifndef _TCD_H_
#define _TCD_H_

#include <sys/time.h>

// to support large file, i.e., in Linux system, file > 2G Bytes.
#define _LARGEFILE64_SOURCE
#define _FILE_OFFSET_BITS	64

// system debug macro.
#ifdef _DEBUG_
#define DBG(fmt, ...)	fprintf(stderr, fmt, ##__VA_ARGS__)
#else
#define DBG(fmt, ...)
#endif

#define PCH(x)	// putchar((x))

// here the type definition for message exchanging between server and clients. 
typedef unsigned char uint8;
typedef unsigned short uint16;
typedef unsigned int uint32;
typedef unsigned long long uint64;


#define KBYTES	1024
#define MBYTES	1048576	// 1024*1024

#define ONETHOUSAND	1000
#define ONEMILLION	1000000

// #define NTOHUL(x)	((((x) & 0xffffffff00000000) >> 32) | (((x) & 0x00000000ffffffff) << 32))

// memory size for ip and hardware/mac address
#define IPA_SZ	4
#define HWA_SZ	6
#define INFO_SZ	32
#define VERINFO_SZ	64
#define CPU_STR_SZ	64
#define STRIP_SZ	16
#define IMAGE_NAME_SZ   128
#define USER_NAME_SZ    128
#define CLIENT_NAME_SZ  64

// post hwinfo in hb
#define POST_REPORT_HWINFO 1

#define EVT_TEXT_SZ	128

#define TCD_WLOCK_FILE "/tmp/fd04ada7-b826-4169-b0af-65e55ed03ed2"
// change the next line to not use the write-lock mechanism
#define D_TCD_WLOCK

#endif

