/******************************************************************************
Copyright 2012 - 2020 Intel Corporation

For licensing information, see the file 'LICENSE' in the root folder of
this software module.
******************************************************************************/


#include <termios.h>

static struct termios new_settings, stored_settings;

int term_raw()
{
	// to change the terminal to raw mode
	tcgetattr(0, &stored_settings);
	new_settings = stored_settings;
	new_settings.c_lflag &= ~ICANON;
	new_settings.c_lflag &= ~ECHO;
	new_settings.c_cc[VTIME]=0;
	new_settings.c_cc[VMIN]=1;
	tcsetattr(0, TCSANOW, &new_settings);

	return 0;
}


int term_restore()
{
	// to restore the terminal mode
	tcsetattr(0, TCSANOW, &stored_settings);
	return 0;
}
