/******************************************************************************
Copyright 2012 - 2020 Intel Corporation

For licensing information, see the file 'LICENSE' in the root folder of
this software module.
******************************************************************************/


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
/*
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
*/

#define INIFN	"/home/tc/etc/tc.ini"

char *get_tcdpid_fn(char *inifn)
{
	FILE *fp;
	char *sp;
	char buf[1024], t1[128], t2[128], t3[128];
	char *tcdpid_fn = (char *)malloc(256);

	if (tcdpid_fn == NULL)
	{
		fprintf(stderr, "tcdpid_fn: buffer malloc failed\n");
		return NULL;
	}
	if (inifn == NULL)
	{
		fprintf(stderr, "tcdpid_fn: inifn NULL\n");
		return NULL;
	}

	if ((fp = fopen(inifn, "r")) == NULL)
	{
		fprintf(stderr, "fopen %s failed\n", INIFN);
		exit(-1);
	}

	sp = fgets(buf, sizeof(buf), fp);
	while(sp != NULL)
	{
		// printf("read line: [%s]\n", buf);

		sscanf(buf, "%s %s %s", t1, t2, t3);
		// printf("t1=%s t2=%s t3=%s\n", t1, t2, t3);

		if (!strcmp(t1, "home"))
		{	
			printf("home=[%s]\n", t3);
			strcpy(tcdpid_fn, t3);
		}
		else if (!strcmp(t1, "home_tcd_pid"))
		{
			printf("home_tcd_pid=[%s]\n", t3);
			strcat(tcdpid_fn, t3);
		}
		sp = fgets(buf, sizeof(buf), fp);
	}

	fclose(fp);

	return tcdpid_fn;
}

main()
{
	printf("in test.c ...\n");

	printf("tcdpid_fn: [%s]\n", get_tcdpid_fn(INIFN));
	
}


#if 0

#include <stdio.h>
#include <stdlib.h>
#include <sys/utsname.h>
#include <string.h>

#define ABIT	1
#define BBIT	2
#define CBIT	4

#define A(x)	(x)&ABIT?"A":""
#define B(x)	(x)&BBIT?"B":""
#define C(x)	(x)&CBIT?"C":""

inline char *getstr(x)	\
{	\
	char *s = malloc(128);	\
	strcat(s, A(x));	\
	strcat(s, B(x));	\
	strcat(s, C(x));	\
	return s;	\
}

#define STR(x)	getstr(x)

main()
{
	int x=7;

	printf("s=%d strx=[%s]\n", x, STR(x));
}

#endif

#if 0

// state definition at server side, used in server's FSM
#define SRV_STATE_INIT		1
#define SRV_STATE_READY		2
#define SRV_STATE_RUN		4
#define SRV_STATE_STOP		8


/*
#define SRV_STATE_STR(x)	\
	(((x) == SRV_STATE_INIT)? "SRV_STATE_INIT":	\
	(((x) == SRV_STATE_READY)? "SRV_STATE_READY":	\
	(((x) == SRV_STATE_RUN)? "SRV_STATE_RUN":	\
	(((x) == SRV_STATE_STOP)? "SRV_STATE_STOP" : "UNKNOWN_SRV_STATE"	\
	))))
*/

#define str(x) #x
#define cat(a,b) a##b
#define s1(x) ((x)&SRV_STATE_INIT)?"INIT":""
#define s2(x) ((x)&SRV_STATE_READY)?"READY":""

#define SRV_STATE_STR(x) s1(x)##s2(x)


//	((x) == SRV_STATE_RUN)? "SRV_STATE_RUN":"" ## \
//	((x) == SRV_STATE_STOP)? "SRV_STATE_STOP" :"" \

main()
{
	int s = 3;
//	printf("state: %s\n", SRV_STATE_STR(s));
	printf("%s", str(hello));
	printf("%s", cat(s1(s),s2(s)));
}

#endif

#if 0
#define MNTDEV	"/dev/sda1"

main()
{
	int retval;
	
//	retval = system("mount | grep -n \"/dev/sda1\" > /dev/null 2>&1");
//	retval = system("mount | grep -n \"/dev/sdb1\" > /dev/null 2>&1");
	retval = system("mount | grep -n \"" MNTDEV "\" > /dev/null 2>&1");

	printf("retval=%d\n", retval);
}
#endif

#if 0
int main(int argc, char **argv)
{
	if (argc != 2)
	{
		printf("%s <value>\n", argv[0]);
		exit(0);
	}

	exit(atoi(argv[1]));
}
#endif


#if 0

#define FNAME_SZ	128
#define SEG_OSIDVER '_'

// get the filename from <fn>_<osid>_<ver> string
char *fl_fname(char *fnidver)
{
	char *buf = (char *)malloc(FNAME_SZ);
	char *chp;

/*
//	printf("fl_fname: fnidver=[%s]\n", fnidver);

	strcpy(buf, fnidver);
	chp = strchr(buf, SEG_OSIDVER);
	if (chp != NULL)
		*chp = '\0';

//	printf("fl_fname: [%s]\n", buf);
*/

	strcpy(buf, fnidver);
	chp = strrchr(buf, SEG_OSIDVER);
	if (chp != NULL)
	{
		*chp = '\0';

		chp = strrchr(buf, SEG_OSIDVER);
		if (chp != NULL)
			*chp = '\0';
	}

	return buf;
}



// get the osid from <fn>_<osid>_<ver> string
int fl_osid(char *fnidver)
{
	char *buf = (char *)malloc(FNAME_SZ);
	char *chp;

//	printf("fl_osid: fnidver=[%s]\n", fnidver);

	strcpy(buf, fnidver);
	chp = strrchr(buf, SEG_OSIDVER);
	if (chp == NULL)
	{
		printf("fl_osid: [1]\n");
		return 1;
	}

	*chp = '\0';
	chp = strrchr(buf, SEG_OSIDVER);
	if (chp == NULL)
	{
		printf("fl_osid: [1]\n");
		return 1;
	}
	else
	{
		printf("fl_osid: [%d]\n", atoi(chp+1));
		return atoi(chp+1);
	}
}



// get the ver from <fn>_<osid>_<ver> string
int fl_ver(char *fnidver)
{
	char *chp = strrchr(fnidver, SEG_OSIDVER);

//	printf("fl_ver: fnidver=[%s]\n", fnidver);
	// printf("chp = <%s>\n", chp);
	if (chp != NULL)
	{
		printf("fl_ver: [%d]\n", atoi(chp+1));
		return atoi(chp+1);
	}
	else
	{
		printf("fl_ver: [1]\n");
		return 1;
	}
}


main()
{
//	char *fn = "android.2.3.img_239_345";
//	char *fn = "android.2.3.img_239";
//	char *fn = "android.2.3.img";
//	char *fn = "win7_cache.img_5_1";
	char *fn = "win7_cache.img_51";

	printf("osname: [%s]\n", fl_fname(fn));
	printf("osid: [%d]\n", fl_osid(fn));
	printf("version: [%d]\n", fl_ver(fn));


}

#endif


#if 0
main()
{
	struct utsname utemp;

	printf("test uname ...\n");

	if (uname(&utemp) == -1)
	{
		perror("uname");
		exit(0);
	}


#if 0
char sysname[];    /* Operating system name (e.g., "Linux") */
char nodename[];   /* Name within "some implementation-defined
                     network" */
char release[];    /* Operating system release (e.g., "2.6.28") */
char version[];    /* Operating system version */
char machine[];    /* Hardware identifier */
#endif


	printf("sysname: %s nodename: %s release: %s version: %s machine: %s\n", utemp.sysname, utemp.nodename, utemp.release, utemp.version, utemp.machine);
}

#endif


#if 0

#define _LARGEFILE64_SOURCE     /* See feature_test_macros(7) */
#define _FILE_OFFSET_BITS	64


#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>


#include <sys/time.h>
#include <signal.h>
#include <string.h>

typedef unsigned char uint8;
typedef unsigned short uint16;
typedef unsigned int uint32;
typedef unsigned long long uint64;


// Check windows
#if _WIN32 || _WIN64
 #if _WIN64
  #define MACHINE_X64
 #else
  #define MACHINE_X32
 #endif
#endif

// Check GCC
#if __GNUC__
 #if __x86_64__ || __ppc64__
  #define MACHINE_X64
 #else
  #define MACHINE_X32
 #endif
#endif

/*
#if (sizeof(long) == 8)
#define MACHINE_X64	1
#endif

#if (sizeof(long) == 4)
#define MACHINE_X32
#endif
*/


typedef struct tcdmsg_struct
{
#define TCDMSG_REGREQ	1
#define TCDMSG_DEREGREQ	2
#define TCDMSG_REGACK	3

#define TCDMSG_RUNREQ	4
#define TCDMSG_STOPREQ	5
#define TCDMSG_RUNACK	6

#define TCDMSG_PKTINQ	7
#define TCDMSG_PKTACK	8
#define TCDMSG_DATA	9

#define TCDMSG_HELLO	10
#define TCDMSG_SHUTDOWN	11
#define TCDMSG_REBOOT	12

#define TCDMSG_NOTIFY	13

// used for TC integration
#define TCDMSG_CMDSTART	14
#define TCDMSG_CMDRUN	15
#define TCDMSG_CMDLIST	16
#define TCDMSG_CMDQUIT	17
#define TCDMSG_CMDREBOOT	18
#define TCDMSG_CMDSHUTDOWN	19

	uint32 type;
	uint32 size;

	union uu
	{

		// run request
		struct ur_s
		{
// defined in tcd.h
#define FNAME_SZ	64
			uint8 fname[FNAME_SZ];
			uint32 hasnofile;
			uint64 tslots;
		}ur;


	}u;

} __attribute__((packed)) TCDMSG;


static char dotmap[10][7] = {
	{0x0E, 0x11, 0x13, 0x15, 0x19, 0x11, 0x0E, }, 
	{0x04, 0x0C, 0x04, 0x04, 0x04, 0x04, 0x0E, }, 
	{0x0E, 0x11, 0x01, 0x02, 0x04, 0x08, 0x1F, }, 
	{0x1F, 0x02, 0x04, 0x02, 0x01, 0x01, 0x0E, }, 
	{0x02, 0x06, 0x0a, 0x12, 0x1F, 0x02, 0x02, }, 
	{0x1F, 0x10, 0x1E, 0x01, 0x01, 0x11, 0x0E, }, 
	{0x06, 0x08, 0x10, 0x1E, 0x11, 0x11, 0x0E, }, 
	{0x1F, 0x01, 0x02, 0x04, 0x08, 0x08, 0x08, }, 
	{0x0E, 0x11, 0x11, 0x0E, 0x11, 0x11, 0x0E, }, 
	{0x0E, 0x11, 0x11, 0x0F, 0x01, 0x02, 0x0C, }, 
};

int print_digit(int x)
{
	unsigned char val;
	int k;

	if (x<0 || x>9)
	{
		fprintf(stderr, "illegal digit x %d\n", x);
		return -1;
	}

	for (k=0; k<7; k++)
	{
		val = 0x80;
		while(val != 0)
		{
			if (val & dotmap[x][k])
				printf("*");
			else
				printf(" ");
			val >>= 1;
		}
		printf("\n");
	}
}

int print_num(int x)
{
	int dight[32], dcount;
	int k, value;
	unsigned char val;
	int idx, j;
	
	k = 0;
	value = x;
	while(value > 0)
	{
		dight[k] = value % 10;
		value /= 10;
		k++;
	}
	dcount = k;

/*
	for (k=dcount; k>0; k--)
		printf("%d ", dight[k-1]);
*/

	printf("\n");
	for (k=0; k<7; k++)
	{

		for (j=dcount; j>0; j--)
		{
			idx = dight[j-1];

			val = 0x80;
			while(val != 0)
			{
				if (val & dotmap[idx][k])
					printf("*");
				else
					printf(" ");
				val >>= 1;
			}
		}
		printf("\n");

	}
	printf("\n");

	
}



main()
{
	printf("size of uint8: %d\n", (int)sizeof(uint8));
	printf("size of uint16: %d\n", (int)sizeof(uint16));
	printf("size of uint32: %d\n", (int)sizeof(uint32));
	printf("size of uint64: %d\n", (int)sizeof(uint64));
	printf("size of long: %d\n", (int)sizeof(long));

	TCDMSG t;

	t.u.ur.tslots = 0x1122334455667788;

	printf("tslots: 0x%llx\n", t.u.ur.tslots);

#ifdef MACHINE_X64
printf("running on 64-bit machine\n");
#endif

#ifdef MACHINE_X32
printf("running on 32-bit machine\n");
#endif

/*
	int k;
	for (k=0; k<10; k++)
		print_digit(k);
*/
	print_num(1234567890);
}

#if 0

// buf: the filename pool
// **fn: the string array as the output. 
// return: # of file names in **fn
#define SEGCHAR ';'
int getfn(char *buf, char **fn)
{
	char *chp, *head;
	int count=0;

	if (buf == NULL)
	{
		fprintf(stderr, "NULL buf\n");
		return -1;
	}

	head = chp = buf;
	while(1)
	{
		while(*chp != SEGCHAR && *chp != '\0')
			chp++;

		fn[count++] = head;
		
		
		if (*chp == '\0')
			break;
		else
			*chp = '\0';

		head = ++chp;
	}

	return count;
}

// **fn: the string array as the output. 
// count: # of filenames in **fn
// buf: the filename pool
// return: # of file names in **fn
int putfn(char **fn, int count, char *buf)
{
	int k;
	char *chp;

	if (buf == NULL || fn == NULL)
	{
		fprintf(stderr, "NULL buf");
		return -1;
	}

	chp = buf;
	for (k=0; k<count; k++)
	{
		memcpy(chp, fn[k], strlen(fn[k]));
		chp += strlen(fn[k]);
		*chp++ = SEGCHAR;
	}

	*(--chp) = '\0';

	return 0;
}



main()
{
	char buf[] = "../win7.img;/boot/images/ubuntu.img;android.img";
	char *fn[32];
	int k;

	int count = getfn(buf, fn);
	if (count != -1)
	{
		for (k=0; k<count; k++)
			printf("%d --- %s\n", k, fn[k]);
	}
	else
		printf("parse failed\n");	


	char buf2[1024];
	char *fn2[] = {"../ubuntu.img", "/boot/images/android.img", "winxp.img", "/mnt/oldimages/dos.img"};

	putfn(fn2, 4, buf2);
	printf("buf2=[%s]\n", buf2);	

	printf("sizeof fn2=%d\n", sizeof(fn2)/sizeof(char *));
}

#endif


/*
#define SLOT_BYTES	1460

int fl_open(char *name)
{
	int fd; 

	if ((fd = open(name, O_RDONLY)) == -1)
	{
		perror("fl_open");
		return -1;
	}
	printf("fl_open: <%s> successfully\n", name);
	return fd;
}


int fl_read_slot(int fd, uint32 slot, char *buf)
{
	int retval;

	printf(">>> fl_read_slot: current slot: [%d] SLOT_BYTES: [%d] fl_offset: [%lld]\n", slot, SLOT_BYTES, (uint64)slot*SLOT_BYTES);

	// if ((retval = lseek64(fd, (off64_t)(slot*(uint64)SLOT_BYTES), SEEK_SET)) == -1)
	if ((retval = lseek64(fd, (off64_t)((uint64)slot*SLOT_BYTES), SEEK_SET)) == -1)
	{
		perror("lseek64");
		return -1;
	}

	if ((retval = read(fd, buf, SLOT_BYTES)) < 0)
	{
		perror("fl_read");
		return -1;
	}

	return retval;
}

int fl_close(int fd)
{
	return close(fd);
}


main()
{
	int fd; 
	int slot = 2967639; 
	char buf[4096];

// fl_read_slot: current slot: [2967639] SLOT_BYTES: [1460] fl_offset: [37785644]


	fd = fl_open("../ce8.img");

	if (fl_read_slot(fd, slot, buf) == -1)
	{
		perror("fl_read_slot");
	}

	fl_close(fd);
	
}

*/


#if 0
// here the type definition for message exchanging between server and clients. 
typedef unsigned char uint8;
typedef unsigned short uint16;
typedef unsigned int uint32;
typedef unsigned long long uint64;

int count=0;
struct timeval basetv; 

struct timeval getts()
{
	struct timeval tv;
	struct timezone tz;

	gettimeofday(&tv, &tz);
	return tv;
}

uint64 diff_tv(struct timeval starttv, struct timeval endtv)
{
	struct timeval result;
	// double d;
	uint64 diff;

	if (endtv.tv_sec < starttv.tv_sec)
		return -1;
	
	if (endtv.tv_sec == starttv.tv_sec && endtv.tv_usec < starttv.tv_usec)
		return -1;

	result.tv_sec = endtv.tv_sec - starttv.tv_sec; 
	result.tv_usec = endtv.tv_usec - starttv.tv_usec; 

	if (result.tv_usec < 0)
	{
		result.tv_sec --;
		result.tv_usec += 1000000;
	}

	// d = (double)result.tv_sec + (double)result.tv_usec/1000000;
	// printf("diff: %ld . %ld sec, d=%f usec\n", result.tv_sec, result.tv_usec, d);
	diff = (uint64)(result.tv_sec) * 1000000 + (uint64)(result.tv_usec);

	return diff;
}

void sigroutine(int dunno)
{
	struct timeval tv; 
	// double d;
	uint64 diff;

	tv = getts();
	// d = diff_tv(basetv, tv);
	diff = diff_tv(basetv, tv);
	printf("in sigroutine (%d) ...%d --- ts: %ld:%ld	d=%lld\n", dunno, count++, tv.tv_sec, tv.tv_usec, diff);
	// alarm(1);
	// printf("%ld:%ld\n", tv.tv_sec, tv.tv_usec);
}


void vos_usleep(uint32 usec)
{
	if (usec == 0)
		return;
	else
		usleep(usec);
	return;
}

void vos_usleep1(uint32 usec)
{
	volatile int i, j, k;

	i=j=k=0;
	while (k++ < usec)
		while (j++<10000)
		{
			__asm__ __volatile__("nop\nnop\nnop\nnop\nnop\nnop\nnop\nnop"::);
		}
}

void vos_usleep2(uint32 usec)
{
	struct timeval tv1, tv2;
	uint64 diff;

	tv1 = getts();
	while(1)
	{
		// __asm__ __volatile__("nop\nnop\nnop\nnop\nnop\nnop\nnop\nnop");
		__asm__ __volatile__("nop\n");

		tv2 = getts();
		diff = diff_tv(tv1, tv2);
		// printf("diff=%lld\n", diff);
		if (diff > usec)
			break;
	}
	return;
}

main()
{
	struct timeval tv1, tv2;
	long long int lli;
	int i, k;
	int us[] = {1, 2, 5, 10, 20, 50, 100, 200, 500, 1000};

/*
	int count=0;
	while(count++<10)
	{
		printf("click ... %d\n", count);
		vos_usleep2(5000000);
	}
*/

	for (k=0; k<sizeof(us)/sizeof(int); k++)
	{
		tv1 = getts();
		for (i=0; i<1000; i++)
			vos_usleep(us[k]);
		tv2 = getts();
		lli = diff_tv(tv1, tv2);
		printf("sleep: %d lli=%lld\n", us[k], lli);

		tv1 = getts();
		for (i=0; i<1000; i++)
			vos_usleep2(us[k]);
		tv2 = getts();
		lli = diff_tv(tv1, tv2);
		printf("sleep: %d lli=%lld\n", us[k], lli);

	}


/*
	struct itimerval tv, otv;

	printf("some test program for TCD project ...\n");

	signal(SIGALRM, sigroutine);

	tv.it_value.tv_sec = 1;
	tv.it_value.tv_usec = 0;
	tv.it_interval.tv_sec = 0;
	tv.it_interval.tv_usec = 1000;

	basetv = getts();

	if (setitimer(ITIMER_REAL, &tv, &otv) != 0)
		perror("setitimer");
	

	// alarm(1);
	while(1)
		pause();

*/
}

#endif

#endif

