/******************************************************************************
Copyright 2012 - 2020 Intel Corporation

For licensing information, see the file 'LICENSE' in the root folder of
this software module.
******************************************************************************/

#ifndef _TM_H_
#define _TM_H_

#include <unistd.h>
#include <time.h>
#include <sys/time.h>
#include <signal.h>
#include <stdlib.h>
#include <fcntl.h>

#include "tcd.h"

uint64 diff_tv(struct timeval starttv, struct timeval endtv);
void vos_msleep(uint32 msec);
struct timeval getts();

void vos_random_msleep();
void vos_random_usleep();

// local time zone time string to Epoch time (1970-01-01)
// "2018-06-08 19:09:19" -> 1528456159
time_t str2timet(const char *buf, const char *fmt);

// seconds elapsed since Epoch time to time string
// 1528456159 -> "2018-06-08 19:09:19"
char *timet2str(char *buf, int sz, const char *fmt, time_t *t);

// link with -lrt
// return local time string
// for example, "2018-06-08 19:09:19"
//char *clktmstr(char *buf, int sz, const char *fmt);
#endif

