#!/bin/sh

if [ $# -lt 2 ]; then
	echo "autopart.sh <device> <partition>"
	exit 0
fi

echo "umount the partition ..."
umount /mnt

echo "clear disk partition table ..."
dd if=/dev/zero of=$1 bs=1 count=66 seek=446

echo "new --- tagging the hard disk..."
echo "update MBR (+63 sectors)..."
echo "TC" > /tmp/hb.sig
dd if=/tmp/hb.sig of=$1 bs=512 seek=63
dd if=/weiyu/MBRCode.bin of=$1 bs=512 seek=64
dd if=/weiyu/BootLoad.bin of=$1 bs=512 seek=65

cylinders=`fdisk -l $1 | grep -n "^[0-9]" | awk '{print $5}'`
echo "Original Cylinder of Hard Disk: " $cylinders
if [ $cylinders > 65536 ]
then
 cylinders=65536
 echo "Adjusted Cylinder: " $cylinders
fi

cylinders=$((cylinders*9/10/1024*1024))
echo "Used Cylinders of Hard Disk: " $cylinders

echo "partition the device ..."
fdisk $1 << EOF 
n
p
1
8
$cylinders
w
EOF

echo "format the partition ..."
mkfs.ext3 $2






mount $2 /mnt/

mkdir -p /mnt/boot/grub
cp -a /weiyu/share/grub/* /mnt/boot/grub/
cp -a /weiyu/bzImage /mnt/boot/
cp -a /weiyu/initrd.img /mnt/boot/

umount /mnt/

grub --batch <<EOT # 1>/dev/null 2>/dev/null
root (hd1,0)
setup (hd1)
quit
EOT





echo "successfully ..."

