#!/bin/sh

if [ $# -lt 1 ] ; then
    echo ": no output file is specified."
    exit 1
fi

filePath=$1

if echo "$filePath" | grep -q "\/" ; then
    fileDir=${filePath%/*}
fi

if [ -n "$fileDir" ] && [ ! -d "$fileDir" ] ; then
    mkdir -p $fileDir
    if [ ! $? -eq 0 ] ; then
        echo "error: fail to create directory"
        exit 2
    fi
fi

cpufile=/proc/cpuinfo 
if [ ! -e "$cpufile" ] ; then
    echo "error: $cpufile: no such file or directory"
    exit 3
fi

cat $cpufile | grep -q "model\ name"
if [ ! $? -eq 0 ] ; then
    echo "error: no cpu modle name entry found"
    exit 4
fi

cat $cpufile | grep "model\ name" | sed -n '1p' | awk -F" " '{for(n=4;n<NF;n++) printf $n" "}' > $filePath
cat $cpufile | grep "model\ name" | sed -n '1p' | awk -F" " '{printf $NF}' >> $filePath

