#!/bin/sh
# mount partitions if any

DEV_NODE='/dev/sda'

# exit normally
ERR_NORMAL=0
ERR_MOUNT_SYSPART=11
ERR_MOUNT_DSKPART=12

source /usr/sbin/tc/global_def.sh

if ! df | grep "^${DISKDEV}" ; then
    mount ${DISKDEV} ${DISKDIR}
    if ! [ $? -eq 0 ] ; then
        exit $ERR_MOUNT_DSKPART
    fi
fi

if ! df | grep "^${DISKRSVD}" ; then
    mount ${DISKRSVD} ${RSVDDIR}
    if ! [ $? -eq 0 ] ; then
        exit $ERR_MOUNT_SYSPART
    fi
fi

echo -n "12345678" | md5sum | awk '{print $1}' >/mnt/disk/guest.passwd

if [ -f $SERVADDR_FILE ] ; then
    SERVER=`cat $SERVADDR_FILE `
fi

#if [ "x$INITIALIZATION_MODE" != "xUSB" ] ; then
    # notify server the client is Not being initalized
#    $TCDCLT_APP $SERVER eth0 12345 "${ACT_POWERON}: : "
	echo "1: :" >/tmp/tc-status.conf
#fi

exit $ERR_NORMAL
