#/bin/sh
# detect disks attached to the current machine and print details.
source import_debug.sh
#HOST_DEBUG=yes
if [ "x$HOST_DEBUG" == "x" ] ; then
    ROOT=
else
    ROOT=/localdisk/szl/fakeroot
fi
TMP_DIR=$ROOT/var/tc
CONF_DIR=$ROOT/etc/tc.conf.d
SCRIPT_DIR=$ROOT/usr/local/bin/script
MTDIR=$ROOT/mnt/disk

TMPFILE=$TMP_DIR/lba.tmp
EBRTMPFILE=$TMP_DIR/ebr_lba.tmp
CONFFILE=$CONF_DIR/partlist.conf

SCRIPT_PATH=$0
SCRIPT_NAME=${SCRIPT_PATH##*/}

if [ -n "$1" ] ; then
    CONFFILE=$1
fi

exec 5>&1 6>&2
exec 1>$TMP_DIR/detect_disk.log 2>&1
echo -n "" > $CONFFILE

disk_name_list=`fdisk -l | grep '^Disk' | grep '/dev/.*:' | awk '{print $2}' | sed 's/://'`
for disk in $disk_name_list ; do
    nLen=${#disk}
    endChar=${disk:$(expr $nLen - 1):$(expr $nLen - 1)}
    # if it is a digit
    if [ ! -z "${endChar##*[!0-9]*}" ] ; then
        continue
    fi

    VENDOR_FILE='/sys/block/'${disk##*/}'/device/vendor'
    MODEL_FILE='/sys/block/'${disk##*/}'/device/model'
    VENDOR=`cat ${VENDOR_FILE}`
    MODEL=`cat ${MODEL_FILE}`

    # remove spaces
    vn=""
    for vendor in $VENDOR ; do
        vn="${vn}${vendor}"
    done
    VENDOR=${vn}

    md=""
    for model in $MODEL ; do
        md="${md}${model}"
    done
    MODEL=${md}

    PHY_SECTOR_SZ_FILE='/sys/block/'${disk##*/}'/queue/hw_sector_size'
    PHY_SECTOR_SZ=`cat ${PHY_SECTOR_SZ_FILE}`
    DISK_SECTORS_FILE='/sys/block/'${disk##*/}'/size'
    DISK_SECTORS=`cat ${DISK_SECTORS_FILE}`

    #DISK_Bytes=`fdisk -l $disk | grep '^Disk' | grep '/dev/.*:' | awk '{print $5}' | sed 's/://'`
    DISK_Bytes=`echo "${DISK_SECTORS} * ${PHY_SECTOR_SZ}" | bc`
    DISK_CAPA=`sh $SCRIPT_DIR/calc_capa.sh $DISK_Bytes`
    DISK_KiB=`echo "${DISK_Bytes} / 1024" | bc`
    DISK_MiB=`echo "${DISK_KiB} / 1024" | bc`
    #DISK_GiB=`echo "${DISK_MiB} / 1024" | bc`
    #DISK_TiB=`echo "${DISK_GiB} / 1024" | bc`


    echo -n "${disk##*/} " >> $CONFFILE
    #echo -n "$disk " >> $CONFFILE
    echo -n "$DISK_Bytes " >> $CONFFILE
    echo -n "$VENDOR " >> $CONFFILE
    echo -n "$MODEL " >> $CONFFILE
    echo -n "$DISK_CAPA " >> $CONFFILE
    echo -n "$DISK_MiB " >> $CONFFILE
    echo "" >> $CONFFILE
done

exec 1>&5 2>&6
exec 5>&- 6>&-

exit 0

