#!/bin/sh
DISKDEV=/dev/sda
NIF=eth0
LOGFILE=/var/log/disk-initializer.1.log
LOGFILE2=/var/log/disk-initializer.2.log

exec 7>&1 8>&2
exec 1>$LOGFILE 2>&1

date "+%F %T"
echo ""

# wait for disk be detected
echo "wait for $DISKDEV be ready"
until [ -b $DISKDEV ] ; do
  echo -n "."
  sleep 1
done
echo ""

# wait for fdisk is ready
echo "wait for fdisk ultility be ready"
until fdisk -l 1>/dev/null 2>&1 ; do
  echo -n "."
  sleep 1
done
echo ""

# wait for network driver
echo "wait for network driver be ready"
until [ -f /proc/net/dev ] ; do
  echo -n "."
  sleep 1
done
echo ""

# wait for ifconfig ultility and nic
echo "wait for ifconfig ultility be ready"
until ifconfig | grep -q "^${NIF}" ; do
  echo -n "."
  sleep 1
done
echo ""

export TERM=linux
/usr/local/bin/initializer >&7 2>$LOGFILE2
ret=$?

echo "exitCode = $ret"

exec 1>&7 2>&8
exec 7>&- 8>&-

