#!/bin/bash
RAMDISK_DIR=$(pwd)

TC_BUILD_DIR=/root/TC
BR2_DIR=/root/TC/buildroot-2016.08.1
BR2_OUT_DIR=$BR2_DIR/output
BR2_BUILD_DIR=$BR2_OUT_DIR/build
BR2_TARGET_DIR=$BR2_OUT_DIR/target
TC_FONT_DIR=$TC_BUILD_DIR/fonts

CROSS_PREFIX='/root/TC/buildroot-2016.08.1/output/host/usr/bin'
if ! echo $PATH | grep -q "$CROSS_PREFIX" ; then
    PATH=$PATH:$CROSS_PREFIX
fi

## hdboot_diff
echo "copy hdboot binaries..."
HDBOOT_DIR=$RAMDISK_DIR/hdboot_diff
GRUB_DIR=/root/TC/grub-0.97
cd $GRUB_DIR
mkdir -p $HDBOOT_DIR/usr/share/boot/grub
cp --remove-destination stage2/fat_stage1_5 $HDBOOT_DIR/usr/share/boot/grub/
cp --remove-destination stage2/e2fs_stage1_5 $HDBOOT_DIR/usr/share/boot/grub/
cp --remove-destination stage1/stage1 $HDBOOT_DIR/usr/share/boot/grub/
cp --remove-destination stage2/stage2 $HDBOOT_DIR/usr/share/boot/grub/
cp --remove-destination grub/grub $HDBOOT_DIR/usr/sbin/


## iso
cp /usr/share/syslinux/isolinux.bin $RAMDISK_DIR/iso/isolinux/

## mtf_diff
echo "copy libmeegotouch binaries..."
MEEGO_LIB_DIR=/root/qte/libmeegotouch-0.23.5-1
MTF_DIR=$RAMDISK_DIR/mtf_diff
cp -a --remove-destination $MEEGO_LIB_DIR/lib/libmeegotouchcore.so* $MTF_DIR/usr/lib/
cp -a --remove-destination $MEEGO_LIB_DIR/lib/libmeegotouchviews.so* $MTF_DIR/usr/lib/
cp $MEEGO_LIB_DIR/src/translations/libmeegotouch_en.qm $MTF_DIR/usr/share/l10n/meegotouch/
cp $MEEGO_LIB_DIR/src/translations/libmeegotouch_zh_CN.qm $MTF_DIR/usr/share/l10n/meegotouch/
#cp $MEEGO_LIB_DIR/src/translations/libmeegotouch.qm $MTF_DIR/usr/share/l10n/meegotouch/
# strip
strip $MTF_DIR/usr/lib/libmeegotouchcore.so.0.23.5
strip $MTF_DIR/usr/lib/libmeegotouchviews.so.0.23.5
# font
cp $TC_FONT_DIR/* $MTF_DIR/usr/lib/fonts/


## ntfs
echo "copy ntfs binaries..."
NTFS_DIR=$RAMDISK_DIR/ntfs_diff
cd $BR2_TARGET_DIR
cp -a --remove-destination --parents usr/bin/ntfs-3g $NTFS_DIR/
cp -a --remove-destination --parents usr/sbin/mkntfs $NTFS_DIR/
cp -a --remove-destination --parents usr/lib/libntfs-3g.so* $NTFS_DIR/
cp -a --remove-destination --parents sbin/mkfs.ntfs $NTFS_DIR/
cp -a --remove-destination --parents sbin/mount.ntfs-3g $NTFS_DIR/
cp -a --remove-destination --parents usr/bin/ntfscat $NTFS_DIR/
cp -a --remove-destination --parents usr/bin/ntfsinfo $NTFS_DIR/

## qte_diff
echo "copy QT binaries..."
QTE_DIR=$RAMDISK_DIR/qte_diff
EXPAT_BUILD_DIR=/root/TC/expat-2.0.1
cp -a --remove-destination $EXPAT_BUILD_DIR/.libs/libexpat.so* $QTE_DIR/usr/lib/
mkdir -p $QTE_DIR/etc/dbus-1
DBUS_BUILD_DIR=/root/TC/dbus-1.4.10
cp -av $DBUS_BUILD_DIR/test/data/valid-config-files/session.d $QTE_DIR/etc/dbus-1
cp -av $DBUS_BUILD_DIR/test/data/valid-config-files/session.conf $QTE_DIR/etc/dbus-1
cp -av $DBUS_BUILD_DIR/bus/dbus-daemon $QTE_DIR/usr/bin/
cp -av $DBUS_BUILD_DIR/tools/dbus-launch $QTE_DIR/usr/bin/
cp -av $DBUS_BUILD_DIR/dbus/.libs/libdbus-1.so* $QTE_DIR/usr/lib/
QT_LIB_DIR=/root/qte/qt-everywhere-opensource-src-4.7.3
QT_HOST_DIR=/root/TC/qt-everywhere-opensource-src-4.7.3
cd $QT_LIB_DIR
cp -a --remove-destination --parents lib/libQtCore.so* $QTE_DIR/usr/
cp -a --remove-destination --parents lib/libQtDBus.so* $QTE_DIR/usr/
cp -a --remove-destination --parents lib/libQtGui.so* $QTE_DIR/usr/
cp -a --remove-destination --parents lib/libQtNetwork.so* $QTE_DIR/usr/
cp -a --remove-destination --parents lib/libQtSvg.so* $QTE_DIR/usr/
cp -a --remove-destination --parents lib/libQtXml.so* $QTE_DIR/usr/
cp -a --remove-destination --parents lib/fonts/DejaVuSans-Oblique.ttf $QTE_DIR/usr/
cp -a --remove-destination --parents lib/fonts/DejaVuSans.ttf $QTE_DIR/usr/
cp -a --remove-destination --parents lib/fonts/DejaVuSans-BoldOblique.ttf $QTE_DIR/usr/
cp -a --remove-destination --parents lib/fonts/DejaVuSans-Bold.ttf $QTE_DIR/usr/
cp -a --remove-destination --parents lib/fonts/DejaVuSerif-BoldOblique.ttf $QTE_DIR/usr/
cp -a --remove-destination --parents lib/fonts/DejaVuSerif-Bold.ttf $QTE_DIR/usr/
cp -a --remove-destination --parents lib/fonts/DejaVuSerif-Oblique.ttf $QTE_DIR/usr/
cp -a --remove-destination --parents lib/fonts/DejaVuSerif.ttf $QTE_DIR/usr/
cp -a --remove-destination --parents plugins/iconengines $QTE_DIR/usr/lib/qt-4.7.3/
cp -a --remove-destination --parents plugins/imageformats $QTE_DIR/usr/lib/qt-4.7.3/
strip $QTE_DIR/usr/lib/libexpat.so.1.5.2
strip $QTE_DIR/usr/lib/libdbus-1.so.3.5.6
strip $QTE_DIR/usr/lib/libQtCore.so.4.7.3
strip $QTE_DIR/usr/lib/libQtDBus.so.4.7.3
strip $QTE_DIR/usr/lib/libQtGui.so.4.7.3
strip $QTE_DIR/usr/lib/libQtNetwork.so.4.7.3
strip $QTE_DIR/usr/lib/libQtSvg.so.4.7.3
strip $QTE_DIR/usr/lib/libQtXml.so.4.7.3

## rootfs/etc
echo "copy rootfs/etc binaries..."
ROOTFS_DIR=$RAMDISK_DIR/rootfs
cd $BR2_TARGET_DIR
cp -a --remove-destination --parents etc/nsswitch.conf $ROOTFS_DIR/


## rootfs/lib
echo "copy rootfs binaries..."
ROOTFS_DIR=$RAMDISK_DIR/rootfs
cd $BR2_TARGET_DIR
cp -a --remove-destination --parents lib/ld-2.23.so $ROOTFS_DIR/
cp -a --remove-destination --parents lib/ld-linux.so.2 $ROOTFS_DIR/
cp -a --remove-destination --parents lib/libc-2.23.so $ROOTFS_DIR/
cp -a --remove-destination --parents lib/libcrypt-2.23.so $ROOTFS_DIR/
cp -a --remove-destination --parents lib/libcrypt.so.1 $ROOTFS_DIR/
cp -a --remove-destination --parents lib/libc.so.6 $ROOTFS_DIR/
cp -a --remove-destination --parents lib/libdl-2.23.so $ROOTFS_DIR/
cp -a --remove-destination --parents lib/libdl.so.2 $ROOTFS_DIR/
cp -a --remove-destination --parents lib/libgcc_s.so $ROOTFS_DIR/
cp -a --remove-destination --parents lib/libgcc_s.so.1 $ROOTFS_DIR/
cp -a --remove-destination --parents lib/libm-2.23.so $ROOTFS_DIR/
cp -a --remove-destination --parents lib/libm.so.6 $ROOTFS_DIR/
cp -a --remove-destination --parents lib/libnsl-2.23.so $ROOTFS_DIR/
cp -a --remove-destination --parents lib/libnsl.so.1 $ROOTFS_DIR/
cp -a --remove-destination --parents lib/libnss_files-2.23.so $ROOTFS_DIR/
cp -a --remove-destination --parents lib/libnss_files.so.2 $ROOTFS_DIR/
cp -a --remove-destination --parents lib/libpthread-2.23.so $ROOTFS_DIR/
cp -a --remove-destination --parents lib/libpthread.so.0 $ROOTFS_DIR/
cp -a --remove-destination --parents lib/libresolv-2.23.so $ROOTFS_DIR/
cp -a --remove-destination --parents lib/libresolv.so.2 $ROOTFS_DIR/
cp -a --remove-destination --parents lib/librt-2.23.so $ROOTFS_DIR/
cp -a --remove-destination --parents lib/librt.so.1 $ROOTFS_DIR/
cp -a --remove-destination --parents lib/libutil-2.23.so $ROOTFS_DIR/
cp -a --remove-destination --parents lib/libutil.so.1 $ROOTFS_DIR/
cd /
cp -a --remove-destination --parents lib/firmware/rtl_nic/rtl8168h-2.fw $ROOTFS_DIR/
cp -a --remove-destination --parents lib/firmware/rtl_nic/rtl8168e-3.fw $ROOTFS_DIR/

## rootfs/sbin
cd $BR2_TARGET_DIR/usr
cp -a --remove-destination --parents sbin/e2fsck $ROOTFS_DIR/
cp -a --remove-destination /root/TC/e2fsprogs-1.42/e2fsck/e2fsck $ROOTFS_DIR/sbin/
strip $ROOTFS_DIR/sbin/e2fsck
cp -a --remove-destination --parents sbin/mke2fs $ROOTFS_DIR/
cp -a --remove-destination --parents sbin/mkfs.ext2 $ROOTFS_DIR/
## rootfs/usr
cd $BR2_TARGET_DIR
cp -a --remove-destination --parents usr/bin/wget $ROOTFS_DIR/
cp -a --remove-destination --parents usr/lib/libstdc++.so $ROOTFS_DIR/
cp -a --remove-destination --parents usr/lib/libstdc++.so.6 $ROOTFS_DIR/
cp -a --remove-destination --parents usr/lib/libstdc++.so.6.0.20 $ROOTFS_DIR/
cp -a --remove-destination --parents usr/lib/libssl.so $ROOTFS_DIR/
cp -a --remove-destination --parents usr/lib/libssl.so.1.0.0 $ROOTFS_DIR/
cp -a --remove-destination --parents usr/lib/libcrypto.so $ROOTFS_DIR/
cp -a --remove-destination --parents usr/lib/libcrypto.so.1.0.0 $ROOTFS_DIR/
cd /lib
cp -a --remove-destination --parents terminfo/l/linux $ROOTFS_DIR/usr/share/
BUSYBOX_DIR=/root/TC/busybox-1.25.1
cp -a --remove-destination $BUSYBOX_DIR/examples/udhcp/simple.script $ROOTFS_DIR/usr/share/udhcpc/default.script

## busybox
echo "copy rootfs binaries..."
ROOTFS_DIR=$RAMDISK_DIR/rootfs
BUSYBOX_DIR=/root/TC/busybox-1.25.1
cd $BUSYBOX_DIR
make
make CONFIG_PREFIX="$ROOTFS_DIR" install

## tc_diff
echo "copy tc binaries..."
TC_DIFF_DIR=$RAMDISK_DIR/tc_diff
cd $BR2_TARGET_DIR
cp -a --remove-destination --parents usr/bin/jq $TC_DIFF_DIR/
cp -a --remove-destination $BR2_BUILD_DIR/jq-1.5/.libs/libjq.so* $ROOTFS_DIR/usr/lib/
strip $ROOTFS_DIR/usr/lib/libjq.so.1.0.4

# kexec
cd $BR2_TARGET_DIR
cp -a --remove-destination --parents usr/sbin/kexec $TC_DIFF_DIR/
# rsync
#cp -a --remove-destination usr/bin/rsync $TC_DIFF_DIR/usr/sbin/
cp -a $TC_BUILD_DIR/rsync-3.1.2/rsync $TC_DIFF_DIR/usr/sbin/

## test_diff
echo "copy test binaries..."
TEST_DIR=$RAMDISK_DIR/test_diff
cp -a --remove-destination $QT_HOST_DIR/examples/widgets/codeeditor/codeeditor $TEST_DIR/usr/bin/
cp -a --remove-destination $MEEGO_LIB_DIR/demos/widgetsgallery/widgetsgallery $TEST_DIR/usr/bin/
cp -a --remove-destination $MEEGO_LIB_DIR/demos/widgetsgallery/data/media/photo_450x450_021.jpg $TEST_DIR/usr/share/widgetsgallery/media/
cp -a --remove-destination $MEEGO_LIB_DIR/demos/widgetsgallery/theme/base/widgetsgallery.conf $TEST_DIR/usr/share/themes/base/meegotouch/widgetsgallery/
cp -a --remove-destination $MEEGO_LIB_DIR/demos/widgetsgallery/theme/base/images $TEST_DIR/usr/share/themes/base/meegotouch/widgetsgallery/
cp -a --remove-destination $MEEGO_LIB_DIR/demos/widgetsgallery/theme/base/style $TEST_DIR/usr/share/themes/base/meegotouch/widgetsgallery/
cp -a --remove-destination $MEEGO_LIB_DIR/demos/widgetsgallery/theme/base/svg $TEST_DIR/usr/share/themes/base/meegotouch/widgetsgallery/
strip $TEST_DIR/usr/bin/codeeditor
strip $TEST_DIR/usr/bin/widgetsgallery
# cannot find icons

## usbtool_bc_diff
echo "copy usbtool_bc binaries..."
BC_DIR=$RAMDISK_DIR/usbtool_bc_diff
cd $BR2_TARGET_DIR
cp -a --remove-destination --parents usr/bin/bc $BC_DIR/

## usbtool_cifs_diff
echo "copy usbtool_cifs binaries..."
CIFS_DIR=$RAMDISK_DIR/usbtool_cifs_diff
# some files missing in the buildroot output
cd $BR2_TARGET_DIR
cp -a --remove-destination --parents sbin/mount.cifs $CIFS_DIR/
cp -a --remove-destination --parents usr/bin/cifsdd $CIFS_DIR/

## usbtool_diff
# done in Makefile.rel

## usbtool_file_diff
echo "copy usbtool binaries..."
FILE_DIR=$RAMDISK_DIR/usbtool_file_diff
cd $BR2_TARGET_DIR
cp -a --remove-destination --parents usr/bin/file $FILE_DIR/
cp -a --remove-destination --parents usr/lib/libmagic.so* $FILE_DIR/
cp -a --remove-destination --parents usr/share/misc/magic.mgc $FILE_DIR/

## usbtool_newt_diff
echo "copy usbtool_newt binaries..."
NEWT_DIR=$RAMDISK_DIR/usbtool_newt_diff
cd $BR2_TARGET_DIR
cp -a --remove-destination --parents usr/lib/libnewt.so* $NEWT_DIR/
cp -a --remove-destination --parents usr/lib/libslang.so* $NEWT_DIR/
strip $NEWT_DIR/usr/lib/libnewt.so* 
strip $NEWT_DIR/usr/lib/libslang.so* 

## usbtool_samba_diff
echo "copy usbtool_samba binaries..."
SAMBA_DIR=$RAMDISK_DIR/usbtool_samba_diff
cd $BR2_TARGET_DIR
# usr/bin
cp -a --remove-destination --parents usr/bin/smbclient $SAMBA_DIR/
cp -a --remove-destination --parents usr/bin/smbtree $SAMBA_DIR/
cp -a --remove-destination --parents usr/bin/testparm $SAMBA_DIR/

cp -a --remove-destination --parents \
                 usr/lib/libdcerpc-binding.so \
                 usr/lib/libdcerpc-binding.so.0 \
                 usr/lib/libdcerpc-binding.so.0.0.1 \
                 usr/lib/libdcerpc-samr.so \
                 usr/lib/libdcerpc-samr.so.0 \
                 usr/lib/libdcerpc-samr.so.0.0.1 \
                 usr/lib/libdcerpc.so \
                 usr/lib/libdcerpc.so.0 \
                 usr/lib/libdcerpc.so.0.0.1 \
                 usr/lib/libncurses.so \
                 usr/lib/libncurses.so.5 \
                 usr/lib/libncurses.so.5.9 \
                 usr/lib/libndr-krb5pac.so \
                 usr/lib/libndr-krb5pac.so.0 \
                 usr/lib/libndr-krb5pac.so.0.0.1 \
                 usr/lib/libndr-nbt.so \
                 usr/lib/libndr-nbt.so.0 \
                 usr/lib/libndr-nbt.so.0.0.1 \
                 usr/lib/libndr.so \
                 usr/lib/libndr.so.0 \
                 usr/lib/libndr.so.0.0.5 \
                 usr/lib/libndr-standard.so \
                 usr/lib/libndr-standard.so.0 \
                 usr/lib/libndr-standard.so.0.0.1 \
                 usr/lib/libpopt.so \
                 usr/lib/libpopt.so.0 \
                 usr/lib/libpopt.so.0.0.0 \
                 usr/lib/libreadline.so \
                 usr/lib/libreadline.so.6 \
                 usr/lib/libreadline.so.6.3 \
                 usr/lib/libsamba-credentials.so \
                 usr/lib/libsamba-credentials.so.0 \
                 usr/lib/libsamba-credentials.so.0.0.1 \
                 usr/lib/libsamba-errors.so \
                 usr/lib/libsamba-errors.so.1 \
                 usr/lib/libsamba-hostconfig.so \
                 usr/lib/libsamba-hostconfig.so.0 \
                 usr/lib/libsamba-hostconfig.so.0.0.1 \
                 usr/lib/libsamba-passdb.so \
                 usr/lib/libsamba-passdb.so.0 \
                 usr/lib/libsamba-passdb.so.0.25.0 \
                 usr/lib/libsamba-policy.so \
                 usr/lib/libsamba-policy.so.0 \
                 usr/lib/libsamba-policy.so.0.0.1 \
                 usr/lib/libsamba-util.so \
                 usr/lib/libsamba-util.so.0 \
                 usr/lib/libsamba-util.so.0.0.1 \
                 usr/lib/libsamdb.so \
                 usr/lib/libsamdb.so.0 \
                 usr/lib/libsamdb.so.0.0.1 \
                 usr/lib/libsmbclient.so \
                 usr/lib/libsmbclient.so.0 \
                 usr/lib/libsmbclient.so.0.2.3 \
                 usr/lib/libsmbconf.so \
                 usr/lib/libsmbconf.so.0 \
                 usr/lib/libtevent-unix-util.so \
                 usr/lib/libtevent-unix-util.so.0 \
                 usr/lib/libtevent-unix-util.so.0.0.1 \
                 usr/lib/libtevent-util.so \
                 usr/lib/libtevent-util.so.0 \
                 usr/lib/libtevent-util.so.0.0.1 \
                 usr/lib/libwbclient.so \
                 usr/lib/libwbclient.so.0 \
                 usr/lib/libwbclient.so.0.12 \
                 usr/lib/libz.so \
                 usr/lib/libz.so.1 \
                 usr/lib/libz.so.1.2.8 \
                 $SAMBA_DIR/
cp -a --remove-destination --parents usr/lib/samba $SAMBA_DIR/

cd $SAMBA_DIR/

strip $SAMBA_DIR/usr/bin/smbclient 
strip $SAMBA_DIR/usr/bin/smbtree
strip $SAMBA_DIR/usr/bin/testparm
strip \
                 usr/lib/libdcerpc-binding.so.0.0.1 \
                 usr/lib/libdcerpc-samr.so.0.0.1 \
                 usr/lib/libdcerpc.so.0.0.1 \
                 usr/lib/libndr-krb5pac.so.0.0.1 \
                 usr/lib/libndr-nbt.so.0.0.1 \
                 usr/lib/libndr.so.0.0.5 \
                 usr/lib/libndr-standard.so.0.0.1 \
                 usr/lib/libpopt.so.0.0.0 \
                 usr/lib/libsamba-credentials.so.0.0.1 \
                 usr/lib/libsamba-errors.so.1 \
                 usr/lib/libsamba-hostconfig.so.0.0.1 \
                 usr/lib/libsamba-passdb.so.0.25.0 \
                 usr/lib/libsamba-policy.so.0.0.1 \
                 usr/lib/libsamba-util.so.0.0.1 \
                 usr/lib/libsamdb.so.0.0.1 \
                 usr/lib/libsmbclient.so.0.2.3 \
                 usr/lib/libsmbconf.so.0 \
                 usr/lib/libtevent-unix-util.so.0.0.1 \
                 usr/lib/libtevent-util.so.0.0.1 \
                 usr/lib/libwbclient.so.0.12 \
                 usr/lib/libz.so.1.2.8

## usbtool_tune2fs_diff
echo "copy usbtool_tune2fs binaries..."
TUNE2FS_DIR=$RAMDISK_DIR/usbtool_tune2fs_diff
cd $BR2_TARGET_DIR
cp -a --remove-destination --parents lib/libblkid.so* $TUNE2FS_DIR/
cp -a --remove-destination --parents lib/libuuid.so* $TUNE2FS_DIR/
cp -a --remove-destination usr/sbin/e2label $TUNE2FS_DIR/sbin/
cp -a --remove-destination usr/sbin/tune2fs $TUNE2FS_DIR/sbin/
cp -a --remove-destination --parents \
                 usr/lib/libblkid.so \
                 usr/lib/libcom_err.so \
                 usr/lib/libcom_err.so.2 \
                 usr/lib/libcom_err.so.2.1 \
                 usr/lib/libe2p.so \
                 usr/lib/libe2p.so.2 \
                 usr/lib/libe2p.so.2.3 \
                 usr/lib/libext2fs.so \
                 usr/lib/libext2fs.so.2 \
                 usr/lib/libext2fs.so.2.4 \
                 usr/lib/libuuid.so \
                 $TUNE2FS_DIR/
strip \
                 $TUNE2FS_DIR/lib/libblkid.so.1.1.0 \
                 $TUNE2FS_DIR/lib/libuuid.so.1.3.0 \
                 $TUNE2FS_DIR/usr/lib/libcom_err.so.2.1 \
                 $TUNE2FS_DIR/usr/lib/libe2p.so.2.3 \
                 $TUNE2FS_DIR/usr/lib/libext2fs.so.2.4 


## usbtool_findfs_diff
FINDFS_DIR=$RAMDISK_DIR/usbtool_findfs_diff
echo "copy usbtool_findfs binaries..."
cd $BR2_TARGET_DIR
cp -a --remove-destination --parents sbin/findfs $FINDFS_DIR/

# curl utils
CURL_DIR=$TC_BUILD_DIR/curl-7.57.0
CURL_DIFF_DIR=$RAMDISK_DIR/curl_diff
echo "install curl"
cd $CURL_DIR
cp -a --remove-destination src/.libs/curl $CURL_DIFF_DIR/usr/bin
#cp -a --remove-destination src/.libs/lt-curl $CURL_DIFF_DIR/usr/bin
cp -a --remove-destination \
                 lib/.libs/libcurl.so \
                 lib/.libs/libcurl.so.4 \
                 lib/.libs/libcurl.so.4.5.0 \
                 $CURL_DIFF_DIR/usr/lib

# qemu_diff
echo "copy qemu libraries"
QEMU_DIFF_DIR=$RAMDISK_DIR/qemu_diff
cd $BR2_TARGET_DIR
cp -a --remove-destination --parents -t $QEMU_DIFF_DIR/ \
                 usr/lib/libglib-2.0.so* \
                 usr/lib/libgthread-2.0.so* \
                 usr/lib/libpixman-1.so* \
                 usr/lib/libSDL* \
                 usr/lib/libpcre.so*
QEMU_DIR=$TC_BUILD_DIR/qemu-2.10.1
cd $QEMU_DIR
cp -a --remove-destination i386-softmmu/qemu-system-i386 $QEMU_DIFF_DIR/usr/bin/
# the qemu binary is quite large, just strip it, 30MiB -> 8.7MiB
strip $QEMU_DIFF_DIR/usr/bin/qemu-system-i386
cd $BR2_TARGET_DIR
cp -a --remove-destination --parents usr/share/qemu $QEMU_DIFF_DIR/


# lz4
LZ4_DIR=$TC_BUILD_DIR/lz4-1.8.1.2
P2P_DIFF_DIR=$RAMDISK_DIR/lp2p_diff
cd $LZ4_DIR
cp -a --remove-destination lib/liblz4.so* $P2P_DIFF_DIR/usr/lib

# wpa_cli
# wpa_supplicant
echo "copy wpa_cli and wpa_supplicant libs and binaries"
WPA_DIR=$RAMDISK_DIR/wpa_diff
cd $BR2_TARGET_DIR
cp -a --remove-destination --parents -t $WPA_DIR/ \
                 usr/lib/libnl-3.so* \
                 usr/lib/libnl-genl-3.so* \
                 usr/sbin/wpa_cli \
                 usr/sbin/wpa_supplicant
RT2860BIN="/lib/firmware/rt2860.bin"
if [ -f $RT2860BIN ] ; then
  cp -f $RT2860BIN $WPA_DIR/lib/firmware
else
  echo "$RT2860BIN : no such file"
fi

## Traffic Control
TrafficControlLib=$BR2_DIR/output/build/iproute2-4.5.0/tc/tc
if [ -f $TrafficControlLib ] ; then
  cp -f $TrafficControlLib $ROOTFS_DIR/sbin
else
  echo "$TrafficControlLib : no such file"
fi

# Generate rootfs/lib/modules
echo "install linux bzImage & modules..."
ROOTFS_DIR=$RAMDISK_DIR/rootfs
LINUX_DIR=/root/TC/linux-3.18.40
cd $LINUX_DIR
make bzImage
make modules
make INSTALL_MOD_PATH="$ROOTFS_DIR" modules_install
cp $LINUX_DIR/arch/x86/boot/bzImage $HDBOOT_DIR/usr/share/boot/


