#!/bin/sh

. /usr/sbin/tc/global_def.sh

if [ -z "$1" -o -z "$2" -o -z "$3" -o -z "$4" ] ; then
  echo "Usage: _lp2pget_img.sh <username> <target_path> <remote_name> <local_name>"
  exit 1
fi

if [ -n "$5" ] ; then
  SERVER=$5
  echo SERVER=$5
fi

LOG_FILE=/tmp/p2p-dbg.log

NODE_NAME=$1
TARGET_PATH=$2
TARGET_FILE=$4
SEED_URL=seeds/$3.seed
CACHE_URL=seeds/$3.cache
SEED_FILE=$DOWNDIR/$4.seed
CACHE_FILE=$DOWNDIR/$4.cache
CACHE_TEMP=/tmp/$4.cache

# if "Network is unreachable", wget will not retry, add "--retry-connrefused"
wget $WGET_OPTS --tries=2 --timeout=1 --retry-connrefused -nv $HTTP_PROT://$DOMAINNAME/$SEED_URL -O $SEED_FILE
if [ $? -ne 0 ] ; then
  echo "get seed file failed"
  exit 61
fi

# use "-e" not "-f" for /dev/sda
if [ ! -e $TARGET_PATH/$TARGET_FILE ] ; then
  rm -f $CACHE_FILE
fi
if [ ! -f $CACHE_FILE ] ; then

  # del if is regular file
  if [ -f $TARGET_PATH/$TARGET_FILE ] ; then
    rm -f $TARGET_PATH/$TARGET_FILE
  fi

  wget $WGET_OPTS --tries=2 --timeout=1 --retry-connrefused -nv $HTTP_PROT://$DOMAINNAME/$CACHE_URL -O $CACHE_FILE
  if [ $? -ne 0 ] ; then
    echo "no cache file on server"
    rm -f $CACHE_FILE
  fi
fi

if [ -f $CACHE_FILE ] ; then
  cp -f $CACHE_FILE $CACHE_TEMP
fi
$TCDIR/p2p-node-lite $SERVER $NODE_NAME $TARGET_PATH/$TARGET_FILE $SEED_FILE 2 $CACHE_TEMP 2>$LOG_FILE
ret=$?

cp $LOG_FILE $DISKDIR/

if [ $ret -ne 0 ] ; then
  echo "keep the files for resume"
  sync
  mv -f $CACHE_TEMP $CACHE_FILE
  exit 62
fi

rm -f $SEED_FILE $CACHE_FILE $CACHE_TEMP

exit 0
