#!/bin/sh
alias cp='/bin/cp -f'
alias mv='/bin/mv -fv'
alias rm='/bin/rm -f'
alias mkdir='/bin/mkdir -p'
export cp mv rm mkdir

ISO_DIR='iso_tempfs'

mkdir -p ${ISO_DIR}/isolinux

cp -f /root/TC/linux-3.18.40/arch/x86/boot/bzImage ${ISO_DIR}/

source ./mkrootfs

cp -f rootfs.cpio.gz ${ISO_DIR}/initrd.img

cp -f /usr/share/syslinux/isolinux.bin iso/isolinux/
cp -au iso/isolinux/isolinux.bin ${ISO_DIR}/isolinux/
cp -au iso/isolinux/isolinux.cfg ${ISO_DIR}/isolinux/
cat >${ISO_DIR}/isolinux/isolinux.cfg <<EOT
prompt 0
default linux
label linux
   kernel /bzImage
   append initrd=/initrd.img quiet console=ttyS0 bootenv=4
EOT

mkisofs -J -o out.iso -b isolinux/isolinux.bin -c isolinux/boot.cat -no-emul-boot -boot-load-size 4 -boot-info-table -input-charset cp437 ${ISO_DIR}/
isohybrid out.iso

mv -f out.iso tc-initializer.iso

if [ -d "${ISO_DIR}" ] ; then
    rm -rf ${ISO_DIR}
fi
