#!/bin/sh

. /usr/sbin/tc/global_def.sh

if [ -z "$1" -o -z "$2" -o -z "$3" -o -z "$4" ] ; then
  echo "Usage: _local-update.sh <curimg> <username> <osid> <orgimg>"
  exit 1
fi

if [ ! $DISKDIR/$4 ] ; then
  echo "$0: base img not exist"
  exit 2
fi

updated=3

VERFILE=$DISKDIR/$4.ver

while [ true ] ; do
  os_ver=`cat $VERFILE`
  echo "$0: cur_ver=$os_ver"
  nver_file=$DOWNDIR/$4.$os_ver.nver

  if [ ! -f $nver_file ] ; then
    echo "$0: OS patch(ver=$os_ver) not exist"
    break
  fi

  echo "<$UPGRADING $4>"
  $MERGE_IMG $DISKDIR/$4 $DOWNDIR/$4.$os_ver.mdf $DOWNDIR/$4.$os_ver.udf
  if [ $? -ne 0 ] ; then
    echo "$0: merge failed"
    break
  fi

  cat $nver_file >$VERFILE

  rm -f $DOWNDIR/$4.$os_ver.*

  updated=0
done

exit $updated

