#!/bin/sh

. /usr/sbin/tc/global_def.sh

if [ -z "$1" -o -z "$2" -o -z "$3" -o -z "$4" ] ; then
  echo "Usage: _skip-updates.sh <curimg> <username> <osid> <orgimg>"
  exit 1
fi

SKIP_FILE=$DISKDIR/skip.$4-$2

noskip=1

if [ "x$2" == "xadmin" ] ; then
  echo "admin should do update"
  exit $noskip
fi

if [ ! -f $DISKDIR/$4 ] ; then
  echo "no osimg, should do update"
  exit $noskip
fi


skips=$SKIP_UPDATE_LIMIT
if [ -f $SKIP_FILE ] ; then
  skips=`cat $SKIP_FILE`
fi
echo "left skips=$skips"

if [ $skips -le 0 ] ; then
  echo "reach skip limit"
  rm -f $SKIP_FILE
  exit $noskip
fi


rm -f $SKIP_UPDATE_PIPE
mkfifo $SKIP_UPDATE_PIPE

. $DBUSENV
$NOTIFY_APP 11 $SKIP_UPDATE_DELAY

noskip=`cat $SKIP_UPDATE_PIPE`
if [ $noskip -eq 0 ] ; then
  echo "user want to skip update"
  skips=$((skips-1))
  echo $skips >$SKIP_FILE
else
  echo "user want to do update"
  rm -f $SKIP_FILE
fi

exit $noskip

