#!/bin/sh

. /usr/sbin/tc/global_def.sh

if [ -z "$1" ] ; then
  echo "Usage: admin-auth.sh password"
  exit 1
fi

if [ -f $SERVADDR_FILE ] ; then
  SERVER=`cat $SERVADDR_FILE`
  echo SERVER=$SERVER
fi

shaval=`echo -n "$1:admin" | sha256sum | awk '{print $1}'`
curl $CURL_OPTS -X POST --output $AUTH_JSON -H "Content-Type: application/json" -d '{"username":"admin","password":"'$shaval'"}' $HTTP_PROT://$DOMAINNAME/$AUTH_URL
if [ $? -ne 0 ] ; then
  echo "curl failed, use local pwd"
  passwd=`cat $TCDIR/$ADMINPWD_FILE`
  if [ "$1"x != "$passwd"x ] ; then
    echo "wrong password"
    exit 4
  fi
else
  ret_auth=`jq -r '.success' $AUTH_JSON`
  if [ "$ret_auth"x != "true"x ] ; then
    echo "auth failed"
    exit 4
  fi
fi

exit 0
