#!/bin/sh

. /usr/sbin/tc/global_def.sh

if [ -f $SERVADDR_FILE ] ; then
  SERVER=`cat $SERVADDR_FILE`
fi

for uuidfile in $(ls -1 $DISKDIR/*.uuid) ; do
  uuid=`cat $uuidfile`
  osimg=`basename ${uuidfile%.uuid}`
  echo "$0: osimg=$osimg, uuid=$uuid"

  wget $WGET_OPTS --tries=3 --timeout=1 --retry-connrefused $HTTP_PROT://$DOMAINNAME/"$OSUUID_URL"uuid=$uuid -O $OSUUID_JSON
  if [ $? -ne 0 ] ; then
    echo "$0: wget failed"
    continue
  fi

  imgpath=`jq -r '.result.path' $OSUUID_JSON`
  newimg=`basename $imgpath`
  if [ -z "$newimg" ] ; then
    echo "$0: empty newimg name"
    continue
  fi

  newid=`jq -r '.result.ciid' $OSUUID_JSON`
  newver=`jq -r '.result.revision' $OSUUID_JSON`
  if [ -n "$newid" -a -n "$newver" ] ; then
    echo $newid >$DISKDIR/$newimg.id
    echo $newver >$DISKDIR/$newimg.ver
  fi

  if [ "$newimg" == "$osimg" ] ; then
    echo "$0: equal img name"
    continue
  fi

  for file in $(ls -1 $DISKDIR/$osimg*) ; do
    oldname=`basename $file`
    newname=`echo $oldname | sed -r "s|^$osimg|$newimg|"`
    echo "$0: $oldname -> $newname"
    mv -f $DISKDIR/$oldname $DISKDIR/$newname
  done
done
