#!/bin/sh

. /usr/sbin/tc/global_def.sh

if [ -n "$1" ] ; then
  SERVER=$1
  echo SERVER=$1
fi

if [ ! -f $AUTO_LOGIN_FILE ] ; then
  echo "get auto boot info failed"
  exit 2
fi

if [ -f $AUTO_LOGIN_FILE ] ; then
  argv=`awk -F ':' '{printf("AUTOBOOT_USER=%s;AUTOBOOT_DELAY=%s;os_id=%s;os_id_g=%s;os_img=%s;os_img_g=%s",$1,$2,$3,$4,$5,$6)}' $AUTO_LOGIN_FILE`
  eval $argv
fi

if [ $os_id -eq -1 ] ; then
  echo "use global setting"
  os_id=$os_id_g
  os_img=$os_img_g
fi
if [ $os_id -eq 0 ] ; then
  echo "no auto boot info"
  exit 0
fi

. /tmp/dbusenv.sh
cnt=0
until [ $cnt -ge 10 ] ;
do
  $NOTIFY_APP 1 $AUTOBOOT_USER $AUTOBOOT_PASS $AUTOBOOT_DELAY $os_img $os_id>>$NOTIFY_LOG 2>&1
  if [ $? -eq 0 ] ; then
    sleep 5
    break;
  fi

  echo "notify failed, try again"
  sleep 3

  cnt=$((cnt+1))
done

exit 0
