#!/bin/sh

. /usr/sbin/tc/global_def.sh

if [ -n "$1" ] ; then
  SERVER=$1
  echo SERVER=$1
fi

cli_ver=`cat $VERSION_FILE`

wget $WGET_OPTS --tries=10 --timeout=3 --retry-connrefused $HTTP_PROT://$DOMAINNAME/$FWVER_URL -O $FWVER_JSON
if [ $? -ne 0 ] ; then
  echo "get firmware version info failed"
  exit 2
fi
ser_ver=`jq -r '.result.filesystem[0]' $FWVER_JSON`

echo "fw version: client=$cli_ver, server=$ser_ver"
if [ "x$cli_ver" == "x$ser_ver" ] ; then
  echo "firmware is newest"
  exit 0
fi


echo "firmware is obsolete, notify UI"

. /tmp/dbusenv.sh
cnt=0
until [ $cnt -ge 10 ] ;
do
  $NOTIFY_APP 6 >>$NOTIFY_LOG 2>&1
  if [ $? -eq 0 ] ; then
    sleep 5
    break;
  fi

  echo "notify failed, try again"
  sleep 3

  cnt=$((cnt+1))
done

exit 0
