#!/bin/sh

. /usr/sbin/tc/global_def.sh

CLEAN_LIST=/tmp/clean.lst

if [ "x$1" == "x1" ] ; then
  DEEPCLEAN=1
else
  DEEPCLEAN=0
fi


echo "<delete temporary download files>"
rm -rf $DOWNDIR/*

echo "<delete none puser's user data(mdf/udf)>"
rm -f $DISKDIR/$XPDATA_IMG-*.*

if [ $DEEPCLEAN -eq 1 ] ; then
  echo "<delete none puser's user data(base)>"
  rm -f $DISKDIR/$XPDATA_IMG

  echo "<delete partitial download img>"
  rm -f -v `ls $DOWNDIR/*.seed | sed -r "s|$DOWNDIR|$DISKDIR|" | sed -r 's/.seed$//'`
#  rm -f -v `ls $DOWNDIR/*.seed | sed -r "s|$DOWNDIR|$DISKDIR|" | awk '{sub(/.{5}$/,"")}1'`
  rm -f $DOWNDIR/*.seed $DOWNDIR/*.cache
fi


cat $DISKDIR/*.$OSINFO_FILE_EXT >$CLEAN_LIST
if [ $? -ne 0 ] ; then
  echo "no OS img cached"
  exit 0
fi

awk -F ':' '
  BEGIN {
    deep_clean = "'${DEEPCLEAN}'";
  }

  {
    if ( length($6) < 1 )
    {
      next;
    }

    print "<Deleting "$2" mdf/udf>";
    cmd = sprintf("rm -f -v `ls %s/%s-*.* | awk '\''%s'\''`", "'${DISKDIR}'", $6, "{if($0!~/admin/) print $0}");
#    print cmd;
    system(cmd);

    if ( deep_clean == 1 )
    {
      print "<Deleting "$2" image>";
      cmd = sprintf("rm -f %s/%s %s/%s.%s", "'${DISKDIR}'", $6, "'${DISKDIR}'", $6, "'${OSINFO_FILE_EXT}'");
#      print cmd;
      system(cmd);

      # for offline mode
      cmd = sprintf("rm -f %s/*-%s.osenv?", "'${DISKDIR}'", $6);
      print cmd;
      system(cmd);
    }
  }

  END {
  }
  ' $CLEAN_LIST

exit 0
