#!/bin/sh

. /usr/sbin/tc/global_def.sh

if [ -z "$1" -o -z "$2" -o -z "$3" ] ; then
  echo "Usage: deploy_trigger.sh osid curimg mode"
  exit 1
fi

if [ -n "$4" ] ; then
  SERVER=$4
  echo SERVER=$4
fi

wget $WGET_OPTS --tries=3 --timeout=1 --retry-connrefused $HTTP_PROT://$DOMAINNAME/$OSINFO_URL/$1 -O $OSINFO_JSON
if [ $? -ne 0 ] ; then
  echo "get os info failed"
  exit 2
fi

cur_img=$(basename $2)

os_id=$1
os_img=$(basename $(jq -r '.result | [.base_path][0]' $OSINFO_JSON))
os_name=`jq -r '.result | [.name][0]' $OSINFO_JSON`
os_icon=$(basename $(jq -r '.result | [.picture][0]' $OSINFO_JSON))

VERFILE=$DISKDIR/$os_img.ver
if [ -f $VERFILE ] ; then
  os_ver=`cat $VERFILE`
else
  os_ver=`jq -r '.result | [.revision][0]' $OSINFO_JSON`
fi

wget $WGET_OPTS --tries=3 --timeout=1 --retry-connrefused $HTTP_PROT://$DOMAINNAME/$OSINFO_URL/$1/$os_ver -O $OSINFO_JSON
if [ $? -ne 0 ] ; then
  echo "get os info failed"
  exit 2
fi

os_uuid=`jq -r '.result.uuid' $OSINFO_JSON`

echo os_id=$os_id
echo os_img=$os_img
echo os_ver=$os_ver
echo os_name=$os_name
echo os_icon=$os_icon
echo os_uuid=$os_uuid

if [ -z "$os_id" -o -z "$os_img" -o -z "$os_ver" -o -z "$os_name" -o -z "$os_icon" ] ; then
  echo "os info missing some fields"
  exit 3
fi

# always download the file
wget $WGET_OPTS --tries=3 --timeout=1 --retry-connrefused $HTTP_PROT://$DOMAINNAME/$BASEICONDIR/$os_icon -O $DISKDIR/$os_icon

if [ "$os_img"x != "$cur_img"x ] ; then
  echo "$cur_img -> $os_img"
  mv -f $DISKDIR/$cur_img $DISKDIR/$os_img
fi

if [ $3 -eq 1 ] ; then
  echo "deploy mode, delete the meta data files"
  rm -f $DISKDIR/$os_img-*
  echo $SERVER > $SERVADDR_FILE
fi

os_info="$os_id:$os_name:$cur_img:$os_icon:$os_ver:$os_img:1:$os_ver"
echo $os_info >$DISKDIR/$os_img.$OSINFO_FILE_EXT

echo $os_uuid >$DISKDIR/$os_img.uuid

exit 0
