#!/bin/sh
# get-cpu.sh
# DESCRIPTION
#     get the description for CPU
# PARAMETER
#     none
# RETURN VALUE
#     0 on success and print the string for CPU to stdout
#     otherwise, return a non-zero value and print error message on stderr
# 
CPU_FILE=/proc/cpuinfo 

ERROR_SUCCESS=0
ERROR_RUNTIME=3

tcerr(){
    echo [ERROR] $@ >&2
}

if ! [ -f "$CPU_FILE" ] ; then
    tcerr "$CPU_FILE: no such file"
    exit $ERROR_RUNTIME
fi

cat $CPU_FILE | grep -q "model\ name"
retval=$?
if ! [ $retval -eq 0 ] ; then
    tcerr "no cpu modle name entry was found"
    exit $ERR_RUNTIME
fi

awk -F ":" '/model\ name/{print $2; exit}' $CPU_FILE | sed 's/^[[:blank:]]*//;s/^[[:blank:]]*$//;'
retval=$?
if ! [ $retval -eq 0 ] ; then
    tcerr "fail to get cpu information"
    exit $ERR_RUNTIME
else
    exit $ERR_SUCCESS
fi
