#!/bin/sh
# get-memory.sh
# DESCRIPTION
#     get the total memory(Unit: MiB) for the computer
# PARAMETER
#     none
# RETURN VALUE
#     0 on success and print the string for memory(Unit: MiB) to stdout
#     otherwise, return a non-zero value and print error message on stderr
# 
MEMORY_FILE=/proc/meminfo 

ERROR_SUCCESS=0
ERROR_RUNTIME=3

tcerr(){
    echo [ERROR] $@ >&2
}

if ! [ -f "$MEMORY_FILE" ] ; then
    tcerr "$MEMORY_FILE: no such file"
    exit $ERROR_RUNTIME
fi

cat $MEMORY_FILE | grep -q "MemTotal"
retval=$?
if ! [ $retval -eq 0 ] ; then
    tcerr "no total memory information is found"
    exit $ERR_RUNTIME
fi

MEMORY_KIB=`awk '/MemTotal:/{print $2; exit}' $MEMORY_FILE`
retval=$?
if ! [ $retval -eq 0 ] ; then
    tcerr "fail to get memory information"
    exit $ERR_RUNTIME
else
    echo "$MEMORY_KIB / 1024" | bc
    exit $ERR_SUCCESS
fi

