#!/bin/sh
# get-qrcode-file.sh
# To download QR code (a png file) for a TC client, given download link
# ret value: 0 on success, and non-zero value if encounters errors
SCRIPT_NAME=$0

RM='rm -f'
MV='mv -f'

if [ $# -ne 2 ] ; then
    cat <<EOT
SYNOPSIS
    ${SCRIPT_NAME} <URL> <output-file>

DESCRIPTION
    Download QR code png file for a TC client from given \`URL' and save it to 
    file \`output-file'.

EXAMPLE
    ${SCRIPT_NAME} $HTTP_PROT://$DOMAINNAME/tc/rest/client.php/qrcode/1 /usr/sbin/tc/hwqrcode.png
EOT
    exit 1
else
    url=$1
    output_file=$2
fi

output_file_tmp=${output_file}.downloading

if [ -f ${output_file_tmp} ] ; then
    ${RM} ${output_file_tmp}
fi

wget $WGET_OPTS --tries=10 --timeout=3 --retry-connrefused --output-document=${output_file_tmp} ${url}
if [ $? -eq 0 -a -f ${output_file_tmp} ] ; then
    ${MV} -v ${output_file_tmp} ${output_file}
else
    exit 2
fi

exit 0

