#!/bin/sh
# get-qrcode.sh
# download QR code from TC server
# ret value: 0 on success, and non-zero value if encounters errors
SCRIPT_NAME=$0

if [ $# -gt 1 ] ; then
    cat <<EOT
SYNOPSIS
    $SCRIPT_NAME [ServerIP]

DESCRIPTION
    To download QR code for TC client from TC Server with the given IP address.
    If no \`ServerIP' is supplied, it will use the IP address stored in local
    disk.

EXAMPLE
    $SCRIPT_NAME
    $SCRIPT_NAME 192.168.0.1
EOT
    exit 1
elif [ $# -eq 1 ] ; then
    serverip=$1
else
    serverip=
fi

. /usr/sbin/tc/global_def.sh
SCRIPT_GET_QRCODE_URL=$TCDIR/get-qrcode-url.sh
SCRIPT_GET_QRCODE_FILE=$TCDIR/get-qrcode-file.sh

URL=`sh $SCRIPT_GET_QRCODE_URL $serverip`
if [ $? -ne 0 ] ; then
    exit 2
fi

sh $SCRIPT_GET_QRCODE_FILE $URL $QRCODE_FILE
if [ $? -ne 0 ] ; then
    exit 3
fi

exit 0

