#!/bin/sh

if [ -f /usr/sbin/tc/bldopt.sh ] ; then
  . /usr/sbin/tc/bldopt.sh
fi

if [ "x$SDL_BUILD_ENABLE" == "x1" ] ; then
  export cafile=/etc/p2p_cacert.pem
  export certfile=/etc/p2p_usercert.pem
  export keyfile=/etc/p2p_userkey.pem

  export HTTP_PROT="https"
  export WGET_OPTS="--ca-certificate=/etc/tcs.ca.certificate.crt"
  export CURL_OPTS="--cacert /etc/tcs.ca.certificate.crt"
else
  export HTTP_PROT="http"
fi

export DBUSENV=/tmp/dbusenv.sh

export DOMAINNAME=console.tc

export SERVER=192.168.0.1
export SERVERPORT=54321

export HDDEV=/dev/sda
export DISKDEV=/dev/sda1
export DISKRSVD=/dev/sda4
export NTFSDEV=/dev/sda2
export USBDIR=/mnt/usb
export DISKDIR=/mnt/disk
export RSVDDIR=/mnt/rsvd

export TCDIR=/usr/sbin/tc

export DOWNDIR=$DISKDIR/download

export VERSION_FILE=$TCDIR/VERSION

export FILE_DISKRDY=/tmp/f-diskrdy

export SERVADDR_FILE=$RSVDDIR/tc-serv.addr

export WLAN_IFACE=wlan0
export WPACONF_FILE=/etc/wpa_supplicant.conf
export WLANCFG_FILE=$RSVDDIR/tc-wifi.addr

export DEFAULT_IFACE=eth0
export IFACE_FILE=$RSVDDIR/tc-iface.def

export NETCFG_FILE=$RSVDDIR/tc-local.addr

export AUTH_APP=$TCDIR/tc-sync-client
export TOKEN_FILE=/tmp/user.token
export UID_FILE=$DISKDIR/user.id
export UPLOAD_MUDF_APP=$TCDIR/tc-mudf-client
export GETICON_APP=$TCDIR/_get-icon.sh
export RUNIMG_APP=$TCDIR/run_img.sh
export GETIMG_APP=$TCDIR/get_img.sh
export LOCALUPIMG_APP=$TCDIR/_local-update.sh
export SKIPUPIMG_APP=$TCDIR/_skip-updates.sh
export MERGE_APP=$TCDIR/_merge-img.sh.overlay
export GETDATA_APP=$TCDIR/_get_data.sh
export MERGEDATA_APP=$TCDIR/_merge-data.sh.overlay
export UPPER_APP=$TCDIR/_update-per.sh
export UPOST_APP=$TCDIR/_update-ost.sh
export MERGE_IMG=$TCDIR/merge
export VERIFY_IMG=$TCDIR/verify_img.sh
export DEPLOY_TRIGGER=$TCDIR/deploy_trigger.sh

export LP2P_GETIMG_APP=$TCDIR/_lp2pget_img.sh

export NOTIFY_APP=$TCDIR/tcnotifier
export NOTIFY_LOG=/var/log/notify_dbus.log

export SKIP_UPDATE_DELAY=5
export SKIP_UPDATE_LIMIT=3
export SKIP_UPDATE_PIPE=/tmp/skip-update.fifo

export OSLIST_FILE=$TCDIR/os.lst
export OSSYNC_FILE=$TCDIR/os.sync
export DATASYNC_FILE=$TCDIR/data.sync

export BASEDIR=baseimage
export USERDIR=diffmap
export PSYCDIR=psupload
export PDATDIR=psroot
export BASEICONDIR=tc/images/clientboot
export DISKICONDIR=/usr/sbin/tc/pic

export VMDRIVE_FILE=$DISKDIR/vmdrive.inf
export VMDRIVE_FILE2=$DISKDIR/vmdrive1.inf

export BOOT_FILE=$DISKDIR/osenv.inf
export BOOT_FILE2=$DISKDIR/osenv1.inf
export ADMINPWD_FILE=admin.pwd

export XPDATA_IMG=tempdata.img

export NETBW_FILE=/tmp/netbw.conf
export AUTO_LOGIN_FILE=/tmp/atlogin.conf
export MACHINE_NAME_FILE=/tmp/pcname.conf
export GET_CLIENT_ENTRY_SCRIPT=/usr/sbin/tc/get-client-entry.sh

export AUTH_URL="tc/rest/auth.php?"
export AUTH_JSON=$TCDIR/auth.json

export MUDFRST_URL="tc/rest/bootimage2.php"
export MUDFRST_JSON=$TCDIR/mudfrst.json
export MUDFVER_URL="tc/rest/bootimage2.php"
export MUDFVER_JSON=$TCDIR/mudfver.json

export FWVER_URL="tc/rest/firmware.php"
export FWVER_JSON=$TCDIR/fwv.json

export AUTOBOOT_URL="tc/rest/bootimage2.php"
export AUTOBOOT_JSON=$TCDIR/autoboot.json
export AUTOBOOT_USER=autoboot
export AUTOBOOT_PASS=380dd7b45840548fc037671cdec9ddd7
export AUTOBOOT_DELAY=2

export OSINFO_URL="tc/rest/bootimage2.php"
export OSINFO_JSON=$TCDIR/osinfo.json
export OSINFO_FILE_EXT="info"

export CHKIMG_UUID=$TCDIR/chk-img-uuid.sh
export OSUUID_URL="tc/rest/bootimage2.php?"
export OSUUID_JSON=$TCDIR/osuuid.json

export SETNEWPWD_URL="tc/rest/auth.php"
export SETNEWPWD_JSON=$TCDIR/setpwd.json

export MERGEIMG_URL="tc/rest/bootimage2.php"
export MERGEDAT_URL="tc/rest/user.php"

export PDATA_URL="tc/rest/user.php"
export PDATA_JSON=$TCDIR/udata.json

export SYSCONF_URL="tc/rest/system.php/settings"
export SYSCONF_JSON=$TCDIR/sysconf.json

export ACLLIST_FILE=$TCDIR/act.lst
export ACLLIST_FILE_NET=$TCDIR/act.lst.net
export ACLLIST_FILE_LOCAL=$TCDIR/act.lst.local

export TCDCLT_APP=$TCDIR/tcdclt.lite #$TCDIR/tcdclt

export QRCODE_SCRIPT=$TCDIR/get-qrcode.sh
export QRCODE_FILE=$TCDIR/hwqrcode.png

export PBBG_URL="tc/rest/file.php/preboot_background"
export PBBG_FILE=$RSVDDIR/commbg.png
export PBBG_THEMEP=/usr/share/themes/base/meegotouch/images/

export DISK_FULL_THRESHOLD=4096
export GET_DISK_USAGE=$TCDIR/get_disk_usage.sh

export GET_CPU_SCRIPT=$TCDIR/get-cpu.sh
export GET_HWADDR_SCRIPT=$TCDIR/get-hwaddr.sh
export GET_DISK_SIZE_SCRIPT=$TCDIR/get-disk-size.sh
export GET_MEMORY_SCRIPT=$TCDIR/get-memory.sh

export POST_HW_SCRIPT=$TCDIR/post-hw.sh

export TC_QUERY_SERVER_URL="tc/rest/system.php/servers"
export TC_QUERY_SERVER=$TCDIR/tc-query-server.sh
export TC_NEW_CLIENT_NAME_FILE="/tmp/tc-new-client-name.txt"

export TC_CALCFLOW_INTV=2
export TC_CALCFLOW_OUT=/tmp/tc-calcflow.out

export TTY_NR_TCD=3
export TTY_NR_GUI=4

export TC_SEC_FILE="/mnt/disk/.tc.passwd"
export TC_RESOLUTION_FILE="/mnt/disk/resolution.config"
export TC_USBSTORAGE_FILE="/mnt/disk/usbstorage.config"
# script for heart-beat
export STATUS_SCRIPT="/usr/sbin/tc/tc-status.sh"
# define TC client status configuration file
export STATUS_CONF_FILE="/tmp/tc-status.conf"
export HB_INTERVAL=4

# define TC client status code
export ACT_POWERON=1            # statusid
export ACT_AUTHENTICATED=2      # statusid, username
export ACT_SYNCING=3            # statusid, username and osid
export ACT_BOOTING=4            # statusid, username and osid
export ACT_RUNNING=5            # statusid, username and osid
export ACT_SHUTTING_DOWN=6      # statusid
export ACT_UPLOADING=7          # statusid, username and osid
export ACT_INITIALIZING_DISK=8  # statusid
export ACT_UPDATING_FIRMWARE=90 # statusid
export ACT_UPDATING_FIRMWARE_CMD_SENT=91 # statusid
export ACT_UPDATING_FIRMWARE_SUCCESS=92	 # statusid
export ACT_UPDATING_FIRMWARE_FAILURE=93  # statusid
export ACT_DEPLOYING=10         # 
export ACT_INTERRUPTED=11       # 
export ACT_WAITING=12           # 
export ACT_HEARTBEAT=17         # statusid

# define TC client status configuration file reserved after booting OS image
export RSVD_STATUS_CONF_FILE="/mnt/rsvd/tc-status.conf"

#define filed name for reserved status configuration file,
# which would be read while OS images are running.
export ST_STATUS="statusid"
export ST_USERNAME="username"
export ST_OSID="imageid"
export ST_DISKSZ="disksz"
export ST_MEMSZ="memsz"
export ST_CPUMODEL="cpumodel"


if [ "x$lang" == "xzh_CN" ] ; then
  LINESPEED="线路速度"
  NOLIMIT="无限制"
  DIRUP="上行"
  DIRDOWN="下行"
  CHKSUMNOTMATCH="校验和不匹配"
  UPLOADING="正在上传"
  UPGRADING="正在升级"
  CACHING="正在下载"
  VERIFYING="正在校验"
  CACHEADMINMUDF="正在下载管理员漫游数据"
  CACHEOSUDF="正在下载系统升级元文件"
  VERIFYOSUDF="正在校验系统升级元文件"
  CACHEOSMDF="正在下载系统升级索引文件"
  CACHEUSRMUDF="正在下载用户升级文件"
  UPGRADEUSRDATA="正在升级用户数据文件"
  CACHEUSRDATA="正在下载用户数据文件"
  UPLOADUSRDATA="正在上传用户数据文件"
  UPLOADSYSDATA="正在上传系统升级文件"
else
  LINESPEED="line speed"
  NOLIMIT="no limit"
  DIRUP="upload"
  DIRDOWN="download"
  CHKSUMNOTMATCH="the checksum not match"
  UPLOADING="uploading"
  UPGRADING="Upgrading"
  CACHING="Caching"
  VERIFYING="Verifying"
  CACHEADMINMUDF="Caching Admin's roaming data"
  CACHEOSUDF="Caching OS upgrade meta file"
  VERIFYOSUDF="Verifying OS upgrade meta file"
  CACHEOSMDF="Caching OS upgrade map file"
  CACHEUSRMUDF="Caching USER upgrade file"
  UPGRADEUSRDATA="Upgrading USER data file"
  CACHEUSRDATA="Caching USER data file"
  UPLOADUSRDATA="Uploading USER data file"
  UPLOADSYSDATA="Uploading OS upgrade file"
fi
