#!/bin/sh

. /usr/sbin/tc/global_def.sh

if [ -z "$1" -o -z "$2" ] ; then
  echo "Usage: pre_deploy_trigger.sh osid mode"
  exit 1
fi

if [ -n "$3" ] ; then
  SERVER=$3
  echo SERVER=$3
fi

wget $WGET_OPTS --tries=10 --timeout=3 --retry-connrefused $HTTP_PROT://$DOMAINNAME/$OSINFO_URL/$1 -O $OSINFO_JSON
if [ $? -ne 0 ] ; then
  echo "get os info failed"
  exit 2
fi

os_id=$1
os_img=$(basename $(jq -r '.result | [.base_path][0]' $OSINFO_JSON))

echo os_id=$os_id
echo os_img=$os_img

if [ -z "$os_id" -o -z "$os_img" ] ; then
  echo "os info missing some fields"
  exit 3
fi

if [ $2 -eq 1 ] ; then
  echo "pre deploy mode, delete ver($os_img.ver) and img($os_img) files"
  rm -f $DISKDIR/$os_img
  rm -f $DISKDIR/$os_img.ver
  echo $SERVER > $SERVADDR_FILE
fi

exit 0
