#!/bin/sh

. /usr/sbin/tc/global_def.sh

if [ -z "$1" -o -z "$2" -o -z "$3" -o -z "$4" ] ; then
  echo "Usage: reset_img.sh <curimg> <username> <osid> <orgimg>"
  exit 1
fi

if [ -n "$5" ] ; then
  SERVER=$5
  echo SERVER=$5
fi

UID=`cat $UID_FILE`
echo "user id: $UID"

CURPER=0
PERFILE=$TCDIR/$3.per
if [ -f $PERFILE ] ; then
  CURPER=`cat $PERFILE`
fi
if [ ${#CURPER} -eq 2 ] ; then
  CURPER=${CURPER:1:1}
fi
echo CURPER=$CURPER
if [ $CURPER -lt 2 ] ; then
  echo permission denied
  exit 2
fi

curl $CURL_OPTS -X DELETE --output $MUDFRST_JSON -H "Content-Type: application/json" -d '{"uid":"'$UID'"}' "$HTTP_PROT://$DOMAINNAME/$MUDFRST_URL/$3/pending"
if [ $? -ne 0 ] ; then
  echo "communicate with server timeout"
  exit 3
fi
jret=`jq -r '.success' $MUDFRST_JSON`
if [ "$jret"x != "true"x ] ; then
  echo "reset mdf/udf version failed"
  exit 61
fi

echo "delete udf/mdf/ver..."
rm -f $DISKDIR/$4-$2.*

$TCDIR/createMdfUdf $DISKDIR/$4 $2 $DISKDIR
if [ $? -ne 0 ] ; then
  echo "create mdf/udf failed"
  exit 12
fi
echo "1" >$DISKDIR/$4-$2.ver

#echo "sleeping for debuging"
#sleep 30

exit 0
