#!/bin/sh

. /usr/sbin/tc/global_def.sh

if [ $# -lt 4 ] ; then
  echo "Usage: run_img.sh <curimg> <username> <osid> <orgimg>"
  exit 1
fi

prog=`basename $0`
echo "prog=$prog"
if [ $prog == "run_img.sh.vm" ] ; then
  echo "use vm mode"
  VMMODE=1
else
  echo "use native mode"
  VMMODE=0
fi

$GETIMG_APP $@
ret=$?
if [ $ret -ne 0 ] ; then
  echo "get_img.sh failed: $ret"
  exit $ret
fi

$TCDIR/gendtag $HDDEV $DISKDIR/pagefile.disk

#echo "sleeping for debuging"
#sleep 30

if [ "x$VMMODE" != "x1" -a "x$SDL_BUILD_ENABLE" != "x1" ] ; then
  while [ true ]; do
    echo "umount disk..."
    umount $DISKDIR
    if [ $? -eq 0 ] ; then
      break;
    fi

    echo "umount disk failed, try again"
    sleep 10
  done

  while [ true ]; do
    echo "umount rsvd..."
    umount $RSVDDIR
    if [ $? -eq 0 ] ; then
      break;
    fi

    echo "umount rsvd failed, try again"
    sleep 10
  done
fi

#$TCDCLT_APP $SERVER eth0 12345 "4:$2:$3" >>/tmp/clt.log 2>&1
echo "4:$2:$3" >$STATUS_CONF_FILE
sleep 2

:<<BLOCK
secs=10
while [ $secs -gt 0 ]; do
  echo -ne "boot from local: $secs\033[0K\r"
  sleep 1
  secs=$((secs-1))
done
BLOCK

if [ "x$VMMODE" == "x1" ] ; then
  BRIDGE=br0
  IFACE=$DEFAULT_IFACE
  if [ -f $IFACE_FILE ] ; then
    IFACE=`cat $IFACE_FILE`
  fi

  echo "add $IFACE to $BRIDGE"
  brctl addbr $BRIDGE
  brctl addif $BRIDGE $IFACE
  ifconfig $BRIDGE up

  export SDL_VIDEODRIVER=fbcon
  qemu-system-i386 \
  -nodefaults \
  -machine q35,accel=kvm \
  -cpu qemu32 \
# -cpu host \  # win10 need
  -m 1536M \
  -vga std \
  -display sdl \
  -k en-us \
  -usb -device usb-tablet \
  -device e1000,netdev=tap0 -netdev tap,id=tap0,ifname=tap0 \
  `cat $VMDRIVE_FILE` \
#  -incoming tcp:0:6789 \
#  -drive if=virtio,format=raw,file=$NTFSDEV \
#  `cat $VMDRIVE_FILE2` \
#  -drive media=cdrom,file=/mnt/disk/virtio-win.iso

  echo "del $IFACE from $BRIDGE"
  ifconfig $BRIDGE down
  brctl delif $BRIDGE $IFACE
  brctl delbr $BRIDGE
else
  if [ "x$SDL_BUILD_ENABLE" == "x1" ] ; then
    reboot
  else
    kexec -l $TCDIR/kloader
    kexec -e
  fi
fi
