#!/bin/sh

. /usr/sbin/tc/global_def.sh

IFACE=$DEFAULT_IFACE
if [ -f $IFACE_FILE ] ; then
  IFACE=`cat $IFACE_FILE`
fi

RXB_FILE=/sys/class/net/$IFACE/statistics/rx_bytes
TXB_FILE=/sys/class/net/$IFACE/statistics/tx_bytes
while [ true ]; do
  PRE_RX_BYTES=`cat $RXB_FILE`
  PRE_TX_BYTES=`cat $TXB_FILE`

  PRE_MS=`date +%s%3N`
  sleep $TC_CALCFLOW_INTV
  CUR_MS=`date +%s%3N`
  INTERVAL=$((CUR_MS-PRE_MS))

  CUR_RX_BYTES=`cat $RXB_FILE`
  CUR_TX_BYTES=`cat $TXB_FILE`

  RX_SPEED=`echo "scale=2;($CUR_RX_BYTES-$PRE_RX_BYTES)/1048/$INTERVAL" | bc | awk '{printf "%.2f",$0}'`
  TX_SPEED=`echo "scale=2;($CUR_TX_BYTES-$PRE_TX_BYTES)/1048/$INTERVAL" | bc | awk '{printf "%.2f",$0}'`
  echo "$LINESPEED: $DIRDOWN=${RX_SPEED}MB/s, $DIRUP=${TX_SPEED}MB/s" >$TC_CALCFLOW_OUT
done


