#!/bin/sh

. /usr/sbin/tc/global_def.sh

if [ ! -f $WLANCFG_FILE ] ; then
  echo "$WLANCFG_FILE not exist"
  exit 2
fi

cnt=0
tries=5
until [ $cnt -ge $tries ] ; do
  wpa_cli -i$WLAN_IFACE status
  if [ $? -eq 0 ] ; then
    break;
  fi

  echo "wait 1s for wpa_supplicant"
  sleep 1
  cnt=$((cnt+1))
done
if [ $cnt -eq $tries ] ; then
  echo "wpa_supplicant not running"
  exit 3
fi

argv=`awk -F ':' '{printf("ssid=%s;passcode=%s;",$1,$2)}' $WLANCFG_FILE`
eval $argv

wpa_cli -i$WLAN_IFACE remove_network 0
wpa_cli -i$WLAN_IFACE add_network
wpa_cli -i$WLAN_IFACE set_network 0 ssid \"$ssid\"
if [ -z "$passcode" ] ; then
  wpa_cli -i$WLAN_IFACE set_network 0 key_mgmt NONE
else
  wpa_cli -i$WLAN_IFACE set_network 0 psk \"$passcode\"
fi
wpa_cli -i$WLAN_IFACE select_network 0
wpa_cli -i$WLAN_IFACE enable_network 0
wpa_cli -i$WLAN_IFACE save_config

exit 0
