#!/bin/sh

. /usr/sbin/tc/global_def.sh

if [ $# -lt 2 ] ; then
  echo "Usage: tc-fastcopy.sh <src_img> <dst_img>"
  exit 1
fi

CREATECACHE=$TCDIR/create_cache.sh
FASTCOPY=$TCDIR/FastCopy

src_img=$1
dst_img=$2
cache_file=/tmp/fastcopy.cache
blk_size=4096
img_size=`ls -l "$src_img" | awk '{print $3}'`

$CREATECACHE $src_img $img_size $cache_file $blk_size
ret=$?
if [ $ret -ne 0 ] ; then
  echo "create cache file failed"
  exit $ret
fi

$FASTCOPY $src_img $dst_img $img_size $cache_file $blk_size

