#!/bin/sh

. /usr/sbin/tc/global_def.sh

if [ $# -lt 1 ] ; then
  echo "Usage: tc-md5sum.sh <osimg>"
  exit 1
fi

CREATECACHE=$TCDIR/create_cache.sh
FASTCAT=$TCDIR/FastCat

osimg=$1
cache_file=/tmp/fastcat.cache
blk_size=4096
img_size=`ls -l "$osimg" | awk '{print $3}'`

$CREATECACHE $osimg $img_size $cache_file $blk_size
ret=$?
if [ $ret -ne 0 ] ; then
  echo "create cache file failed"
  exit $ret
fi

$FASTCAT $osimg $img_size $cache_file $blk_size | md5sum

