#!/bin/sh
# tc-status.sh
# report status periodicly
#
. /usr/sbin/tc/global_def.sh

# comment the following line if not to post hardware infomation
POST_REPORT_HWINFO=yes

LOGFILE=/tmp/tc-status.log

server=$SERVER
ifname=$DEFAULT_IFACE
if [ -f $IFACE_FILE ] ; then
  ifname=`cat $IFACE_FILE`
fi

# get hardward information
if [ -f $GET_DISK_SIZE_SCRIPT ] ; then
    disksz=`$GET_DISK_SIZE_SCRIPT`
fi

if [ -f $GET_MEMORY_SCRIPT ] ; then
    memsz=`$GET_MEMORY_SCRIPT`
fi

if [ -f $GET_CPU_SCRIPT ] ; then
    strcpu=`$GET_CPU_SCRIPT`
fi


# loop forever
while : ; do
    if [ -f $SERVADDR_FILE ] ; then
        server=`cat $SERVADDR_FILE`
    fi

    if [ -f $STATUS_CONF_FILE ] ; then
        client_status=`cat $STATUS_CONF_FILE`
    else
        sleep 1
        continue
    fi

    if [ "x${POST_REPORT_HWINFO}" == "xyes" ] ; then
        $TCDCLT_APP $server $ifname 12345 "${client_status}" "${disksz}" "${memsz}" "${strcpu}" 2>&1 >$LOGFILE
    else
        $TCDCLT_APP $server $ifname 12345 "${client_status}" 2>&1 >$LOGFILE
    fi

    echo "disk  : ${disksz} MiB" >>$LOGFILE
    echo "memory: ${memsz} MiB"  >>$LOGFILE
    echo "cpu   : ${strcpu}"     >>$LOGFILE

    sleep $HB_INTERVAL
done

exit 1

