#!/bin/sh

. /usr/sbin/tc/global_def.sh

if [ -z "$1" -o -z "$2" -o -z "$3" ] ; then
  echo "Usage: verify_img.sh <file_path> <local_name> <remote_name>"
  exit 1
fi

if [ -n "$4" ] ; then
  SERVER=$4
  echo SERVER=$4
fi

TARGET_PATH=$1
TARGET_FILE=$2
MD5SUM_FILE=$3.md5sum

wget $WGET_OPTS --tries=1 --timeout=1 --retry-connrefused -nv $HTTP_PROT://$DOMAINNAME/seeds/$MD5SUM_FILE -O $DOWNDIR/$MD5SUM_FILE
if [ $? -eq 0 ] ; then
  echo "verify $TARGET_FILE($MD5SUM_FILE)"
  c_sum=`md5sum $TARGET_PATH/$TARGET_FILE | awk '{print $1}'`
  s_sum=`cat $DOWNDIR/$MD5SUM_FILE | awk '{print $1}'`
  echo "client's checksum=$c_sum"
  echo "server's checksum=$s_sum"
  if [ "x$c_sum" != "x$s_sum" ] ; then
    echo "<$CHKSUMNOTMATCH>"
    exit 62
  fi
fi

exit 0
