#!/bin/sh
# check if file has existed on the partition
source import_debug.sh

if [ "x$HOST_DEBUG" == "x" ] ; then
    TMP_DIR=/var/tc
    CONF_DIR=/etc/tc.conf.d
    SCRIPT_DIR=/usr/local/bin/script
else
    TMP_DIR=/home/bright/tc/tc-project/ramdisk/imgexport_diff/var/tc
    CONF_DIR=/home/bright/tc/tc-project/ramdisk/imgexport_diff/etc/tc.conf.d
    SCRIPT_DIR=/home/bright/tc/tc-project/ramdisk/imgexport_diff/usr/local/bin/script
fi

MTDIR=/mnt/usb

exec 5>&1 6>&2
exec 1>>/dev/null 2>&1

if [ $# -ne 2 ] ; then
# wrong parameter
    exit 1
fi

FILENAME=$1
PART=$2

if ! [ -e $PART ] ; then
# wrong partitions
    exit 2
fi

if ! df | grep -q "$PART" ; then
    if ! mount $PART $MTDIR && ! ntfs-3g $PART $MTDIR ; then
# fail to mount partitions
        exit 3
    fi
else
    cd / && umount -f $PART
    if ! mount $PART $MTDIR && ! ntfs-3g $PART $MTDIR ; then
# fail to mount partitions
        exit 3
    fi
fi

# after mounted

RETVAL=4
if [ -e $MTDIR/$FILENAME ] ; then
    RETVAL='0'
fi

umount -f $MTDIR

exec 1>&5
exec 2>&6

exit $RETVAL
