#!/bin/sh

LOCAL_DISK=$1
LBA_BEGIN=$2
LBA_END=$3
CYL=$4
HPC=$5
SPT=$6
FOREIGN_PARTITION=$7
FILENAME=$8
CFGFILE=$9

if [ $# -ne 9 ] ; then
    exit 1
fi

source import_debug.sh
if [ "x$HOST_DEBUG" == "x" ] ; then
    ROOTDIR=''
else
    ROOTDIR='/home/bright/tc/tc-project/ramdisk/imgexport_diff'
fi

#LOCAL_DIR=$ROOTDIR/mnt/disk
FOREIGN_DIR=$ROOTDIR/mnt/usb
CFG_DIR=$ROOTDIR/etc/tc.conf.d

LOG=${ROOTDIR}'/var/log/tcsh.log'

exec 5>&1 6>&2
exec 1>>$LOG 2>&1

#if [ -n "$HOST_DEBUG" ] ; then
#    echo "0" > $CFG_DIR/$CFGFILE
#    exit 1
#fi

lba_count=$(($LBA_END + 1 - $LBA_BEGIN))
#echo "lba_count=$lba_count"

if mount | grep -q "$FOREIGN_PARTITION" ; then
    if ! umount -f $FOREIGN_PARTITION ; then
        echo "0" > $CFG_DIR/$CFGFILE
        exit 1
    fi
fi

stmp=""
if ntfs-3g $FOREIGN_PARTITION $FOREIGN_DIR ; then
    rm -f $FOREIGN_DIR/$FILENAME

    ret=1
    if [ $LBA_BEGIN -eq 0 ] ; then
      FSIZE=$(($lba_count * 512))
      BSIZE=4096
      CFILE=/tmp/clone.cache
      /usr/local/bin/script/create_cache.sh $LOCAL_DISK $FSIZE $CFILE $BSIZE
      if [ $? -eq 0 ] ; then
        /usr/sbin/tc/FastCopy $LOCAL_DISK $FOREIGN_DIR/$FILENAME $FSIZE $CFILE $BSIZE
        ret=$?
      fi
    fi
    if [ $ret -ne 0 ] ; then
      dd if=$LOCAL_DISK of=$FOREIGN_DIR/$FILENAME skip=$LBA_BEGIN bs=512 count=$lba_count
    fi

    sync 
    stmp=`ls -l ${FOREIGN_DIR}/${FILENAME} | awk '{print $3}'`
#    stmp=`ls -l ${FOREIGN_DIR}/${FILENAME} | awk '{print $5}'`
#    stmp=$(expr $stmp / 512)
    stmp=$(echo "$stmp / 512" | bc)
    if [ "x$lba_count" == "x$stmp" ] ; then
        echo "1" > $CFG_DIR/$CFGFILE
    else
        echo "0" > $CFG_DIR/$CFGFILE
    fi
    umount $FOREIGN_DIR
elif mount $FOREIGN_PARTITION $FOREIGN_DIR ; then
    rm -f $FOREIGN_DIR/$FILENAME

    ret=1
    if [ $LBA_BEGIN -eq 0 ] ; then
      FSIZE=$(($lba_count * 512))
      BSIZE=4096
      CFILE=/tmp/clone.cache
      /usr/local/bin/script/create_cache.sh $LOCAL_DISK $FSIZE $CFILE $BSIZE
      if [ $? -eq 0 ] ; then
        /usr/sbin/tc/FastCopy $LOCAL_DISK $FOREIGN_DIR/$FILENAME $FSIZE $CFILE $BSIZE
        ret=$?
      fi
    fi
    if [ $ret -ne 0 ] ; then
      dd if=$LOCAL_DISK of=$FOREIGN_DIR/$FILENAME skip=$LBA_BEGIN bs=512 count=$lba_count
    fi

    sync 
    stmp=`ls -l ${FOREIGN_DIR}/${FILENAME} | awk '{print $3}'`
#    stmp=`ls -l ${FOREIGN_DIR}/${FILENAME} | awk '{print $5}'`
#    stmp=$(expr $stmp / 512)
    stmp=$(echo "$stmp / 512" | bc)
    if [ "x$lba_count" == "x$stmp" ] ; then
        echo "1" > $CFG_DIR/$CFGFILE
    else
        echo "0" > $CFG_DIR/$CFGFILE
    fi
    umount $FOREIGN_DIR
else
    echo "0" > $CFG_DIR/$CFGFILE
    exit 1
fi


exec 1>&5
exec 2>&6

