#/bin/sh

# detect disks attached to the current machine and print details.


source import_debug.sh
#HOST_DEBUG=yes
if [ "x$HOST_DEBUG" == "x" ] ; then
    TMP_DIR=/var/tc
    CONF_DIR=/etc/tc.conf.d
    SCRIPT_DIR=/usr/local/bin/script
else
#    TMP_DIR=/home/bright/tc/tc-project/ramdisk/imgexport_diff/var/tc
#    CONF_DIR=/home/bright/tc/tc-project/ramdisk/imgexport_diff/etc/tc.conf.d
#    SCRIPT_DIR=/home/bright/tc/tc-project/ramdisk/imgexport_diff/usr/local/bin/script
    TMP_DIR=/home/bright/tc/tc-project/ramdisk/imgtool_diff/var/tc
    CONF_DIR=/home/bright/tc/tc-project/ramdisk/imgtool_diff/etc/tc.conf.d
    SCRIPT_DIR=/home/bright/tc/tc-project/ramdisk/imgtool_diff/usr/local/bin/script
fi

TMPFILE=$TMP_DIR/lba.tmp
EBRTMPFILE=$TMP_DIR/ebr_lba.tmp
CONFFILE=$CONF_DIR/partlist.conf

MTDIR=/mnt/disk

SCRIPT_PATH=$0
SCRIPT_NAME=${SCRIPT_PATH##*/}

SCRIPT_SIZE2H=$SCRIPT_DIR/size2h.sh
chmod +x $SCRIPT_SIZE2H

exec 5>&1 6>&2
exec 1>$TMP_DIR/detect_disk.log 2>&1

echo -n "" > $CONFFILE

disk_name_list=`fdisk -l | grep '^Disk' | grep '/dev/.*:' | awk '{print $2}' | sed 's/://'`

for disk in $disk_name_list ; do
    nLen=${#disk}
    endChar=${disk:$(expr $nLen - 1):$(expr $nLen - 1)}
    # if it is a digit
    if [ ! -z "${endChar##*[!0-9]*}" ] ; then
        continue
    fi

    VENDOR_FILE='/sys/block/'${disk##*/}'/device/vendor'
    MODEL_FILE='/sys/block/'${disk##*/}'/device/model'
    VENDOR=`cat ${VENDOR_FILE}`
    MODEL=`cat ${MODEL_FILE}`

    # remove spaces
    vn=""
    for vendor in $VENDOR ; do
        vn="${vn}${vendor}"
    done
    VENDOR=${vn}

    md=""
    for model in $MODEL ; do
        md="${md}${model}"
    done
    MODEL=${md}

    CYL=`fdisk -l $disk | sed -n '3p' | awk '{print $5}'`
    HPC=`fdisk -l $disk | sed -n '3p' | awk '{print $1}'`
    SPT=`fdisk -l $disk | sed -n '3p' | awk '{print $3}'`
    disk_capabytes=`fdisk -l $disk | grep '^Disk' | grep '/dev/.*:' | awk '{print $5}' | sed 's/://'`
    DISKCAPA=`$SCRIPT_DIR/calc_capa.sh $disk_capabytes`

    for i in `seq 4` ; do
        partno=$i
        hexdump -s $((430 + 16*$i)) -n 1 -vx $disk | awk '{print $3$2}' | sed 's/^00//' > $TMPFILE
        partboot=`cat $TMPFILE`
        hexdump -s $((434 + 16*$i)) -n 1 -vx $disk | awk '{print $2}' | sed 's/^00//' > $TMPFILE
        parttype=`cat $TMPFILE`
        hexdump -s $((438 + 16*$i)) -n 4 -vx $disk | awk '{print $3$2}' > $TMPFILE
        lbastart=`cat $TMPFILE`
        hexdump -s $((442 + 16*$i)) -n 4 -vx $disk | awk '{print $3$2}' > $TMPFILE
        lbacount=`cat $TMPFILE`

# if it is an empty partition entry
        if [ "x00000000" == "x$lbastart" -a "x00000000" == "x$lbacount" ] || [ "x" == "x$lbastart" -a "x" == "x$lbacount" ] ; then
            continue
        fi
# if it is an empty partition, or it is a EFI partition 
        if [ "x00" == "x$parttype" -o "xef" == "x$parttype" ] ; then
            continue
        fi

# if partition type is '83'(Linux) or 'b'(W95 FAT32) and so on...
        if [ "x$parttype" == "x06" -o "x$parttype" == "x0e" -o "x$parttype" == "x0b" -o "x$parttype" == "x0c" -o "x$parttype" == "x07" -o "x$parttype" == "x83" ] ; then
            if mount | grep -q "^$disk$i" ; then
                df -h $disk$i | sed -n '2p' | awk '{print $2}' > $TMPFILE
                size=`cat $TMPFILE`
                df -h $disk$i | sed -n '2p' | awk '{print $4}' > $TMPFILE
                avail=`cat $TMPFILE`
                df -h $disk$i | sed -n '2p' | awk '{print $5}' > $TMPFILE
                use=`cat $TMPFILE`
                df -k $disk$i | sed -n '2p' | awk '{print $4}' > $TMPFILE
                avail_1k_blocks=`cat $TMPFILE`
                df -k $disk$i | sed -n '2p' | awk '{print $3}' > $TMPFILE
                used_1k_blocks=`cat $TMPFILE`
            else
#                df
#                echo -e "\n\n<<<<<<<<<< mount $disk$i to $MTDIR >>>>>>>>>>"
                if ntfs-3g $disk$i $MTDIR ; then
                    until df | grep -q $disk$i ; do
                        sleep 1
                    done
                    df -k $disk$i | sed -n '2p' | awk '{print $2}' > $TMPFILE
                    size=`cat $TMPFILE`
                    size=`sh $SCRIPT_SIZE2H $size`
                    echo "size = $size"
                    #df -h $disk$i | sed -n '2p' | awk '{print $4}' > $TMPFILE
                    #avail=`cat $TMPFILE`
                    df -k $disk$i | sed -n '2p' | awk '{print $4}' > $TMPFILE
                    avail_1k_blocks=`cat $TMPFILE`
                    df -k $disk$i | sed -n '2p' | awk '{print $3}' > $TMPFILE
                    used_1k_blocks=`cat $TMPFILE`
                    df -h $disk$i | sed -n '2p' | awk '{print $5}' > $TMPFILE
                    use=`cat $TMPFILE`
                    avail=`sh $SCRIPT_SIZE2H $avail_1k_blocks`
                    echo "avail=$avail"

                    umount $disk$i
#                    echo -e ">>>>>>>>>> ntfs: Success <<<<<<<<<<\n\n"
                elif mount $disk$i $MTDIR ; then
                    until df | grep -q $disk$i ; do
                        sleep 1
                    done
                    df -k $disk$i | sed -n '2p' | awk '{print $2}' > $TMPFILE
                    size=`cat $TMPFILE`
                    size=`sh $SCRIPT_SIZE2H $size`
                    #df -h $disk$i | sed -n '2p' | awk '{print $4}' > $TMPFILE
                    #avail=`cat $TMPFILE`
                    df -h $disk$i | sed -n '2p' | awk '{print $5}' > $TMPFILE
                    use=`cat $TMPFILE`
                    df -k $disk$i | sed -n '2p' | awk '{print $4}' > $TMPFILE
                    avail_1k_blocks=`cat $TMPFILE`
                    df -k $disk$i | sed -n '2p' | awk '{print $3}' > $TMPFILE
                    used_1k_blocks=`cat $TMPFILE`
                    avail=`sh $SCRIPT_SIZE2H $avail_1k_blocks`
                    echo "avail=$avail"

                    umount $disk$i
#                    echo -e ">>>>>>>>>> linux:Success <<<<<<<<<<\n\n"
                else
#                    echo -e ">>>>>>>>>> mount:Failed <<<<<<<<<<\n\n"
                    size='unknown'
                    avail='unknown'
                    use='unknown'
                    avail_1k_blocks='0'
                    used_1k_blocks='0'
                fi
            fi
                

            part_cylstart=`fdisk -l $disk | grep "^$disk$i" | sed "s/\*//" | awk '{print $2}'`
            part_cylend=`fdisk -l $disk | grep "^$disk$i" | sed "s/\*//" | awk '{print $3}'`
        # save info
            echo -n "$disk " >> $CONFFILE
            echo -n "$DISKCAPA " >> $CONFFILE
            echo -n "$disk_capabytes " >> $CONFFILE
            echo -n "$CYL " >> $CONFFILE
            echo -n "$HPC " >> $CONFFILE
            echo -n "$SPT " >> $CONFFILE
            echo -n "$i " >> $CONFFILE
            echo -n "$partboot " >> $CONFFILE
            echo -n "$parttype " >> $CONFFILE
            echo -n "$part_cylstart " >> $CONFFILE
            echo -n "$part_cylend " >> $CONFFILE
            echo -n "$((0x$lbastart)) " >> $CONFFILE
            echo -n "$((0x$lbastart + 0x$lbacount - 1)) " >> $CONFFILE
            echo -n "$size " >> $CONFFILE
            echo -n "$avail " >> $CONFFILE
            echo -n "$use " >> $CONFFILE
            echo -n "$avail_1k_blocks " >> $CONFFILE
            echo -n "$used_1k_blocks " >> $CONFFILE
            echo -n "$VENDOR " >> $CONFFILE
            echo "$MODEL" >> $CONFFILE


        elif [ "x$parttype" == "x05" -o "x$parttype" == "x0f" -o "x$parttype" == "x85" ] ; then 
# else if partition type is '5' (Extended)
# read the 1st and 2nd EBR partition entry, until the 2nd EBR partition entry is empty
            part_cylstart=`fdisk -l $disk | grep "^$disk$i" | sed "s/\*//" | awk '{print $2}'`
            part_cylend=`fdisk -l $disk | grep "^$disk$i" | sed "s/\*//" | awk '{print $3}'`
            size='unknown'
            avail='unknown'
            use='unknown'
            avail_1k_blocks='0'
            used_1k_blocks='0'
            echo -n "$disk " >> $CONFFILE
            echo -n "$DISKCAPA " >> $CONFFILE
            echo -n "$disk_capabytes " >> $CONFFILE
            echo -n "$CYL " >> $CONFFILE
            echo -n "$HPC " >> $CONFFILE
            echo -n "$SPT " >> $CONFFILE
            echo -n "$i " >> $CONFFILE
            echo -n "$partboot " >> $CONFFILE
            echo -n "$parttype " >> $CONFFILE
            echo -n "$part_cylstart " >> $CONFFILE
            echo -n "$part_cylend " >> $CONFFILE
            echo -n "$((0x$lbastart)) " >> $CONFFILE
            echo -n "$((0x$lbastart + 0x$lbacount - 1)) " >> $CONFFILE
            echo -n "$size " >> $CONFFILE
            echo -n "$avail " >> $CONFFILE
            echo -n "$use " >> $CONFFILE
            echo -n "$avail_1k_blocks " >> $CONFFILE
            echo -n "$used_1k_blocks " >> $CONFFILE
            echo -n "$VENDOR " >> $CONFFILE
            echo "$MODEL" >> $CONFFILE

#set -x
            counter=0
            last_ebrp2_start=0
            j='5'
            ebrp2_start='exists'
            ebrp2_count='exists'
            first_ebr_start=$lbastart
            rm -f $EBRTMPFILE
            dd if=$disk of=$EBRTMPFILE bs=512 count=1 skip=$((0x$first_ebr_start)) 
            until [ $ebrp2_start == "00000000" -a $ebrp2_count == "00000000" ] ; do
                hexdump -s $((446)) -n 1 -vx $EBRTMPFILE | awk '{print $2}' | sed 's/^00//' > $TMPFILE
                ebrp1_boot=`cat $TMPFILE`
                hexdump -s $((446 + 4)) -n 1 -vx $EBRTMPFILE | awk '{print $2}' | sed 's/^00//' > $TMPFILE
                ebrp1_type=`cat $TMPFILE`
                hexdump -s $((446 + 8)) -n 4 -vx $EBRTMPFILE | awk '{print $3$2}' > $TMPFILE
                ebrp1_start=`cat $TMPFILE`
                hexdump -s $((446 + 12)) -n 4 -vx $EBRTMPFILE | awk '{print $3$2}' > $TMPFILE
                ebrp1_count=`cat $TMPFILE`
                hexdump -s $((446 + 16 + 8)) -n 4 -vx $EBRTMPFILE | awk '{print $3$2}' > $TMPFILE
                ebrp2_start=`cat $TMPFILE`
                hexdump -s $((446 + 16 + 12)) -n 4 -vx $EBRTMPFILE | awk '{print $3$2}' > $TMPFILE
                ebrp2_count=`cat $TMPFILE`
                part_cylstart=`fdisk -l $disk | grep "^$disk$j" | sed "s/\*//" | awk '{print $2}'`
                part_cylend=`fdisk -l $disk | grep "^$disk$j" | sed "s/\*//" | awk '{print $3}'`

                if [ "x$ebrp1_type" == "x06" -o "x$ebrp1_type" == "x0e" -o "x$ebrp1_type" == "x0b" -o "x$ebrp1_type" == "x0c" -o "x$ebrp1_type" == "x07" -o "x$ebrp1_type" == "x83" ] ; then
                    if mount | grep -q "^$disk$j" ; then
                        df -h $disk$j | sed -n '2p' | awk '{print $2}' > $TMPFILE
                        size=`cat $TMPFILE`
                        df -h $disk$j | sed -n '2p' | awk '{print $4}' > $TMPFILE
                        avail=`cat $TMPFILE`
                        df -h $disk$j | sed -n '2p' | awk '{print $5}' > $TMPFILE
                        use=`cat $TMPFILE`
                        df -k $disk$j | sed -n '2p' | awk '{print $4}' > $TMPFILE
                        avail_1k_blocks=`cat $TMPFILE`
                        df -k $disk$j | sed -n '2p' | awk '{print $3}' > $TMPFILE
                        used_1k_blocks=`cat $TMPFILE`
                    else
#                        df
#                        echo -e "\n\n<<<<<<<<<< mount $disk$j to $MTDIR >>>>>>>>>>"
                        if ntfs-3g $disk$j $MTDIR ; then
                            until df | grep -q $disk$j; do
                                sleep 1
                            done

                            df -k $disk$j | sed -n '2p' | awk '{print $2}' > $TMPFILE
                            size=`cat $TMPFILE`
                            size=`sh $SCRIPT_SIZE2H $size`
                            #df -h $disk$j | sed -n '2p' | awk '{print $4}' > $TMPFILE
                            #avail=`cat $TMPFILE`
                            df -h $disk$j | sed -n '2p' | awk '{print $5}' > $TMPFILE
                            use=`cat $TMPFILE`
                            df -k $disk$j | sed -n '2p' | awk '{print $4}' > $TMPFILE
                            avail_1k_blocks=`cat $TMPFILE`
                            df -k $disk$j | sed -n '2p' | awk '{print $3}' > $TMPFILE
                            used_1k_blocks=`cat $TMPFILE`
                            avail=`sh $SCRIPT_SIZE2H $avail_1k_blocks`

                            umount $disk$j
#                            echo -e ">>>>>>>>>> ntfs:Success <<<<<<<<<<\n\n"
                        elif mount $disk$j $MTDIR ; then
                            until df | grep -q $disk$j; do
                                sleep 1
                            done
                            df -k $disk$j | sed -n '2p' | awk '{print $2}' > $TMPFILE
                            size=`cat $TMPFILE`
                            size=`sh $SCRIPT_SIZE2H $size`
                            #df -h $disk$j | sed -n '2p' | awk '{print $4}' > $TMPFILE
                            #avail=`cat $TMPFILE`
                            df -h $disk$j | sed -n '2p' | awk '{print $5}' > $TMPFILE
                            use=`cat $TMPFILE`
                            df -k $disk$j | sed -n '2p' | awk '{print $4}' > $TMPFILE
                            avail_1k_blocks=`cat $TMPFILE`
                            df -k $disk$j | sed -n '2p' | awk '{print $3}' > $TMPFILE
                            used_1k_blocks=`cat $TMPFILE`
                            avail=`sh $SCRIPT_SIZE2H $avail_1k_blocks`

                            umount $disk$j
#                            echo -e ">>>>>>>>>> linux:Success <<<<<<<<<<\n\n"
                        else
#                            echo -e ">>>>>>>>>> mount: Failed <<<<<<<<<<"
                            size='unknown'
                            avail='unknown'
                            use='unknown'
                            avail_1k_blocks='0'
                            used_1k_blocks='0'
                        fi
                    fi
                else
                    size='unknown'
                    avail='unknown'
                    use='unknown'
                    avail_1k_blocks='0'
                    used_1k_blocks='0'
                fi

                # save info
                echo -n "$disk " >> $CONFFILE
                echo -n "$DISKCAPA " >> $CONFFILE
                echo -n "$disk_capabytes " >> $CONFFILE
                echo -n "$CYL " >> $CONFFILE
                echo -n "$HPC " >> $CONFFILE
                echo -n "$SPT " >> $CONFFILE
                echo -n "$j " >> $CONFFILE
                echo -n "$ebrp1_boot " >> $CONFFILE
                echo -n "$ebrp1_type " >> $CONFFILE
                echo -n "$part_cylstart " >> $CONFFILE
                echo -n "$part_cylend " >> $CONFFILE
                echo -n "$((0x$lbastart + 0x$last_ebrp2_start + 0x$ebrp1_start)) " >> $CONFFILE
                echo -n "$((0x$lbastart + 0x$last_ebrp2_start + 0x$ebrp1_start + 0x$ebrp1_count - 1)) " >> $CONFFILE
                echo -n "$size " >> $CONFFILE
                echo -n "$avail " >> $CONFFILE
                echo -n "$use " >> $CONFFILE
                echo -n "$avail_1k_blocks " >> $CONFFILE
                echo -n "$used_1k_blocks " >> $CONFFILE
                echo -n "$VENDOR " >> $CONFFILE
                echo "$MODEL" >> $CONFFILE


                rm -f $EBRTMPFILE
                tmp_i=$((0x$ebrp2_start))
                tmp_j=$((0x$first_ebr_start))
                SKIP_SECTOR=$(($tmp_i + $tmp_j))
                dd if=$disk of=$EBRTMPFILE bs=512 count=1 skip=$SKIP_SECTOR 


                last_ebrp2_start=$ebrp2_start
                counter=$(expr $counter + 1)
                j=$(expr $j + 1)
            done
#set +x
# if partition type is 82 (Linux swap/Solaris) or any other partition type
        else
            part_cylstart=`fdisk -l $disk | grep "^$disk$i" | sed "s/\*//" | awk '{print $2}'`
            part_cylend=`fdisk -l $disk | grep "^$disk$i" | sed "s/\*//" | awk '{print $3}'`
            size='unknown'
            avail='unknown'
            use='unknown'
            avail_1k_blocks='0'
            used_1k_blocks='0'

            # save info
            echo -n "$disk " >> $CONFFILE
            echo -n "$DISKCAPA " >> $CONFFILE
            echo -n "$disk_capabytes " >> $CONFFILE
            echo -n "$CYL " >> $CONFFILE
            echo -n "$HPC " >> $CONFFILE
            echo -n "$SPT " >> $CONFFILE
            echo -n "$partno " >> $CONFFILE
            echo -n "$partboot " >> $CONFFILE
            echo -n "$parttype " >> $CONFFILE
            echo -n "$part_cylstart " >> $CONFFILE
            echo -n "$part_cylend " >> $CONFFILE
            echo -n "$((0x$lbastart)) " >> $CONFFILE
            echo -n "$((0x$lbastart + 0x$lbacount - 1)) " >> $CONFFILE
            echo -n "$size " >> $CONFFILE
            echo -n "$avail " >> $CONFFILE
            echo -n "$use " >> $CONFFILE
            echo -n "$avail_1k_blocks " >> $CONFFILE
            echo -n "$used_1k_blocks " >> $CONFFILE
            echo -n "$VENDOR " >> $CONFFILE
            echo "$MODEL" >> $CONFFILE
        fi
    done
    last_disk=${disk}
done

exec 1>&5 2>&6

exit 0

