#/bin/sh
# convert from 1K blocks to human readable format

ret=1

if ! [ $# -eq 1 ] ; then
    exit $ret
fi

block_1k=$1

if [ 1 -eq `echo "$block_1k == 0" | bc` ] ; then
    echo "0KB"
    ret=0
    exit $ret
fi

ans_int=$block_1k
ans_float=$block_1k
scale=1024
i=0
until [ 1 -eq `echo "$ans_int < $scale" | bc` ] ; do
    ans_int=`echo "$ans_int / $scale" | bc`
    i=$(($i + 1))
done

scale_float=`echo "${scale}^${i}" | bc`
ans_float=`awk -v var1=${ans_float} -v var2=${scale_float} 'BEGIN{printf("%.1f",var1/var2)}'` 
if [ ${ans_float%.*} -ge $scale ] ; then
    i=$(($i + 1))
    ans_float=`awk -v var1=${ans_float} -v var2=${scale} 'BEGIN{printf("%.1f",var1/var2)}'` 
fi

ans_float=${ans_float%.0}

case $i in
    0)
        ans_suffix="KB"
        ;;
    1)
        ans_suffix="MB"
        ;;
    2)
        ans_suffix="GB"
        ;;
    3)
        ans_suffix="TB"
        ;;
    *)
        ret=2
        echo "0KB"
        exit $ret
        ;;
esac

echo "${ans_float}${ans_suffix}"
exit $ret

