#!/bin/sh
# umount_dir.sh
# FUNCTION: try to umount given directory
# RETVALUE: if no service attaches to given directory or if umount the service successfully, return 0;
# otherwise, return 0.

source import_debug.sh

if [ "x$HOST_DEBUG" == "x" ] ; then
    ROOTDIR=''
else
    ROOTDIR='/home/bright/tc/tc-project/ramdisk/imgexport_diff'
    #ROOTDIR='/localdisk/szl/tc_repo/ramdisk/imgexport_diff'
fi

LOG=${ROOTDIR}'/var/log/tcsh.log'
SH_PATH=$0
SH_NAME=${SH_PATH##*/}

exec 5>&1 6>&2
exec 1>>$LOG 2>&1
echo "$SH_NAME:"

help_msg (){
    echo "Usage:"
    echo "    $SH_NAME <ServerIP>"
    echo "    for example: $SH_NAME /mnt/usb"
}

if [ $# -ne 1 ] ; then
    help_msg
    exit 1
else
    MOUNTDIR=$1
fi

# MOUNTDIR=${ROOTDIR}'/mnt/usb'

# If $MOUNTDIR is mounted, umount it
echo -n "Check whether $MOUNTDIR attaches any resources..."
mount | grep -q "$MOUNTDIR"
cmdret=$?
while [ $cmdret -eq 0 -a $? -eq 0 ] ; do
	echo "yes"

#    cnt=0
    umount -f $MOUNTDIR 
#    while [ $? -ne 0 -a $cnt -lt 10 ] ; do
#        cnt=$(expr $cnt + 1)
#        echo "Failed to umount $MOUNTDIR"
#        echo "Try to umount $MOUNTDIR again..."
#        umount -f $MOUNTDIR 
#    done

    if [ $? -eq 0 ] ; then
		echo "Successfully umounted $MOUNTDIR"
	else
        echo "Failed to umount $MOUNTDIR"
        exit 2
    fi

    mount | grep -q "$MOUNTDIR"
done

if [ $cmdret -ne 0 ] ; then
    echo "no"
fi



exec 1>&5 2>&6

exit 0
