#!/bin/sh
# umount_smb.sh
# FUNCTION: try to umount samba services
# RET VALUE: if no service to umount or if umount successfully, return 0;
# otherwise, return a non-zero value.


source import_debug.sh

if [ "x$HOST_DEBUG" == "x" ] ; then
    ROOTDIR=''
else
    ROOTDIR='/home/bright/tc/tc-project/ramdisk/imgexport_diff'
fi

MTDIR=$ROOTDIR'/mnt/usb'
LOG=${ROOTDIR}'/var/log/tcsh.log'
SH_PATH=$0
SH_NAME=${SH_PATH##*/}

exec 5>&1 6>&2
exec 1>>$LOG 2>&1
echo "$SH_NAME:"

help_msg (){
    echo "Usage:"
    echo "    $SH_NAME <SambaService>"
    echo "    for example: $SH_NAME //192.168.0.1/tcimage"
}

if [ $# -ne 1 ] ; then
    help_msg
    exit 1
else
    REMOTEDIR=$1
fi

# If it has been mounted, just try to umount it firstly
echo -n "Check whether samba service has be mounted..."
mount | grep -q "$REMOTEDIR"
cmdret=$?
while [ $cmdret -eq 0 -a $? -eq 0 ] ; do
    umount -f $MTDIR

    if [ $? -eq 0 ] ; then
        echo "Successfully umounted samba service $REMOTEDIR"
        exit 0
    else
        echo "Failed to umount samba service $REMOTEDIR"
        exit 2
    fi

    mount | grep -q "$REMOTEDIR"
done


exec 1>&5 2>&6

exit 0
