/******************************************************************************
Copyright 2012 - 2020 Intel Corporation
 
For licensing information, see the file 'LICENSE' in the root folder of
  this software module. 
******************************************************************************/

#ifndef __DEBUG_H__
#define __DEBUG_H__

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define ENABLE_DEBUG			1

#define ERR(fmt,arg...)         do {\
                                  printf(fmt,##arg);\
                                } while(0)

#define PRT(fmt,arg...)         do {\
                                  printf(fmt,##arg);\
                                } while(0)

#if ENABLE_DEBUG
#define DEBUG(fmt,arg...)      do {\
                                printf(fmt,##arg);\
                              } while(0) 

#define MSG(fmt,arg...)         do {\
                                  printf(fmt,##arg);\
                                } while(0)

#else
#define DEBUG(fmt,arg...)      
#define MSG(fmt,arg...)    

#endif                                
                                
#endif

