/******************************************************************************
Copyright 2012 - 2020 Intel Corporation
 
For licensing information, see the file 'LICENSE' in the root folder of
  this software module. 
******************************************************************************/

#ifndef __SESSION_H__
#define __SESSION_H__
#include <sys/types.h>
#include "protocol.h"
#include "common.h"

#define MAX_OSLIST_ITEM 	512

typedef struct _tc_hd_t{
  tc_pkt_t *snd_pkt;
  tc_pkt_t *rcv_pkt;
  SERVER_CONFIG *s_config;
} tc_hd_t;

extern tc_hd_t tc_hd[2];

int do_auth(tc_hd_t *hd, char *username, char *password);

void free_pkt_list(tc_hd_t *);
int get_user_id();
int disconnect();
int do_upload();
int do_upload_data();
int do_upload_check();
int do_upload_check_data();
int do_sync();
int do_sync_data();
int auth_user();
int allc_pkt_list(tc_hd_t *);

#endif
