/******************************************************************************
Copyright 2012 - 2020 Intel Corporation
 
For licensing information, see the file 'LICENSE' in the root folder of
  this software module. 
******************************************************************************/

#ifndef __CLIENT_H__
#define __CLIENT_H__

typedef struct {
	int usedIdx;
	int sock;

	int userid;
	char *username;	  //name of user
	unsigned char addr[6];

	int hb_count;
	int hb_lost_timeout;
	int boot_timeout;

	int image_id;
	char *image_name;

	IMAGE_ACCESS imageaccess;
	CLIENT_STATUS status;

#ifdef SDL_BUILD_ENABLE
	SSL *p_ssl;
#endif
} Client;

void client_array_init(Client *, int);
int setup_client(Client *client, tc_pkt_t *p);
int get_client(Client client_array[], unsigned char *, char *);
void free_client(Client *);
int mark_client_invalid(Client *);

#endif
