/******************************************************************************
Copyright 2012 - 2020 Intel Corporation
 
For licensing information, see the file 'LICENSE' in the root folder of
  this software module. 
******************************************************************************/

#ifndef __DB_H__
#define __DB_H__

#define ENCRYPT_ITERATION_TIMES		100000
#define SALT_LEN					32
#define PWD_LEN						32
#define PBKDF2_DIG_ALGORITHM        EVP_sha256()

//start the database connection
int start_db(char *name, char *pwd);

//close the database connection
void end_db();

int escape_parameter(char **pEscapedStr,
	char *pSrcStr);

int get_user_status(char *username, int osimageid);
int is_autoboot_user(char *username);
void reset_all_status();

int update_server_status(int server_id,int status);

int insert_user_status(char *username, int imageid, char *ip, int imageaccess, int online);

int update_user_status(char *, int, int);
int update_image_status(char* rawfile, char* newfile, int needupdate);

int update_server_status(int server_id,int status);

int insert_user_login_log(int userid, 
	char *username, 
	char *event, 
	int result);
int get_user_oslist(char *, char *, char **, int *, int);

//int get_ospath_by_name(char *name, char *path, size_t);
char * get_default_server_config(int, char *);
int is_image_locked(char* osimage_id);
int is_image_seed_ready(int);
int get_osimageid_by_name(char *name);
int get_osimageid_by_id(char *id);
int get_osimagename_by_id(char *osid, char *imagename, int imagenameLen);
int get_imageaccess(char *osname, char* username, IMAGE_ACCESS *imageaccess);
int update_image_status_by_id(char* imagename, int needupdate);
int delete_user_status(char *username, int osimageid);
int get_image_cur_ver(int userId, char *osimage_id, char *cur_ver) ;
int get_image_update_list(int, char *,int, int, char *);
int get_data_image_size(int, char *, char *, size_t);
int get_data_image_cur_ver(int userId,
		char *osimage_id, 
		char *cur_ver);
int get_user_id(char *username);
int get_data_image_update_list(
		int user_id, 
		char *osimage_id, 
		int start_ver,
		int end_ver,
		char *outlist);
int is_data_image_locked(char *,int);
char *get_udf_dir();
char *get_home_tc_dir();
char *get_home_var_dir();
char *get_lic_file();
char *get_ca_dir();
int get_login_failure_interval();

#endif
