/******************************************************************************
Copyright 2012 - 2020 Intel Corporation
 
For licensing information, see the file 'LICENSE' in the root folder of
  this software module. 
******************************************************************************/

#ifndef __DEBUG_H__
#define __DEBUG_H__

#include "predefine.h"

#define LOG_SRV_NAME		"tc-sync-server"
// Set ENABLE_DEBUG to 1 if you want a debugging version of tc-server 
// Otherwise set ENABLE_DEBUG to 0 
#define ENABLE_DEBUG 		1
//Whether to print the read/write detail infos
#define RW_DEBUG			0


#if RUN_IN_DAEMON_MODE
#define MSG(fmt,arg...) do {\
							syslog(LOG_INFO,fmt,##arg);\
							}while(0)
#define TC_OUTPUT(fmt,arg...) do {\
							syslog(LOG_ERR,fmt,##arg);\
							printf(fmt,##arg);\
							}while(0)

#define ERR(fmt,arg...) do {\
							syslog(LOG_ERR,fmt,##arg);\
							printf(fmt,##arg);\
							}while(0)

#define PERR(msg) 		do {\
							syslog(LOG_ERR,msg);\
							printf(msg);\
							}while(0)

#if ENABLE_DEBUG
#define DEBUG(fmt,arg...)     do {\
								syslog(LOG_INFO,fmt,##arg);\
							  }while(0)
                               
                                
#else
#define DEBUG(fmt,arg...)
#endif

#else
#define MSG(fmt,arg...)         do {\
                                  printf(fmt,##arg);\
                                } while(0)

#define TC_OUTPUT(fmt,arg...)   do {\
                                  printf(fmt,##arg);\
                                } while(0)
                        
#define ERR(fmt,arg...)         do {\
                                  printf(fmt,##arg);\
                                } while(0) 

#define PERR(msg)        		do {\
                                  perror(msg);\
                                } while(0)


#if ENABLE_DEBUG
#define DEBUG(fmt,arg...)      do {\
                                printf(fmt,##arg);\
                              } while(0) 
                             
                              
#else
#define DEBUG(fmt,arg...)
#endif                                
                                
#endif

#if RW_DEBUG
#define TC_RW_DEBUG(fmt,arg...)  do {\
                                    printf(fmt, ##arg);\
                                  } while(0)
#else
#define TC_RW_DEBUG(fmt,arg...)
#endif

void logging_init(void); 

#endif
