@Rem @file
@echo off
setlocal enableExtensions enableDelayedExpansion
set thisScript=%~0
set exitCode=0

:LabelParseArgs
if /i "%~1"=="" (
  goto LabelContinue
) else if /i "%~1"=="/?" (
  set opHelp=1
) else if /i "%~1"=="/h" ( 
  set opHelp=1
) else if /i "%~1"=="/help" (
  set opHelp=1
) else if /i "%~1"=="--enable" (
  set opUsbAccessMode=%~2
  if /i "!opUsbAccessMode!" == "" (
    shift
    goto WrongArgs
  ) else (
    shift
  )
  if /i not "!opUsbAccessMode!" == "1" set opUsbAccessMode=0
)
shift
goto LabelParseArgs

:LabelContinue
if /i "%opHelp%" == "1" goto Usage
if not defined opUsbAccessMode goto WrongArgs
echo opUsbAccessMode = %opUsbAccessMode%
echo.

@Rem
@Rem ===========================================================================
@Rem
echo usb access mode: %opUsbAccessMode%
if /i "%opUsbAccessMode%"=="0" (
  call :FooDisableUsbAccess
) else if /i "%opUsbAccessMode%"=="1" (
  call :FooEnableUsbAccess
)

set exitCode=%errorlevel%
goto ExitLabel


:FooEnableUsbAccess
REM reg add "HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Control\StorageDevicePolicies" /v WriteProtect /t reg_dword /d 0 /f
reg add "HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Services\USBSTOR" /v Start /t reg_dword /d 3 /f
reg add "HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Services\WUDFRd" /v Start /t reg_dword /d 3 /f 

copy %Windir%\usbstor.inf %Windir%\inf\usbstor.inf /y
if %errorlevel% equ 0 ( del %Windir%\usbstor.inf /q /f )
copy %Windir%\usbstor.pnf %Windir%\inf\usbstor.pnf /y
if %errorlevel% equ 0 ( del %Windir%\usbstor.pnf /q /f )

c:\setcon.exe -e usbstor\*
c:\setcon.exe -e USB\MS_COMP_MTP
exit /b 0

:FooDisableUsbAccess
REM reg add "HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Control\StorageDevicePolicies" /v WriteProtect /t reg_dword /d 1 /f
reg add "HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Services\USBSTOR" /v Start /t reg_dword /d 4 /f
reg add "HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Services\WUDFRd" /v Start /t reg_dword /d 4 /f

c:\setcon.exe -d usbstor\*
c:\setcon.exe -d USB\MS_COMP_MTP

copy %Windir%\inf\usbstor.inf %Windir%\usbstor.inf /y
if %errorlevel% equ 0 ( del %Windir%\inf\usbstor.inf /q /f )
copy %Windir%\inf\usbstor.pnf %Windir%\usbstor.pnf /y
if %errorlevel% equ 0 ( del %Windir%\inf\usbstor.pnf /q /f )
exit /b 0

:WrongArgs
echo -- try "%thisScript% /?" for more details.
set exitCode=1
goto ExitLabel

:Usage
echo Usage: %thisScript% --enable {0 ^| 1}
set exitCode=1

:ExitLabel
(
  echo.
  echo -- %date% %time%
  echo.
  echo -- batch exit code: !exitCode!
  endlocal
  exit /b !exitCode!
)