@echo off
@set srcAppDir=tc_app\
@set srcDrvDir=tc_drv\
@set srcVfsDrvDir=tcvfs_drv\
@set srcVrsDrvDir=tcvrs_drv\
@set fsDrvDir=Ext2Fsd-*\
@set fsSubDir=Ext2Fsd\Setup\
@set fsInstallBat=Setup.bat
@set fsInstallFailed=0
@set tcVfsInstallFailed=0
@set tcVrsInstallFailed=0
@set appInstallBat=app_install.bat
@set drvInstallBat=drv_install.bat
@set grantAdminBat=grantadmin.vbs

@>nul 2>&1 "%SYSTEMROOT%\system32\cacls.exe" "%SYSTEMROOT%\system32\config\system"  
 
@if "%errorlevel%" NEQ "0" (  
    @echo Requesting administrative privileges...  
    @goto PromptUac
) else ( goto grantAdmin )  
 
@:PromptUac  
    @echo Set UAC = CreateObject^("Shell.Application"^) > "%temp%\%grantAdminBat%"  
    @echo UAC.ShellExecute "%~s0", "", "", "runas", 1 >> "%temp%\%grantAdminBat%"  
 
    @"%temp%\%grantAdminBat%"  
    @exit /B 1 
 
@:grantAdmin  
    @if exist "%temp%\%grantAdminBat%" ( del "%temp%\%grantAdminBat%" )  
    @pushd "%CD%"  
    @cd /D "%~dp0"  

:install_fs_drv
@echo off
echo 1. Installing FS driver ...
cd %fsDrvDir%
if "%errorlevel%" NEQ "0" (  
    echo Failed to install Fs driver: %fsDrvDir% not found  
    echo Please install it manually later
    set fsInstallFailed=1
    goto install_app
) 

cd %fsSubDir%
if "%errorlevel%" NEQ "0" (  
    echo Failed to install Fs driver: %fsSubDir% not found 
    echo Please install it manually later
    set fsInstallFailed=1
    goto install_app
)

call "%fsInstallBat%"
if "%errorlevel%" NEQ "0" (  
    echo=
    echo Failed to install Fs driver: %fsInstallBat% error 
    echo Please install it manually later
    echo=
    set fsInstallFailed=1
    goto install_app
)

:install_app
@echo off
@cd /D "%~dp0" 
echo.
echo 2. Installing TC app ...
cd %srcAppDir%
if "%errorlevel%" NEQ "0" (  
    echo=
    echo Failed to install app: %srcAppDir% not found
    echo=
    goto install_err
)

call "%appInstallBat%"
if "%errorlevel%" NEQ "0" (
    goto install_err
)

:install_drv
@echo off
@cd /D "%~dp0" 
echo=
echo 3. Installing TC storage driver ...
cd %srcDrvDir%
if "%errorlevel%" NEQ "0" (  
    echo Failed to install TC storage driver: %srcDrvDir% not found
    goto install_err
)

call "%drvInstallBat%"

if "%errorlevel%" NEQ "0" (
    goto install_err
)

set tcVfsInstallFailed=2
set tcVrsInstallFailed=2

:install_vfs_drv
@echo off
@cd /D "%~dp0" 
echo=
echo 4. Installing TC VFS driver ...
cd %srcVfsDrvDir%
if "%errorlevel%" NEQ "0" (  
    echo Failed to install TC VFS driver: %srcVfsDrvDir% not found
    goto install_ok
)

call "%drvInstallBat%"

set tcVfsInstallFailed=%errorlevel%

if "%tcVfsInstallFailed%" EQU "2" (
    goto install_ok
)

if "%tcVfsInstallFailed%" NEQ "0" (
    goto install_err
)

:install_vrs_drv
@echo off
@cd /D "%~dp0" 
echo=
echo 5. Installing TC VRS driver ...
cd %srcVrsDrvDir%
if "%errorlevel%" NEQ "0" (  
    echo Failed to install TC VRS driver: %srcVrsDrvDir% not found
    goto install_ok
)

call "%drvInstallBat%"

set tcVrsInstallFailed=%errorlevel%

if "%tcVrsInstallFailed%" EQU "2" (
    goto install_ok
)

if "%tcVrsInstallFailed%" NEQ "0" (
    goto install_err
)

:install_ok
echo=
echo Congratulations, Installation completed!
echo=
if "%fsInstallFailed%" == "1" (
echo However, FS driver installation failed, please install it manually later
echo=
)
if "%tcVfsInstallFailed%" == "2" (
echo Warning: TCVFS driver was not installed since it was missing, or did not support current OS
echo=
)
if "%tcVrsInstallFailed%" == "2" (
echo Warning: TCVRS driver was not installed since it was missing, or did not support current OS
echo=
)
pause

@cd /D "%~dp0"
exit /B 0

:install_err
echo=
echo Error: Installation failed!
echo=
pause
@cd /D "%~dp0"
exit /B 1
