@echo off
@set drvSrcDir=.
@set tccDrvFile=tcvfs.sys
@set tccDrvCatFile=tcvfs.cat
@set tccDrvInf=tcvfs.inf
@set win7Os=win7
@set win10Os=win10
@set xpOs=wxp
@set x86Arch=i386
@set x64Arch=amd64
@set PreInstallBat=pre_install.bat
@set PostInstallBat=post_install.bat
@set grantAdminBat=grantadmin.vbs
@set errorCode=1
@set defaultUserName=tc
@set installMode=2
@set checkFileExist=

@>nul 2>&1 "%SYSTEMROOT%\system32\cacls.exe" "%SYSTEMROOT%\system32\config\system"  
 
@if "%errorlevel%" NEQ "0" (  
    @echo Requesting administrative privileges...  
    @goto PromptUac
) else ( goto grantAdmin )  
 
@:PromptUac  
    @echo Set UAC = CreateObject^("Shell.Application"^) > "%temp%\%grantAdminBat%"  
    @echo UAC.ShellExecute "%~s0", "", "", "runas", 1 >> "%temp%\%grantAdminBat%"  
 
    @"%temp%\%grantAdminBat%"  
    @exit /B 1 
 
@:grantAdmin  
    @if exist "%temp%\%grantAdminBat%" ( del "%temp%\%grantAdminBat%" )  
    @pushd "%CD%"  
    @cd /D "%~dp0"  

if %1.==help. goto show_help
if %1.==. goto detect_os_arch
if %2.==. goto show_help

set targetOs=%1
set targetArch=%2
goto install_drv

:detect_os_arch

ver | findstr /i "5\.1\." > nul
if %ERRORLEVEL% EQU 0 set targetOs=%xpOs%
ver | findstr /i "5\.2\." > nul
if %ERRORLEVEL% EQU 0 set targetOs=%xpOs%
ver | findstr /i "6\.0\." > nul
if %ERRORLEVEL% EQU 0 set targetOs=%win7Os%
ver | findstr /i "6\.1\." > nul
if %ERRORLEVEL% EQU 0 set targetOs=%win7Os%
ver | findstr /i "6\.2\." > nul
if %ERRORLEVEL% EQU 0 set targetOs=%win7Os%
ver | findstr /i "6\.3\." > nul
if %ERRORLEVEL% EQU 0 set targetOs=%win7Os%
ver | findstr /i "10\.0\." > nul
if %ERRORLEVEL% EQU 0 set targetOs=%win10Os%
ver | findstr /i "10\.1\." > nul
if %ERRORLEVEL% EQU 0 set targetOs=%win10Os%
ver | findstr /i "10\.2\." > nul
if %ERRORLEVEL% EQU 0 set targetOs=%win10Os%
ver | findstr /i "10\.3\." > nul
if %ERRORLEVEL% EQU 0 set targetOs=%win10Os%
ver | findstr /i "10\.4\." > nul
if %ERRORLEVEL% EQU 0 set targetOs=%win10Os%

if %targetOs%. == . goto unknown_os_arch

if "%PROCESSOR_ARCHITECTURE%"=="AMD64" set targetArch=%x64Arch%
if "%PROCESSOR_ARCHITEW6432%"=="AMD64" set targetArch=%x64Arch%
if "%PROCESSOR_ARCHITECTURE%"=="X86" set targetArch=%x86Arch%
if "%PROCESSOR_ARCHITECTURE%"=="x86" set targetArch=%x86Arch%
if %targetArch%. == . goto unknown_os_arch

set checkFileExist="%drvSrcDir%\%targetOs%\%targetArch%\%tccDrvFile%"
if not exist %checkFileExist% goto file_not_exist

set checkFileExist="%drvSrcDir%\%tccDrvInf%"
if not exist %checkFileExist% goto file_not_exist

set checkFileExist=

if exist "%PreInstallBat%" ( 
    call %PreInstallBat%
)
if %errorlevel% NEQ 0 goto sys_error

copy /y "%drvSrcDir%\%targetOs%\%targetArch%\%tccDrvFile%" "%drvSrcDir%\" >nul
if exist "%drvSrcDir%\%targetOs%\%targetArch%\%tccDrvCatFile%" (
  copy /y "%drvSrcDir%\%targetOs%\%targetArch%\%tccDrvCatFile%" "%drvSrcDir%\" >nul
)

if exist "%windir%\system32\drivers\%tccDrvFile%" (
	set installMode=1
	echo TC VFS driver was installed before, do you want to:
	echo 1. Update driver
	echo 2. Reinstall dirver
	set /p installMode="Please select[1(Default) or 2]:"
)

fltmc unload tcvfs

echo=
if "%installMode%" NEQ "2" (
	echo Updating driver
    goto UpdateDrvFiles
) else (
    echo Reinstalling driver
)

:install_drv

copy /y "%drvSrcDir%\%tccDrvInf%" "%windir%\inf" > NUL
rundll32.exe setupapi.dll,InstallHinfSection DefaultUnInstall 132 %drvSrcDir%\%tccDrvInf%
rundll32.exe setupapi.dll,InstallHinfSection DefaultInstall 132 %drvSrcDir%\%tccDrvInf%

if "%errorlevel%" NEQ "0" (  
    echo=
    echo Failed to run rundll32.exe
    echo=
    goto sys_error
)

:UpdateDrvFiles

copy /y "%drvSrcDir%\%tccDrvFile%" "%windir%\system32\drivers" > NUL

if %errorlevel% NEQ 0 goto file_not_updated

REM if "%username%" equ "%defaultUserName%" goto OtherSettings
REM reg add "HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\services\TcVfs" /v ".UserLinkFolder" /t reg_sz /d "%username%" /f >nul

reg add "HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\services\TcVfs" /v "Start" /t reg_dword /d 0x00000001 /f >nul

:OtherSettings

if exist "%PostInstallBat%" ( 
    call %PostInstallBat%
)
if %errorlevel% NEQ 0 goto sys_error

goto sys_exit

:file_not_updated
echo=
echo Error: file %drvSrcDir%\%targetOs%\%targetArch%\%tccDrvFile% does NOT updated!
echo=
goto sys_error

:file_not_exist
echo=
if "%targetOs%" == "%win10Os%" (
echo TCVFS driver was missing, or did not support current OS yet, will skip the installation
set errorCode=2
) else (
echo Error installing TCVFS driver: file %checkFileExist% does NOT exist !
)
echo=
goto sys_error

:unknown_os_arch
echo can not determine OS version or system arch. please setup manually.
:show_help
echo -------------------------------------------------------------------------------
echo TCC driver installation:
echo -------------------------------------------------------------------------------
echo  Manual installation:
echo   setup %win7Os%  %x86Arch%        - Install tccdriver to Windows WIN7/WIN8 X86
echo   setup %win7Os%  %x64Arch%        - Install tccdriver to Windows WIN7/WIN8 AMD64
echo   setup %win10Os%  %x86Arch%        - Install tccdriver to Windows WIN10 X86
echo   setup %win10Os%  %x64Arch%        - Install tccdriver to Windows WIN10 AMD64
echo -------------------------------------------------------------------------------

:sys_error
if exist "%drvSrcDir%\%tccDrvFile%" del "%drvSrcDir%\%tccDrvFile%"
if exist "%drvSrcDir%\%tccDrvCatFile%" del "%drvSrcDir%\%tccDrvCatFile%"
exit /B %errorCode%

:sys_exit
if exist "%drvSrcDir%\%tccDrvFile%" del "%drvSrcDir%\%tccDrvFile%"
if exist "%drvSrcDir%\%tccDrvCatFile%" del "%drvSrcDir%\%tccDrvCatFile%"
exit /B 0
