/******************************************************************************
Copyright 2016 - 2019 Intel Corporation
 
For licensing information, see the file 'LICENSE' in the root folder of
  this software module. 
******************************************************************************/

#ifndef INITDISKPAGE_H
#define INITDISKPAGE_H


#include <QProcess>
#include <MApplicationPage>

class MLabel;
class MProgressIndicator;


class InitDiskPage : public MApplicationPage
{
    Q_OBJECT

public:
    InitDiskPage(int nImgPartMB);
    virtual ~InitDiskPage();

    virtual void createContent();

protected:
    void ShowMessage(const QString &msg);

private slots:
    void onPsError(QProcess::ProcessError errCode);
    void onPsFinished(int exitCode, QProcess::ExitStatus exitStatus);

private:
    MProgressIndicator *spinner;
    MLabel  *lbPrompt;

    QProcess psTcSync;

    int nImgPart;
};


#endif // INITDISKPAGE_H
