/******************************************************************************
Copyright 2016 - 2019 Intel Corporation
 
For licensing information, see the file 'LICENSE' in the root folder of
  this software module. 
******************************************************************************/

#include <QGraphicsLinearLayout>
#include <MLabel>
#include <MDebug>

#include "inputdialog.h"


InputDialog::InputDialog(const QString &title, const QString &text)
  : MDialog(title, M::OkButton|M::CancelButton)
{
    MLabel *label;

    mDebug("InputDialog::InputDialog");

    setObjectName("inputDialog");

    label = new MLabel(text);
    label->setObjectName("inputLabel");
    label->setStyleName("CommonBodyTextInverted");
    label->setAlignment(Qt::AlignLeft | Qt::AlignVCenter);

    edit = new MTextEdit;
    edit->setObjectName("inputdlg_te");
    edit->setEchoMode(MTextEditModel::Password);

    QGraphicsLinearLayout *layout = new QGraphicsLinearLayout(Qt::Vertical);
    layout->setContentsMargins(0, 0, 0, 0);
    layout->setSpacing(0);
    layout->addItem(label);
    layout->addItem(edit);

    centralWidget()->setLayout(layout);

    connect(edit, SIGNAL(returnPressed()), this, SLOT(accept()));
    connect(this, SIGNAL(appeared()), SLOT(setfocusOnTextEdit()));
}

InputDialog::~InputDialog()
{
    mDebug("InputDialog::~InputDialog");
}

void InputDialog::setfocusOnTextEdit()
{
    edit->setFocus();
}

