/******************************************************************************
Copyright 2016 - 2019 Intel Corporation
 
For licensing information, see the file 'LICENSE' in the root folder of
  this software module. 
******************************************************************************/

#ifndef INPUTPANEL_H
#define INPUTPANEL_H

#include <QtGui>
#include <QtCore>

#include "ui_inputpanelform.h"


class InputPanel : public QWidget
{
    Q_OBJECT

public:
    InputPanel();

signals:
    void characterGenerated(QChar character);

protected:
    bool event(QEvent *e);

private slots:
    void saveFocusWidget(QWidget *oldFocus, QWidget *newFocus);
    void buttonClicked(QWidget *w);

private:
    Ui::InputPanelForm form;
    QWidget *lastFocusedWidget;
    QSignalMapper signalMapper;
    QPushButton *pButtons[33];
    bool capslock;
    bool numlock;
};


#endif // INPUTPANEL_H
