/******************************************************************************
Copyright 2016 - 2019 Intel Corporation
 
For licensing information, see the file 'LICENSE' in the root folder of
  this software module. 
******************************************************************************/

#ifndef INPUTPANELCONTEXT_H
#define INPUTPANELCONTEXT_H

#include <QtGui/QInputContext>

#include "inputpanel.h"

class InputPanel;


class InputPanelContext : public QInputContext
{
    Q_OBJECT

public:
    InputPanelContext();
    ~InputPanelContext();

    bool filterEvent(const QEvent* event);

    QString identifierName();
    QString language();

    bool isComposing() const;

    void reset();

private slots:
    void sendCharacter(QChar character);

private:
    void updatePosition();

private:
    InputPanel *inputPanel;
};


#endif // INPUTPANELCONTEXT_H
