/******************************************************************************
Copyright 2016 - 2019 Intel Corporation
 
For licensing information, see the file 'LICENSE' in the root folder of
  this software module. 
******************************************************************************/

#include <QFile>
#include <MBanner>

#include "misc.h"


void readLine(const char *filename, QString &str)
{
    QFile file(filename);

    if (file.open(QIODevice::ReadOnly | QIODevice::Text))
    {
        char buf[128];
        // The newline character ('\n') is included in the buffer.
        if (file.readLine(buf, sizeof(buf)) )
        {
            str = buf;
            str = str.trimmed();
        }
        file.close();
    }
}

void writeLine(const char *filename, const QString &str)
{
    QFile file(filename);

    if (file.open(QIODevice::WriteOnly | QIODevice::Text))
    {
        file.write(str.toUtf8());
        file.close();
    }
}

void displayBanner(const MApplicationPage *page, const QString &msg)
{
    if (!page->isOnDisplay())
    {
        return;
    }

    MBanner *bnError = new MBanner;
    bnError->setObjectName("comm_bn_error");
    bnError->setStyleName(MBannerType::SystemBanner);
    bnError->setIconID("icon-m-common-error");
    bnError->setTitle(msg);
    bnError->appear(page->scene(), MSceneWindow::DestroyWhenDone);
}

