/******************************************************************************
Copyright 2016 - 2019 Intel Corporation
 
For licensing information, see the file 'LICENSE' in the root folder of
  this software module. 
******************************************************************************/

#include <QGraphicsLinearLayout>
#include <QProcess>
#include <MButton>
#include <MDebug>

#include "powerdialog.h"


PowerDialog::PowerDialog()
  : MDialog(qtTrId("Would you like to..."), M::NoStandardButton)
{
    mDebug("PowerDialog::PowerDialog");

    setObjectName("powerDialog");

    QGraphicsLinearLayout *layout = new QGraphicsLinearLayout(Qt::Horizontal, centralWidget());

    MButton *btnReboot= new MButton(qtTrId("Reboot"));
    btnReboot->setObjectName("power_btn_reboot");
    btnReboot->setViewType(MButton::iconType);
    btnReboot->setIconID("icon-reboot");
    btnReboot->setMaximumWidth(175);
    layout->addItem(btnReboot);

    MButton *btnShutdown= new MButton(qtTrId("Shut Down"));
    btnShutdown->setObjectName("power_btn_shutdown");
    btnShutdown->setViewType(MButton::iconType);
    btnShutdown->setIconID("icon-shutdown");
    btnShutdown->setMaximumWidth(175);
    layout->addItem(btnShutdown);

    connect(btnReboot, SIGNAL(clicked()), this, SLOT(onBtnRebootClicked()));
    connect(btnShutdown, SIGNAL(clicked()), this, SLOT(onBtnShutdownClicked()));
}

PowerDialog::~PowerDialog()
{
    mDebug("PowerDialog::~PowerDialog");
}

void PowerDialog::onBtnRebootClicked()
{
    QProcess::execute("/usr/sbin/tc/tc-shutdown.sh --reboot");
}

void PowerDialog::onBtnShutdownClicked()
{
    QProcess::execute("/usr/sbin/tc/tc-shutdown.sh --poweroff");
}

