/******************************************************************************
Copyright 2016 - 2019 Intel Corporation
 
For licensing information, see the file 'LICENSE' in the root folder of
  this software module. 
******************************************************************************/

#ifndef PROCESSPAGE_H
#define PROCESSPAGE_H


#include <QProcess>
#include <MApplicationPage>

class MLabel;
class MButton;
class MTextEdit;
class MProgressIndicator;


class ProcessPage : public MApplicationPage
{
    Q_OBJECT

public:
    ProcessPage(const QString &title, const QString &program, const QStringList &arguments);
    virtual ~ProcessPage();

    virtual void createContent();

protected:
    virtual void tapAndHoldGestureEvent(QGestureEvent *event, QTapAndHoldGesture *gesture);

    void ShowMessage(const QString &title, const QString &msg);

public slots:
    Q_SCRIPTABLE int SkipUpdates(int delay);

signals:
    void SkipUpdatesEvent(int delay);

private slots:
    void onBtnDetailClicked();
    void onPsError(QProcess::ProcessError errCode);
    void onPsFinished(int exitCode, QProcess::ExitStatus exitStatus);
    void onReadyRead();
    void onSkipUpdatesEvent(int delay);

private:
    QProcess process;
    QString desc;
    QString cmd;
    QStringList args;

    MProgressIndicator *spinner;
    MButton  *btnDetail;
    MLabel  *lbNetFlow;
    MLabel  *lbPrompt;
    QString  strPrompt;

    bool bOutEnabled;
    MTextEdit *txOutput;

    QByteArray fakecon;
    int lineStart;
    int lineEnd;
    int curPos;
};


#endif // PROCESSPAGE_H
