/******************************************************************************
Copyright 2016 - 2019 Intel Corporation
 
For licensing information, see the file 'LICENSE' in the root folder of
  this software module. 
******************************************************************************/

#ifndef REGMACHPAGE_H
#define REGMACHPAGE_H


#include <QProcess>
#include <MApplicationPage>

class MTextEdit;
class MButton;
class MProgressIndicator;


class RegMachPage : public MApplicationPage
{
    Q_OBJECT

public:
    RegMachPage(const QString &serverIP, const QString &clientName);
    virtual ~RegMachPage();

    virtual void createContent();

protected:
    void ShowMessage(bool bSucceed, const QString &msg);

private slots:
    void onBtnRegMachClicked();

    void onPsError(QProcess::ProcessError errCode);
    void onPsFinished(int exitCode, QProcess::ExitStatus exitStatus);

private:
    QString servIP;
    QString cltName;

    MProgressIndicator *spinner;
    MTextEdit *teMachName;
    MButton *btnRegMach;

    QProcess psTcSync;
};


#endif // REGMACHPAGE_H
