/******************************************************************************
Copyright 2016 - 2019 Intel Corporation
 
For licensing information, see the file 'LICENSE' in the root folder of
  this software module. 
******************************************************************************/

#ifndef SETTINGPAGE_H
#define SETTINGPAGE_H


#include <MApplicationPage>

class MButton;
class MTextEdit;
class MComboBox;


class SettingPage : public MApplicationPage
{
    Q_OBJECT

public:
    SettingPage(const QString &serverIP);
    virtual ~SettingPage();

    virtual void createContent();

protected:
    virtual void swipeGestureEvent(QGestureEvent *event, QSwipeGesture *gesture);

private:
    void readWifiCfg();
    void readIfaceList();
    void readNetCfg();

private slots:
    void onCfgNetTabPressed();

    void onBtnInitHdClicked();
    void onBtnChgWifiClicked();
    void onBtnDHCPOffClicked();
    void onBtnCfgNetClicked();
    void onBtnChgServIPClicked();

    void onAppeared();

public:
    bool bIPChanged;
    QString servIP;

private:
    MTextEdit *teWifiSSID;
    MTextEdit *teWifiPwd;
    MButton *btnChgWifi;

    MTextEdit *teImgPart;
    MButton *btnInitHd;

    MComboBox *cbIfaceList;
    MButton *btnDHCPOff;
    MTextEdit *teLocalIP;
    MTextEdit *teNetmask;
    MTextEdit *teGateway;
    MTextEdit *teDNS1;
    MTextEdit *teDNS2;
    MButton *btnCfgNet;

    MTextEdit *teServIP;
    MButton *btnChgServIP;
};


#endif // SETTINGPAGE_H
