-- phpMyAdmin SQL Dump
-- version 2.11.4
-- http://www.phpmyadmin.net
--
-- Host: localhost
-- Generation Time: Oct 30, 2015 at 01:21 PM
-- Server version: 5.0.51
-- PHP Version: 5.2.5

SET SQL_MODE="NO_AUTO_VALUE_ON_ZERO";

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;

--
-- Database: `tc`
--
DROP DATABASE  IF EXISTS `tc`;
CREATE DATABASE `tc` DEFAULT CHARACTER SET utf8;
USE `tc`;
-- --------------------------------------------------------

--
-- Table structure for table `imageupdatehistory`
--

CREATE TABLE IF NOT EXISTS `imageupdatehistory` (
  `id` int(11) NOT NULL auto_increment,
  `imageId` int(11) NOT NULL,
  `newPath` varchar(250) NOT NULL DEFAULT '',
  `oldPath` varchar(250) DEFAULT NULL,
  `revision` int(11) NOT NULL DEFAULT '1',
  `previous` int(11) NOT NULL DEFAULT '1',
  `userDataPath` varchar(250) DEFAULT NULL,
  `metaDataPath` varchar(250) DEFAULT NULL,
  `rstUserDataPath` varchar(250) NOT NULL DEFAULT '',
  `rstMetaDataPath` varchar(250) NOT NULL DEFAULT '',
  `timestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `uuid` varchar(36) NOT NULL DEFAULT '',
  `operatorId` bigint(20) unsigned NOT NULL DEFAULT '0',
  `memo` varchar(50) NOT NULL,
  UNIQUE KEY `uuid` (`uuid`),
  UNIQUE KEY `id` (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Table structure for table `machines`
--

CREATE TABLE IF NOT EXISTS `machines` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `machineName` varchar(50) collate utf8_bin NOT NULL default '',
  `mac` varchar(20) NOT NULL default '',
  `client_token` char(12) default NULL,
  `cpu_model` varchar(128) NOT NULL default '',
  `memory_size` int(10) unsigned NOT NULL default '0' COMMENT 'in MiB',
  `disk_size` float unsigned NOT NULL default '0' COMMENT 'in GiB',
  `client_group` int(10) NOT NULL default '0',
  `firmware` varchar(32) NOT NULL default '',
  `download_KBS` int(10) NOT NULL default '0',
  `upload_KBS` int(10) NOT NULL default '0',
  `resolution` varchar(32) NOT NULL default '',
  `usb_storage` enum('0','1') NOT NULL default '1',
  `memo` varchar(50) NOT NULL default '',
  PRIMARY KEY  (`machineName`),
  UNIQUE KEY `mac` (`mac`),
  UNIQUE KEY `id` (`id`),
  UNIQUE KEY `client_token` (`client_token`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;


--
-- Table structure for table `osimages`
--

CREATE TABLE IF NOT EXISTS `osimages` (
  `id` int(11) NOT NULL auto_increment,
  `imageName` varchar(30) collate utf8_bin NOT NULL DEFAULT '',
  `path` varchar(250) collate utf8_bin NOT NULL,
  `groupRead`      varchar(160) NOT NULL default '-1',
  `personalization` varchar(160) NOT NULL default '-1',
  `revision` int(4) NOT NULL default '1',
  `ostype` char(16) NOT NULL default 'unknown',
  `needUpdate` enum('0','1','2') NOT NULL default '0',
  `autoboot` enum('y','n') NOT NULL default 'n',
  `autoboot_revision` int(4) NOT NULL default '1',
  `iconPath` varchar(250) default NULL,
  `memo` varchar(20) default NULL,
  `groupDiffWrite` varchar(160) NOT NULL default '-1',
  `groupRawWrite`  varchar(160) NOT NULL default '-1',
  `groupInstall`   varchar(160) NOT NULL default '-1',
  `imageDesc` varchar(300) default NULL,
  `revision_quota` int(4) NOT NULL default '9',
  `reg_path` varchar(250) collate utf8_bin NOT NULL,
  `reg_timestamp` timestamp NOT NULL default CURRENT_TIMESTAMP,
  `major` int(10) unsigned NOT NULL default '0',
  `minor` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`imageName`),
  UNIQUE KEY `id` (`id`),
  UNIQUE KEY `path` (`path`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;


-- --------------------------------------------------------

--
-- Table structure for table `serverconfigs`
--

CREATE TABLE IF NOT EXISTS `serverconfigs` (
  `id` int(11) NOT NULL auto_increment,
  `serverId` smallint(6) NOT NULL,
  `configName` varchar(50) NOT NULL,
  `configValue` varchar(250) NOT NULL,
  PRIMARY KEY  (`serverId`,`configName`,`id`),
  UNIQUE KEY `id` (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

--
-- Dumping data for table `serverconfigs`
--

INSERT INTO `serverconfigs` (`serverId`, `configName`, `configValue`) VALUES
(4, 'userDataPath', '/home/tc/userdata/'),
(4, 'osImagePath', '/home/tc/diskimage/'),
(4, 'home', '/home/tc'),
(4, 'home_var', '/home/tc/var'),
(4, 'max_login_failure', '5'),
(4, 'user_locking', '5'),
(4, 'ca_dir', '/home/tc/etc/cert/'),
(4, 'lf_retry_interval', '5'),
(4, 'maxVerKept', '10');


-- --------------------------------------------------------
--
-- Table structure for table `usergroups`
--

CREATE TABLE IF NOT EXISTS `usergroups` (
  `id` INT(11) NOT NULL auto_increment,
  `groupName` VARCHAR(40) collate utf8_bin NOT NULL,
  `groupDesc` VARCHAR(100) collate utf8_bin DEFAULT NULL,
  `isSuper` ENUM('0','1') NOT NULL DEFAULT '0',
  `createTime` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `memo` VARCHAR(50) collate utf8_bin DEFAULT '',
  `boot_ciid` INT(4) NOT NULL DEFAULT '0',
  `ps_background_upload` TINYINT(1) NOT NULL DEFAULT '-1',
  PRIMARY KEY  (`groupName`),
  UNIQUE KEY `id` (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

--
-- Dumping data for table `usergroups`
--

INSERT INTO `usergroups` (`id`, `groupName`, `groupDesc`, `isSuper`, `createTime`) VALUES
(2, 'system', 'invisible internal accounts', '1', '0000-00-00 00:00:00'),
(3, 'Administrator', 'root group', '1', '0000-00-00 00:00:00');

-- --------------------------------------------------------
--
-- Table structure for table `users`
--

CREATE TABLE IF NOT EXISTS `users` (
  `id` bigint(20) unsigned NOT NULL auto_increment,
  `printName` varchar(30) NOT NULL DEFAULT '',
  `userName` varchar(30) collate utf8_bin NOT NULL DEFAULT '',
  `groupId` int(11) NOT NULL DEFAULT '0',
  `access_token` char(12) DEFAULT NULL,
  `password` CHAR(64) NOT NULL DEFAULT '',
  `isApproved` enum('0','1') DEFAULT '0',
  `registration_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `approveTime` datetime DEFAULT NULL,
  `approverId` bigint(20) DEFAULT NULL,
  `storage_frozen` enum('true','false') NOT NULL DEFAULT 'false',
  `storage_lock` char(32) NOT NULL DEFAULT '',
  `login_failure` TINYINT(1) NOT NULL DEFAULT '0',
  `reset_password` TINYINT(1) NOT NULL DEFAULT '0',
  `salt` CHAR(32) NOT NULL DEFAULT '',
  `sha256ed` CHAR(64) NOT NULL DEFAULT '',
  PRIMARY KEY  (`userName`),
  UNIQUE KEY `id` (`id`),
  UNIQUE KEY `access_token` (`access_token`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8;

--
-- Dumping data for table `users`
--

INSERT INTO `users` (`id`, `printName`, `userName`, `password`, `groupId`, `isApproved`, `reset_password`, `salt`, `sha256ed`)
  VALUES
  (1, 'administrator', 'admin', 'a396b69a1c76e2fbf25badb336c2faa26d57c251196fabc76763c92b60b965f8', '3', '1', '1', '9fa89546f80c577d82cfbdf89430c0bf', 'a94d241298bc950916abdba01896e74d324bdaba1e29c7a20db6dc850c6d26ff');

-- --------------------------------------------------------

--
-- Table structure for table `userstatus`
--

CREATE TABLE IF NOT EXISTS `userstatus` (
  `id` int(11) NOT NULL auto_increment,
  `userId` int(4) unsigned NOT NULL DEFAULT '0',
  `client_status` enum('power_on','power_off','authenticated','syncing','booting','running',
    'uploading','shutting_down','unknown','initializing_disk','updating_firmware','deploying',
    'interrupted', 'waiting','updating_firmware_cmd_sent','updating_firmware_failed',
    'updating_firmware_done') NOT NULL,
  `mac` varchar(20) NOT NULL DEFAULT '',
  `ip` varchar(40) NOT NULL DEFAULT '',
  `osImageId` int(11) NOT NULL DEFAULT '0',
  `last_login` datetime NOT NULL DEFAULT '1970-01-01 01:01:01',
  `heartbeat` int(11) unsigned NOT NULL DEFAULT '0',
  `cpu_model` varchar(128) NOT NULL DEFAULT '',
  `memory_size` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'in MiB',
  `disk_size` float unsigned NOT NULL DEFAULT '0' COMMENT 'in GiB',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;


CREATE TABLE IF NOT EXISTS `deploy_image` (
  `id` bigint(20) NOT NULL auto_increment,
  `image_id` int(4) NOT NULL DEFAULT 0,
  `image_revision` int(4) NOT NULL default '1',
  `image_path` varchar(255) NOT NULL DEFAULT '',
  `image_size` bigint(11) NOT NULL DEFAULT 0,
  `progress` int(11) NOT NULL DEFAULT 0,
  `speed` float NOT NULL DEFAULT '0',
  `deploy_timestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `deploy_client_count` int(11) NOT NULL DEFAULT 0,
  UNIQUE KEY `id` (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;


CREATE TABLE IF NOT EXISTS `deploy_history` (
  `id` int(11) NOT NULL auto_increment,
  `timestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `event_type` enum('info', 'warning', 'error', 'debug') NOT NULL DEFAULT 'info',
  `event_text` varchar(150) NOT NULL DEFAULT '',
  `mark` enum('normal','beacon') NOT NULL DEFAULT 'normal',
  UNIQUE KEY `id` (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;


CREATE TABLE IF NOT EXISTS `deploy_client` (
  `id` int(11) NOT NULL auto_increment,
  `ip_addr` varchar(15) NOT NULL,
  `mac_addr` varchar(17) NOT NULL,
  `status` enum('waiting','deploying','interrupted','formatting','preparing') NOT NULL DEFAULT 'waiting',
  `error` enum('disk', 'reserved_size', 'initialization') DEFAULT NULL,
  PRIMARY KEY  (`mac_addr`),
  UNIQUE KEY `id` (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;


CREATE TABLE IF NOT EXISTS `peer` (
  `id` int(4) NOT NULL auto_increment,
  `name` varchar(150) NOT NULL DEFAULT '',
  `ip_addr` varchar(15) NOT NULL DEFAULT '',
  PRIMARY KEY  (`name`),
  UNIQUE KEY `id` (`id`),
  UNIQUE KEY `ip_addr` (`ip_addr`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;


CREATE TABLE IF NOT EXISTS `peer_history` (
  `id` int(11) NOT NULL auto_increment,
  `peer_id` int(11) NOT NULL,
  `event` enum('create','update','delete','sync') NOT NULL,
  `message` varchar(250) NOT NULL,
  `user_id` int(11) NOT NULL,
  `timestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  UNIQUE KEY `id` (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;


CREATE TABLE IF NOT EXISTS `seed` (
  `id` int(4) NOT NULL auto_increment,
  `status` enum('raw','hashing','active','error') NOT NULL DEFAULT 'raw',
  `file_type` enum('img','udf') NOT NULL DEFAULT 'img',
  `file_size` bigint(11) NOT NULL DEFAULT 0,
  `file_path` varchar(255) NOT NULL DEFAULT '',
  `seed_path` varchar(255) NOT NULL DEFAULT '',
  `timestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  UNIQUE KEY `id` (`id`),
  UNIQUE KEY `file_path` (`file_path`),
  UNIQUE KEY `seed_path` (`seed_path`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;


CREATE TABLE IF NOT EXISTS `user_revision` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `image_id` int(11) NOT NULL DEFAULT 0,
  `user_id` int(11) NOT NULL DEFAULT 0,
  `user_revision` int(11) NOT NULL DEFAULT 1,
  `description` varchar(255) NOT NULL DEFAULT '',
  `timestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  UNIQUE KEY `id` (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;


CREATE TABLE IF NOT EXISTS `client_group` (
  `cgid` int(11) NOT NULL,
  `cg_name` varchar(40) COLLATE utf8_bin NOT NULL DEFAULT '',
  `cg_desc` varchar(200) COLLATE utf8_bin NOT NULL DEFAULT '',
  `cg_create_ts` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `cg_autoboot_ciid` int(4) NOT NULL DEFAULT '0'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;

ALTER TABLE `client_group` ADD UNIQUE KEY `id` (`cgid`);
ALTER TABLE `client_group` MODIFY `cgid` int(11) NOT NULL AUTO_INCREMENT;
ALTER TABLE `client_group` ADD UNIQUE KEY `cg_name` (`cg_name`);


CREATE TABLE IF NOT EXISTS `operation_history` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `verb` enum('create','read','update','delete','unkown') NOT NULL DEFAULT 'unkown',
  `object` enum('user','user_group','client','client_group','client_image','restore_point','unkown') NOT NULL DEFAULT 'unkown',
  `subject` int(11) NOT NULL DEFAULT 0,
  `text` varchar(100) NOT NULL DEFAULT '',
  `error` varchar(100) NOT NULL DEFAULT '',
  `timestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  UNIQUE KEY `id` (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;


CREATE TABLE IF NOT EXISTS `private_storage` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `user_id` int(11) NOT NULL DEFAULT 0,
  `image_file` varchar(255) NOT NULL DEFAULT '',
  `image_size` bigint(11) NOT NULL DEFAULT 0 COMMENT 'in MiB',
  `revision` int(11) NOT NULL DEFAULT '1',
  `udf_file` varchar(255) NOT NULL DEFAULT '',
  `mdf_file` varchar(255) NOT NULL DEFAULT '',
  `rst_udf_file` varchar(255) NOT NULL DEFAULT '',
  `rst_mdf_file` varchar(255) NOT NULL DEFAULT '',
  `timestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  UNIQUE KEY `id` (`id`)
) ENGINE=MyISAM;


CREATE TABLE IF NOT EXISTS `group_storage` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `group_id` int(11) NOT NULL DEFAULT '0',
  `image_id` int(11) NOT NULL DEFAULT '0',
  `image_size` bigint(11) NOT NULL DEFAULT 0 COMMENT 'in MiB',
  `timestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  UNIQUE KEY `id` (`id`)
) ENGINE=MyISAM;


CREATE TABLE IF NOT EXISTS `role` (
  `id` int(4) NOT NULL auto_increment,
  `role_id` char(4) NOT NULL DEFAULT '',
  `name` varchar(255) NOT NULL DEFAULT '',
  `description` varchar(255) NOT NULL DEFAULT '',
  `create_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  UNIQUE KEY `id` (`id`)
) ENGINE=InnoDB;

ALTER TABLE `role`
 ADD UNIQUE KEY `role_id` (`role_id`);

CREATE TABLE IF NOT EXISTS `role_permission` (
  `id` int(4) NOT NULL auto_increment,
  `role_id` char(4) NOT NULL DEFAULT '',
  `allowed_url` varchar(255) NOT NULL DEFAULT '',
  `create_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  UNIQUE KEY `id` (`id`)
) ENGINE=InnoDB;

CREATE TABLE IF NOT EXISTS `role_group_binds` (
  `id` int(4) NOT NULL auto_increment,
  `role_id` char(4) NOT NULL DEFAULT '',
  `group_id` int(4) NOT NULL DEFAULT '1',
  `create_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  UNIQUE KEY `id` (`id`)
) ENGINE=InnoDB;

CREATE TABLE IF NOT EXISTS `user_auth_history` (
  `id` INT(10) NOT NULL AUTO_INCREMENT,
  `user_id` INT(4) NOT NULL DEFAULT '0',
  `user_name` VARCHAR(30) NOT NULL DEFAULT '',
  `client_ip` VARCHAR(40) NOT NULL DEFAULT '',
  `client_name` VARCHAR(50) NOT NULL DEFAULT '',
  `event` ENUM('login', 'logout') NOT NULL DEFAULT 'login',
  `result` TINYINT(1) NOT NULL DEFAULT '0',
  `create_time` TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `logger_id` INT(4) NOT NULL DEFAULT '0',
  `visible` TINYINT(1) NOT NULL DEFAULT '1',
  UNIQUE KEY `id` (`id`)
) ENGINE=InnoDB;



/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;

