<?php

/******************************************************************************
Copyright 2012 - 2020 Intel Corporation

For licensing information, see the file 'LICENSE' in the root folder of
                           this software module.
******************************************************************************/

    error_reporting(E_ALL);
    require('../libs/libtc.php');
    require("libpage.php");
    require("include/inc.bootstrap.php");

    standard_page_begin('client_full_table');
?>

<div class="container-fluid">
<!-- row for toolbar -->
    <div class="row">
<?php
    $bar = array(
        "button_groups" => array(
            array(
                "buttons" => array(
                    array("i18n" => "s_client_add", "icon" => "glyphicon-plus"),
                    array("i18n" => "s_client_remove", "icon" => "glyphicon-minus"),
                ),
            ),
            array(
                "buttons" => array(
                    array("i18n" => "s_client_edit_name", "icon" => "glyphicon-edit"),
                    array("i18n" => "s_client_edit_group", "icon" => "glyphicon-edit"),
                    array("i18n" => "s_client_edit_mac", "icon" => "glyphicon-edit"),
                ),
            ),
            array(
                "buttons" => array(
                    array("i18n" => "s_client_edit_limit", "icon" => "glyphicon-edit"),
                    array("i18n" => "s_client_edit_usb_storage", "icon" => "glyphicon-edit"),
                    array("i18n" => "s_client_edit_resolution", "icon" => "glyphicon-edit"),
                    array("i18n" => "s_client_edit_desc", "icon" => "glyphicon-edit"),
                    array("i18n" => "s_client_export", "icon" => "glyphicon-edit"),
                ),
            ),
        ),
        "search_control" => array(
            "class" => "pull-right",
            "id" => "search_control",
        ),
        "id" => "crud_control",
    );
    echo html_toolbar($bar);
?>
    </div>

    <div class="row">
        <table class="table tc-table col-xs-12" id="table_client_list">
            <thead>
                <tr>
                    <th> <input type="checkbox"> </th>
                    <th> <span i18n="s_name"> Name </span> </th>
                    <th> <span i18n="s_client_group"> Group </span> </th>
                    <th> <span i18n="s_mac_address"> MAC Address </span> </th>
                    <th> CPU </th>
                    <th> <span i18n="s_memory_size"> Memory Size </span> </th>
                    <th> <span i18n="s_disk_size"> Disk Size </span> </th>
                    <th> <span i18n="s_speed_limit_download_title"></span> </th>
                    <th> <span i18n="s_speed_limit_upload_title"></span> </th>
                    <th> <span i18n="s_usb_storage"></span> </th>
                    <th> <span i18n="s_display_resolution"></span> </th>
                    <th> <span i18n="s_description"> Description </span> </th>
                </tr>
            </thead>
            <tbody>
            </tbody>
        </table>
    </div>

<div style="display: none">
    <div id="dialog_edit_speed_limit">
        <div class="form-group">
            <label><span i18n="s_speed_limit_download">
                Download Speed Limit (MB/s, 0 means no limit)
            </span></label>
            <input type="text" class="form-control" value="0">
        </div>
        <div class="form-group">
            <label><span i18n="s_speed_limit_upload">
                Upload Speed Limit (MB/s, 0 means no limit)
            </span></label>
            <input type="text" class="form-control" value="0">
        </div>
    </div>
</div>

</div>
<?php control_pagination(); ?>

<?php standard_page_mid(); ?>

<script language="javascript">

"use strict";
function page_load() {
    util_page.disable_cache();
    util_page.enable_locale();
    util_page.render_sidebar();

    util_table.create($('.tc-table'));
    util_table.enable_search($('#search_control input'), $('#search_control button'));
    util_table.enable_pagination($('#page-control'));
    util_table.enable_sort();
    util_table.bind_sort(4, util_table.size_comparator);
    util_table.bind_sort(5, util_table.size_comparator);
    // button list: create, delete, batch enabling, batch disabling, change group, change password
    util_table.bind_checked(function($trs) {
        if ($trs.length == 0) {
            $('#crud_control button:nth(1)').prop('disabled', true);
            $('#crud_control button:nth(2)').prop('disabled', true);
            $('#crud_control button:nth(3)').prop('disabled', true);
            $('#crud_control button:nth(4)').prop('disabled', true);
            $('#crud_control button:nth(5)').prop('disabled', true);
            $('#crud_control button:nth(6)').prop('disabled', true);
            $('#crud_control button:nth(7)').prop('disabled', true);
            $('#crud_control button:nth(8)').prop('disabled', true);
        } else if ($trs.length == 1) {
            $('#crud_control button:nth(1)').prop('disabled', false);
            $('#crud_control button:nth(2)').prop('disabled', false);
            $('#crud_control button:nth(3)').prop('disabled', false);
            $('#crud_control button:nth(4)').prop('disabled', false);
            $('#crud_control button:nth(5)').prop('disabled', false);
            $('#crud_control button:nth(6)').prop('disabled', false);
            $('#crud_control button:nth(7)').prop('disabled', false);
            $('#crud_control button:nth(8)').prop('disabled', false);
        } else if ($trs.length > 1) {
            $('#crud_control button:nth(1)').prop('disabled', false);
            $('#crud_control button:nth(2)').prop('disabled', true);
            $('#crud_control button:nth(3)').prop('disabled', false);
            $('#crud_control button:nth(4)').prop('disabled', true);
            $('#crud_control button:nth(5)').prop('disabled', false);
            $('#crud_control button:nth(6)').prop('disabled', false);
            $('#crud_control button:nth(7)').prop('disabled', false);
            $('#crud_control button:nth(8)').prop('disabled', false);
        }
    });

    load_table();

    // bind button handlers
    // create
    $('#crud_control button:nth(0)').click(function(){
        util_page.navi_page('client_create_page.php');
    });

    // delete
    init_buttons_status();
    $('#crud_control button:nth(1)').click(delete_rows);
    $('#crud_control button:nth(2)').click(change_name);
    $('#crud_control button:nth(3)').click(change_group);
    $('#crud_control button:nth(4)').click(change_mac);
    $('#crud_control button:nth(5)').click(change_limit);
    $('#crud_control button:nth(6)').click(change_usb);
    $('#crud_control button:nth(7)').click(change_resolution);
    $('#crud_control button:nth(8)').click(change_desc);
    $('#crud_control button:nth(9)').click(export_csv);
}

var init_buttons_status = function() {
    $('#crud_control button:nth(1)').prop('disabled', true);
    $('#crud_control button:nth(2)').prop('disabled', true);
    $('#crud_control button:nth(3)').prop('disabled', true);
    $('#crud_control button:nth(4)').prop('disabled', true);
    $('#crud_control button:nth(5)').prop('disabled', true);
    $('#crud_control button:nth(6)').prop('disabled', true);
    $('#crud_control button:nth(7)').prop('disabled', true);
    $('#crud_control button:nth(8)').prop('disabled', true);
};

var change_limit = function() {
    var $dialog = util_page.dialog_confirm_builder(
        $('#dialog_edit_speed_limit').html(),
        find_i18n('s_save'),
        function() {
            change_rows({
                'download_MBS': $dialog.find('input:nth(0)').val(),
                'upload_MBS': $dialog.find('input:nth(1)').val()
            });
        });
    var bags = util_table.checked();
    // load selected client speed limit value
    // use 0 for multiple selections
    if (bags.length == 1) {
        util_page.rest_get('/tc/rest/machine.php/' + bags[0].key, function(c) {
            $dialog.find('input:nth(0)').val(c.download_MBS);
            $dialog.find('input:nth(1)').val(c.upload_MBS);
        });
    }
};

var change_group = function() {
    var title = find_i18n('s_input_new_client_group');
    util_page.rest_get('/tc/rest/client_group.php', function(cgs) {
        var selections = util_page.dialog_select_selections();
        $.map(cgs, function(cg) {
            var text = cg.name + ', ' + cg.create_timestamp;
            if (cg.desc) {
                text += ', ' + cg.desc;
            }
            selections.push({text: text, value: cg.cgid});
        });
        util_page.dialog_select(title, selections, function(value) {
            change_rows({client_group: value});
        });
    });
};

var change_usb = function() {
    var title = find_i18n('s_input_new_client_usb_storage');
    var selections = util_page.dialog_select_selections('EYN');
    util_page.dialog_select(title, selections, function(sel) {
        change_rows({usb_storage: sel});
    });
};

var change_resolution = function() {
    var title = find_i18n('s_input_new_client_resolution');
    var $dialog = util_page.dialog_prompt(title, function(value) {
        change_rows({resolution: value});
    });
    $dialog.find('input').attr('maxlength', '32');
};

var change_desc = function() {
    var title = find_i18n('s_input_new_client_desc');
    var $dialog = util_page.dialog_prompt(title, function(value) {
        change_rows({memo: value});
    });
    $dialog.find('input').attr('maxlength', '40');
};

var export_csv = function() {

    var $trs = $("#table_client_list").find("tr");
    var str = "";
    for (var i = 0; i < $trs.length; i++) {
        var $tds = $trs.eq(i).find("td,th");
        for (var j = 1; j < $tds.length; j++) {
            str += $tds.eq(j).text() + ",";
        }
        str += "\n";
    }
    var uri = "data:text/csv;charset=utf-8,\ufeff" + encodeURIComponent(str);
    var ie_chinese = "\ufeff" + str;         
    var blob = new Blob([ie_chinese],{type: "text/csv;charset=utf-8;"});
    var date=new Date();
    var data_format = date.getFullYear()+""+(date.getMonth()+1)+""+date.getDate();
    var csv_name = "client_list-"+data_format + ".csv";
    if (navigator.msSaveBlob) { // IE 10+
        navigator.msSaveBlob(blob, csv_name);
    } else {
        var link = document.createElement("a");
        if (link.download !== undefined) {
            link.href = uri;
            link.setAttribute("download", csv_name);
            document.body.appendChild(link);
            link.click();
            document.body.removeChild(link);
        }           
    }
};

var change_name = function() {
    var title = find_i18n('s_input_new_client_name');
    var $dialog = util_page.dialog_prompt_required(title, function(name) {
        change_rows({name: name});
    });
    $dialog.find('input').attr('maxlength', '30');
};

var change_mac = function() {
    var title = find_i18n('s_input_new_client_mac');
    var $dialog = util_page.dialog_prompt_required(title, function(value) {
        if (util_page.is_mac(value)) {
            value = value.toUpperCase();
            change_rows({mac: value});
        } else {
            util_page.dialog_message_i18n('e_bad_client_mac');
        }
    });
    $dialog.find('input').attr('maxlength', '17').css('text-transform', 'uppercase');
};

var change_rows = function(row_data) {
    var bags = util_table.checked(),
        total_count = bags.length,
        done_count = 0,
        error_count = 0,
        error_lines = '';

    $.map(bags, function(bag){
        var url = '/tc/rest/machine.php/' + bag.key;
        util_page.rest_put(url, row_data, function(res) {
            done_count += 1;
            if (total_count === done_count + error_count) {
                if (error_count === 0) {
                    util_page.dialog_message_i18n('s_update_done_ok');
                } else {
                    util_page.dialog_message(error_lines);
                }
                load_table();
            }
        }, function(error) {
            error_count += 1;
            error_lines += '<br>['+ bag.row[0] + '] ' + find_i18n(error.error);
            if (total_count === done_count + error_count) {
                if (error_count === 0) {
                    util_page.dialog_message_i18n('s_update_done_ok');
                } else {
                    util_page.dialog_message(error_lines);
                }
                load_table();                
            }
        });
    });
};

var delete_rows = function() {
    var bags = util_table.checked(),
        message = find_i18n('c_delete_selected_client'),
        total_count = bags.length,
        done_count = 0,
        error_count = 0,
        error_lines = '';

    util_page.dialog_confirm(message, function(){
        var urls = $.map(bags, function(bag){
            var url = '/tc/rest/machine.php/' + bag.key;
            util_page.rest_delete(url, {}, function() {
                done_count += 1;
                if (total_count === done_count + error_count) {
                    if (error_count === 0) {
                        util_page.dialog_message_i18n('s_update_done_ok');
                    } else {
                        util_page.dialog_message(error_lines);
                    }
                    load_table();
                }
            }, function(error) {
                error_count += 1;
                error_lines += '<p>['+ bag.row[0] + '] ' + find_i18n(error.error) + '</p>';
                if (total_count === done_count + error_count) {
                    if (error_count === 0) {
                        util_page.dialog_message_i18n('s_update_done_ok');
                    } else {
                        util_page.dialog_message(error_lines);
                    }
                    load_table();
                }
            });
        });
    });
};

function load_table() {
    util_page.rest_get('/tc/rest/machine.php', function(res) {
        util_table.load(parse_record(res));
    });
    init_buttons_status();
}

function parse_record(result) {
    var records = [];
    $.map(result, function(r) {
        var memory = r.memory_size == 0 ? '' : r.memory_size,
            disk = r.disk_size == 0 ? '' : r.disk_size,
            limit_d = r.download_MBS == 0 ? '' : r.download_MBS + ' MB/s',
            limit_u = r.upload_MBS == 0 ? '' : r.upload_MBS + ' MB/s',
            usb_storage = find_i18n(
                r.usb_storage ? 's_usb_storage_enabled' : 's_usb_storage_disabled');

        if (memory) {
            memory = util_page.print_size(memory, 'MiB');
        }

        if (disk) {
            disk = util_page.print_size(disk, 'GiB');
        }

        records.push({
            key: r.id,
            row: [
                r.name,
                r.client_group_name,
                r.mac,
                r.cpu_model,
                memory,
                disk,
                limit_d,
                limit_u,
                usb_storage,
                r.resolution,
                r.memo
            ],
            checkable: true
        });
    });
    return records;
}

$(document).ready(page_load);
</script>

<?php standard_page_end(); ?>