<?php

/******************************************************************************
Copyright 2012 - 2020 Intel Corporation

For licensing information, see the file 'LICENSE' in the root folder of
                           this software module.
******************************************************************************/

    error_reporting(E_ALL);

    require('../libs/libtc.php');
    require("libpage.php");

    $link = 'dashboard';

    browser_compatibility_check();
    page_permission_check($link);
    page_begin();
    page_head($link);
    body_begin();
    container_begin();

    sidebar_item_home();
    sidebar_left($link);
    content_right_begin($link);
?>

<div class="container-fluid">

<div class="row no-gutters">
    <!-- ======== TOP ROW ======== -->
    <!-- top left panel -->
    <div class="container-fluid col-xs-3 col-sm-3 col-md-3 col-lg-3" id="server-side" style="max-width: 280px;">
        <h4>
            <span i18n="s_server_status">Server Side</span>
        </h4>
        <table class="info-table dashboard-table">
            <tbody>
                <tr>
                    <td><span i18n="s_server_services">System Status</span></td>
                    <td>
                        <div class="onoff-switch">
                            <input type="checkbox" name="switch-system" class="onoff-switch-checkbox" id="switch-system">
                            <label class="onoff-switch-label" for="switch-system">
                                <span class="onoff-switch-inner"></span>
                                <span class="onoff-switch-switch"></span>
                            </label>
                        </div>
                    </td>
                </tr>
                <tr>
                    <td><span i18n="s_server_builtin_dhcp">DHCP Server</span></td>
                    <td>
                        <div class="onoff-switch">
                            <input type="checkbox" name="switch-dhcp-server" class="onoff-switch-checkbox" id="switch-dhcp-server">
                            <label class="onoff-switch-label" for="switch-dhcp-server">
                                <span class="onoff-switch-inner"></span>
                                <span class="onoff-switch-switch"></span>
                            </label>
                        </div>
                    </td>
                </tr>
                <tr>
                    <td><span i18n="s_network_address">Server Address</span></td>
                    <td><a href="javascript:change_server_ip()"><span id="server-ip"></span></a></td>
                </tr>
                <tr>
                    <td><span i18n="s_network_gateway">Server Gateway</span></td>
                    <td><a href="#"><span id="server_gateway"></span></a></td>
                </tr>
                <tr>
                    <td><span i18n="s_network_dns">Server DNS</span></td>
                    <td><a href="#"><span id="server_dns"></span></a></td>
                </tr>

                <tr class="dashboard_title_margin">
                </tr>
                <tr>
                    <td style="text-align: left">
                        <h4>
                            <span i18n="s_client_status">Client Side</span>
                        </h4>
                    </td>
                </tr>
                <tr>
                    <td><span i18n="s_dashboard_client_registration"></span></td>
                    <td>
                        <div class="onoff-switch">
                            <input type="checkbox" name="client_open_registration" class="onoff-switch-checkbox"
                                id="client_open_registration">
                            <label class="onoff-switch-label" for="client_open_registration">
                                <span class="onoff-switch-inner"></span>
                                <span class="onoff-switch-switch"></span>
                            </label>
                        </div>
                    </td>
                </tr>
                <tr>
                    <td><span i18n="s_dashboard_client_naming"></span></td>
                    <td>
                        <div class="onoff-switch">
                            <input type="checkbox" name="client_naming"  id="client_naming" class="onoff-switch-checkbox">
                            <label class="onoff-switch-label" for="client_naming">
                                <span class="onoff-switch-inner"></span>
                                <span class="onoff-switch-switch"></span>
                            </label>
                        </div>
                    </td>
                </tr>
                <tr>
                    <td><span i18n="s_dashboard_client_naming_rule"></span></td>
                    <td><a href="#" id="naming_rule"></a></td>
                </tr>
            </tbody>
        </table>
    </div>
    <!-- top left panel end-->

    <div class="container-fluid col-xs-3 col-sm-3 col-md-3 col-lg-3" id="client-side" style="max-width: 280px;">

        <h4>
            <span i18n="s_server_wan">WAN Services</span>
        </h4>
        <table class="info-table dashboard-table">
            <tbody>

                <tr>
                    <td><span i18n="s_server_wan_tracker"></span></td>
                    <td>
                        <div class="onoff-switch">
                            <input type="checkbox" name="tracker_wan" class="onoff-switch-checkbox" id="tracker_wan">
                            <label class="onoff-switch-label" for="tracker_wan">
                                <span class="onoff-switch-inner"></span>
                                <span class="onoff-switch-switch"></span>
                            </label>
                        </div>
                    </td>
                </tr>
                <tr>
                    <td><span i18n="s_server_wan_tracker_ip"></span></td>
                    <td><a href="###"><span id="tracker_wan_ip"></span></a></td>
                </tr>


                  <tr class="dashboard_title_margin">
                </tr>  
                <tr>
                    <td style="text-align: left">
                        <h4>
                            <span i18n="s_permission_global">Global Permissions</span>
                        </h4>
                    </td>
                </tr>
                <tr>
                    <td><span i18n="s_ps_background_upload_switch"></span></td>
                    <td>
                        <div class="onoff-switch">
                            <input type="checkbox" name="ps_background_upload"  id="ps_background_upload" class="onoff-switch-checkbox">
                            <label class="onoff-switch-label" for="ps_background_upload">
                                <span class="onoff-switch-inner"></span>
                                <span class="onoff-switch-switch"></span>
                            </label>
                        </div>
                    </td>
                </tr>
                <tr>
                    <td><span i18n="s_autoboot_image">Auto Login Image</span></td>
                    <td><a href="javascript:change_autoboot()"><span id="autoboot-image"></span></a></td>
                </tr>
                <tr>
                    <td><span i18n="s_auto_login_delay">Auto Login Delay</span></td>
                    <td><a href="#" id="auto_login_delay"><span></span>&nbsp;<span i18n="s_second"></span></a></td>
                </tr>
                    <tr class="dashboard_title_margin">
                </tr>
                <tr>
                    <td style="text-align: left">
                        <h4>
                        <span i18n="s_server_ad_domain">AD Domain</span>
                        </h4>
                    </td>
                </tr>
                <tr>  
                    <td><span i18n="s_server_ad_domain_server">AD Domain Server</span></td>
                    <td>
                        <div class="onoff-switch">
                            <input type="checkbox" name="ad_domain_enable" class="onoff-switch-checkbox" id="ad_domain_enable">
                            <label class="onoff-switch-label" for="ad_domain_enable">
                                <span class="onoff-switch-inner"></span>
                                <span class="onoff-switch-switch"></span>
                            </label>
                        </div>
                    </td>
                </tr>
                <tr>
                    <td><span i18n="s_server_ad_domain_server_ip">AD DS Address</span></td>
                    <td><a href="###"><span id="ad_domain_server_ip"></span></a></td>
                </tr>
                <tr>
                    <td><span i18n="s_server_ad_domain_server_name">AD DS Name</span></td>
                    <td><a href="###"><span id="ad_domain_server_name"></span></a></td>
                </tr>
            </tbody>
        </table>
    </div>
    <!-- top middle panel -->
    <div class="col-xs-3 col-sm-3 col-md-3 col-lg-3" id="stat-data" style="max-width: 270px;">
        <h4 style="text-align: center;">
            <span i18n="s_network_nic_usage_percent">TC System NIC Usage Percent</span>
        </h4>
        <div id="gauge" class="dashboard_gage">
             <canvas id="network-chart" width="100%" height="100%"></canvas>
        </div>
        <table class="legend-table" style="width: 90%;">
            <tbody>
                <tr>
                    <td><span i18n="s_network_nic">NIC Information</span></td>
                    <td><span id="server_nic"></span></td>
                </tr>
                <tr>
                    <td><span i18n="s_network_nic_kmodule">Kernal Module</span></td>
                    <td><span id="server_nic_kmodule"></span></td>
                </tr>
                <tr>
                    <td><span i18n="s_network_nic_driver">Driver Name</span></td>
                    <td><span id="server_nic_driver"></span></td>
                </tr>
            </tbody>
        </table>
    </div>
    <!-- top middle panel end -->

    <!-- top right panel -->
    <div class="col-xs-3 col-sm-3 col-md-3 col-lg-3" id="fs-data" style="max-width: 270px;">
        <h4 style="text-align: center;">
            <span i18n="s_fs_usage_percent">TC File System Usage Percent</span>
        </h4>
        <div id="gauge_fs" class="dashboard_gage">
            <canvas id="fileSystem-chart" width="100%" height="100%"></canvas>
        </div>
        <table class="legend-table">
            <tbody>
                <tr>
                    <td><span i18n="s_fs_total_size"></span></td>
                    <td><span>--</span> GiB</td>
                </tr>
                <tr>
                    <td><span i18n="s_fs_used_size"></span></td>
                    <td><span>--</span> GiB</td>
                </tr>
                <tr>
                    <td><span i18n="s_fs_free_size"></span></td>
                    <td><span>--</span> GiB</td>
                </tr>
            </tbody>
        </table>
    </div>
    <!-- top right panel end -->
</div>
<!-- ======== TOP ROW END  ======== -->

<hr>


<div class="row">

<!-- bottom left -->
    <div class="col-xs-12 col-sm-12 col-md-12 col-lg-12" id="client-list" style="max-width: 1050px;">
        <h4>
            <span i18n="s_client_active">Online Client</span>
            <a href="online_clients.php">
                <small><span i18n="s_full_list"></span></small>
            </a>
            <strong class="pull-right">
                <label>--</label> / <label>--</label>
                <small><span i18n='s_client_counter_legend'></span></small>
            </strong>
        </h4>
        <table class="table table-striped">
            <thead>
                <tr>
                    <th><span i18n='s_client'>Client</span></th>
                    <th><span i18n='s_client_status'>Status</span></th>
                    <th><span i18n='s_username'>User</span></th>
                    <th><span i18n='s_image_name'>Image</span></th>
                    <th><span i18n='s_ip_address'>IP Address</span></th>
                    <th><span i18n='s_heartbeat'>Heartbeat</span></th>
                </tr>
            </thead>
            <tbody>
            </tbody>
        </table>
    </div>
<!-- bottom left end -->
<!-- bottom right panel -->
    <div class="col-xs-4 col-sm-4 col-md-4 col-lg-4">
    </div>
<!-- bottom right panel end -->

</div> <!-- row ends -->
</div> <!-- TOP level container -->

<div style="display: none;">
    <div id="dialog_server_address">
        <div class="form-group">
            <label><span i18n="s_ip_address">IP Address</span></label>
            <input type="text" class="form-control">
        </div>
        <div class="form-group">
            <label><span i18n="s_subnet_mask">Subnet Mask</span></label>
            <input type="text" class="form-control">
        </div>
    </div>
    <div id="dialog_client_naming_rule">
        <h4><span i18n="s_dashboard_client_naming_rule"></span></h4>
        <hr>
        <div class="form-group">
            <label i18n="s_batch_prefix"></label>
            <input type="text" class="form-control">
        </div>
        <div class="form-group">
            <label i18n="s_batch_suffix"></label>
            <input type="text" class="form-control">
        </div>
        <div class="form-group">
            <label i18n="s_batch_width"></label>
            <input type="text" class="form-control">
        </div>
        <div class="form-group">
            <label i18n="s_batch_first"></label>
            <input type="text" class="form-control">
        </div>
    </div>
</div>

<?php 
    content_right_end();
//    rows_end();
    container_end();

    page_script_files();
?>

<script language="javascript">

"use strict";

var global_refresh = true,
    heartbeat_timeout = 120;
var $text_autoboot = $('#autoboot-image');

function change_server_ip() {
    var do_change_ip = function() {
        var settings = {
            addr: $(this).find('input:nth(0)').val(),
            mask: $(this).find('input:nth(1)').val()
        };
        util_page.rest_put(
            '/tc/rest/network.php',
            settings,
            function() {
                $('#server-ip')
                    .data('sip', settings.addr)
                    .data('smask', settings.mask)
                    .text(settings.addr);
            }
        );
    };

    var html = $('#dialog_server_address').html(),
        btn_text = find_i18n('s_save'),
        old_ip = $('#server-ip').data('sip'),
        old_mask = $('#server-ip').data('smask');

    util_page.dialog_confirm_builder(html, btn_text, do_change_ip)
        .find('input:nth(0)').val(old_ip).end()
        .find('input:nth(1)').val(old_mask);
}

function load_client_list(clients) {    
    for (var i in clients) {
        var status = clients[i].client_status;
        var $tr = $('<tr></tr>')
            .append('<td>' + clients[i].client_name + '</td>')
            .append('<td>' + find_i18n('cs_' + status) + '</td>')
            .append('<td>' + clients[i].user + '</td>')
            .append('<td>' + clients[i].image + '</td>')
            .append('<td>' + clients[i].ip + '</td>')
            .append('<td>' + clients[i].heartbeat + '</td>');

        if (clients[i].heartbeat_delay > heartbeat_timeout) {
            $tr.addClass('warning');
        }

        $('#client-list tbody').append($tr);
    }
}

function stat_client_list(clients) {
    var counters = {
        _total: 0,
        power_off: 0,
        power_on: 0,
        authenticated: 0,
        syncing: 0,
        booting: 0,
        running: 0,
        uploading: 0,
        shutting_down: 0,
        unknown: 0,
        initializing_disk: 0,
        updating_firmware: 0
    };

    counters._total = clients.length;
    for (var i in clients) {
        if (clients[i].client_status in counters)
            counters[clients[i].client_status] += 1;
        else
            counters[clients[i].client_status] = 1;
    }

    return counters;
}

function load_client_counters(clients) {
    var c = stat_client_list(clients);

    $('#total-client-count').text(c._total);

    $('#running-count').text(c.running + c.shutting_down);
    $('#tcboot-count').text(c.power_on + c.authenticated);
    $('#osboot-count').text(c.booting);
    $('#syncing-count').text(c.syncing + c.uploading);
    $('#maintaining-count').text(c.initializing_disk + c.updating_firmware);
    $('#error-count').text(c.unknown);

    $('#client_count_online').text(clients.length);
    $('#client_count_running').text(c.running + c.shutting_down);
    $('#client_count_booting').text(
        c.power_on + c.authenticated + c.booting + c.syncing
        + c.uploading + c.initializing_disk + c.updating_firmware
        + c.unknown
    );

    // update online counts
    $('#client-list label:nth(0)').text(clients.length);
    // update total counts
    $('#client-list label:nth(1)').text(c._total); 
}


function update_system_services_status(servers) {
    // check TC server status
    // disk server: tc-sync-server, or disk server
    // ccontrol server: tc-client-control-server
    // pxe server: dhcpd with pxe settings
    var is_on = servers.disk.status == 'on' && servers.deploy.status == 'on';
    // IE8 on off switch
    $('#switch-system-on').attr('checked', is_on);
    $('#switch-system-off').attr('checked', !is_on);
    // standard on off switch
    $('#switch-system').prop('checked', is_on);

    // update toolbar status according to server on/off
    $('#toolbar_cci button').attr('disabled', !is_on);

    // update DHCP server status
    var active_dhcp = servers.dhcp.status == 'on';
    // IE8 on off switch
    $('#ie8-switch-dhcp-server-on').attr('checked', active_dhcp);
    $('#ie8-switch-dhcp-server-off').attr('checked', !active_dhcp);
    // standard on off switch
    $('#switch-dhcp-server').prop('checked', active_dhcp);

    $("input[name='tracker_wan']").prop('checked', servers.tracker_wan.status === 'on');
}


function update_server_network() {
    util_page.rest_get('/tc/rest/network.php', function(data) {
        $('#server-ip')
            .text(data.ip)
            .data('sip', data.ip)
            .data('smask', data.mask);
        var speed_text = data.speed_mbps  + ' mbps';
        if (data.speed_mbps === -1) {
            speed_text = find_i18n('s_network_nic_speed_unknown');
        }
        $('#server_nic').text(data.nic + ' (' + speed_text + ')');
        $('#server_nic_kmodule').text(data.kmod);
        $('#server_nic_driver').text(data.driver);

        page_update_network_gateway(data.gateway);
        page_update_network_dns(data.dns);
    });
}

var page_update_switch = function(settings, entry) {
    $("input[name='" + entry + "']").prop('checked', settings[entry]);
}

var page_bind_switch = function(entry) {
    $("input[name='" + entry + "']").change(function() {
        var settings = {};
        settings[entry] = $(this).prop('checked');
        util_page.rest_put('/tc/rest/system.php', settings, update_status, function(err) {
            util_page.dialog_message_error(err);
            update_status();
        });
    });
}

var page_update_auto_login_delay = function(val) {
    $('#auto_login_delay span:nth(0)').text(val);
};

var page_read_auto_login_delay = function() {
    return $('#auto_login_delay span:nth(0)').text();
};

var page_update_network_gateway = function(val) {
    if (val) {
        $('#server_gateway').text(val);
    } else {
        $('#server_gateway').text(find_i18n('s_none'));
    }
};

var page_read_network_gateway = function() {
    var text = $('#server_gateway').text();
    if (text === find_i18n('s_none')) {
        return '';
    }
    return text;
};

var page_update_network_dns = function(val) {
    if (val) {
        $('#server_dns').text(val);
    } else {
        $('#server_dns').text(find_i18n('s_none'));
    }
};

var page_read_network_dns = function() {
    var text = $('#server_dns').text();
    if (text === find_i18n('s_none')) {
        return '';
    }
    return text;
};

var page_update_input_text = function(key, val) {
    var value = val;
    if (!value) {
        value = find_i18n('s_none');
    }
    $('#' + key).text(value).data('val', val);
}

var page_update_client_naming_rule = function(settings) {
    if (settings === undefined) {
        util_page.rest_get('/tc/rest/system.php/settings', page_update_client_naming_rule);
        return;
    }
    var rule = find_i18n('s_none');
    if (settings.client_naming) {
        var begin = settings.client_naming_first;
        var width = settings.client_naming_width;
        begin = ('0'.repeat( Math.max(width - begin.toString().length, 0)) + begin).slice(-width);
        var end = '9'.repeat(width);
        rule = settings.client_naming_prefix;
        rule += '[' + begin + '-' + end + ']';
        rule += settings.client_naming_suffix;
    }
    $('#naming_rule').text(rule)
        .data('prefix', settings.client_naming_prefix)
        .data('suffix', settings.client_naming_suffix)
        .data('width', settings.client_naming_width)
        .data('first', settings.client_naming_first);
}

function update_status() {
    util_page.rest_get('/tc/rest/system.php/servers', function(status){
        update_system_services_status(status);
    });

    util_page.rest_get('/tc/rest/system.php/settings', function(settings){
        global_refresh = settings.page_refresh;
        heartbeat_timeout = settings.heartbeat_timeout;

        page_update_auto_login_delay(settings.auto_login_delay);
        page_update_switch(settings, 'client_open_registration');
        page_update_switch(settings, 'client_naming');
        page_update_client_naming_rule(settings);
        page_update_switch(settings, 'ad_domain_enable');
        page_update_switch(settings, 'ps_background_upload');

        page_update_input_text('ad_domain_server_name', settings.ad_domain_server_name);
        page_update_input_text('ad_domain_server_ip', settings.ad_domain_server_ip);

        page_update_input_text('tracker_wan_ip', settings.tracker_wan_ip);
    });

    update_server_network();

    util_page.rest_get('/tc/rest/system.php', function(result){
        $('#ie8-switch-client-registration-on').attr('checked', result.client_open_registration);
        $('#ie8-switch-client-registration-off').attr('checked', !result.client_open_registration);

        $('#total_client_reg').text(result.client_registered);
    });

    util_page.rest_get('/tc/rest/bootimage2.php', function(result){
        update_autoboot_images(result.images);
    });

}

function update_autoboot_images(images) {
    // clear previous autoboot image history
    $text_autoboot.text(find_i18n('s_none', 'none')).attr('title', '');
    // search the image list for the autoboot image
    $.map(images, function(img) {
        if (img.autoboot == 'y') {
            $.map(img.history, function(rev) {
                if (img.autoboot_revision !== rev.revision) {
                    return;
                }
                var text = img.name,
                    title = rev.timestamp;
                //Dashboard show autoboot image revision
                //if (rev.revision) {
                    //var image_revision = find_i18n('s_version') + rev.revision;
                    //text += ', ' + image_revision; 
                    //title += ', ' + image_revision;
                //}
                $text_autoboot.text(text).attr('title', title);
            });
        }
    });
}

function select_autoboot_image(images) {
    // search for autoboot selected image, set the value to '' as the default selection of combo
    var selections = $.map(images, function(img){
        if (img.autoboot == 'y') {
            var selection = {value: ''};
            $.map(img.history, function(history){
                if (history.revision == img.autoboot_revision) {
                    var image_revision = find_i18n('s_version') + history.revision;
                    //Dashboard show autoboot image "name+revision"
                    //selection.text = [img.name, image_revision, history.timestamp].join(', ');
                    selection.text = [img.name, history.timestamp].join(', ');//Dashboard only show autoboot image name
                    selection.revision = history.revision;
                }
            });
            return selection;
        }
    });

    var none_selection_value = -1;
    if($.isEmptyObject(selections)) {
        none_selection_value = '';
    }
    // append other boot images for selection
    $.map(images, function(img){
        // auto boot image has been added already
        if (img.autoboot == 'y') {
            return;    
        }
        var selection = {
            revision: img.revision,
            value: img.id
        };
        $.map(img.history, function(history){
            if (parseInt(history.revision) >= parseInt(selection.revision)) {
                var image_revision = find_i18n('s_version') + history.revision;
                //Dashboard only show autoboot image "name+revision"
                //selection.text = [img.name, image_revision, history.timestamp].join(', ');
                selection.text = [img.name, history.timestamp].join(', ');//Dashboard only show autoboot image name
                selection.revision = history.revision;
            }
        });
        selections.push(selection);
    });
    // append option 'none' for clear autoboot image
    selections.push({text: find_i18n('s_none', 'none'), value: none_selection_value, revision: 0});

    var title = find_i18n('s_select_client_autoboot_image', 'Select auto login image file for clients');
    util_page.dialog_select(title, selections, function(select_id){
        if (select_id) {
            var data = {autoboot: 'y', id: select_id},
                url = '/tc/rest/bootimage2.php/' + select_id;
            $.map(selections, function(selection){
                if (selection.value == select_id) {
                    data['revision'] = selection.revision;
                }
            });
            util_page.rest_put(url, data, update_status);
        }
    });
}

var page_bind_input_text = function(name) {
    var save_value = function(val) {
        var settings = {};
        settings[name] = val;
        util_page.rest_put('/tc/rest/system.php/settings', settings, function() {
            page_update_input_text(name, val);
        });
    }

    $('#' + name).click(function() {
        util_page.dialog_prompt(find_i18n('s_input_server_' + name), save_value)
            .find('input').val($(this).data('val'));
    });
}

var page_bind_client_naming_rule = function() {
    $('#naming_rule').click(function() {
        var html = $('#dialog_client_naming_rule').html(),
            btn_text = find_i18n('s_save');

        util_page.dialog_confirm_builder(html, btn_text, function() {
            var rule = {
                client_naming_prefix: $(this).find('input:nth(0)').val(),
                client_naming_suffix: $(this).find('input:nth(1)').val(),
                client_naming_width: $(this).find('input:nth(2)').val(),
                client_naming_first: $(this).find('input:nth(3)').val()
            };
            util_page.rest_put('/tc/rest/system.php', rule, function() {
                page_update_client_naming_rule();
            });
        })
            .find('input:nth(0)').val($(this).data('prefix')).end()
            .find('input:nth(1)').val($(this).data('suffix')).end()
            .find('input:nth(2)').val($(this).data('width')).end()
            .find('input:nth(3)').val($(this).data('first'));
    });
}

function bind_server_side_control() {
    var $system_switch = $('#server-side .onoff-switch input:nth(0)'),
        $dhcp_switch = $('#server-side .onoff-switch input:nth(1)');

    $system_switch.change(function(){
        if ($system_switch.prop('checked')) {
            util_page.rest_post(
                '/tc/rest/controller.php',
                {rpc: 'start-system'},
                update_status,
                function(res) {
                    util_page.dialog_message_error(res);
                    update_status();
                }
            );
        } else {
            util_page.do_rpc3('stop-system', {}, update_status);
        }
    });

    $dhcp_switch.change(function() {
        var data = {rpc: 'stop-dhcp'};
        if ($(this).prop('checked')) {
            data = {rpc: 'start-dhcp'};
        }
        util_page.rest_post('/tc/rest/controller.php', data, update_status);
    });

    $('#auto_login_delay').click(function() {
        util_page.dialog_prompt_required(
            find_i18n('s_input_auto_login_delay'),
            function(val) {
                var settings = {auto_login_delay: val};
                util_page.rest_put(
                    '/tc/rest/system.php',
                    settings,
                    function() {
                        page_update_auto_login_delay(val);
                    }
                );
            }
        ).find('input').val(page_read_auto_login_delay());
    });

    $('#server_gateway').click(function() {
        util_page.dialog_prompt(
            find_i18n('s_input_server_gateway'),
            function(val) {
                var settings = {gateway: val};
                util_page.rest_put(
                    '/tc/rest/network.php',
                    settings,
                    function() {
                        page_update_network_gateway(val);
                    }
                );
            }
        ).find('input').val(page_read_network_gateway());
    });

    $('#server_dns').click(function() {
        util_page.dialog_prompt(
            find_i18n('s_input_server_dns'),
            function(val) {
                var settings = {dns: val};
                util_page.rest_put(
                    '/tc/rest/network.php',
                    settings,
                    function() {
                        page_update_network_dns(val);
                    }
                );
            }
        ).find('input').val(page_read_network_dns());
    });

    page_bind_input_text('ad_domain_server_name');
    page_bind_input_text('ad_domain_server_ip');

    page_bind_switch('client_open_registration');
    page_bind_switch('client_naming');
    page_bind_switch('ad_domain_enable');
    page_bind_switch('tracker_wan');
    page_bind_switch('ps_background_upload');
    page_bind_input_text('tracker_wan_ip');

    page_bind_client_naming_rule();
}

function change_autoboot() {
    util_page.rest_get('/tc/rest/bootimage2.php', function(result){
        select_autoboot_image(result.images);
    });
}

var enable_chart_fs = function() {
    var request_usage = function(done) {
        util_page.rest_get('/tc/rest/system.php/filesystem', function(res) {
            var total = res.disk_total_gib.toFixed(2),
                free = res.disk_free_gib.toFixed(2),
                used = res.disk_used_gib.toFixed(2);
            done(res.disk_used_percent, total, used, free);
        });
    };

    var fileSystemChart = null;

    request_usage(function(percent, total, used, free) {
        var used_text = find_i18n('s_used'),
            remain_text = find_i18n('s_remain');

        fileSystemChart = new Chart(document.getElementById("fileSystem-chart"), {
            type: 'doughnut',
            data: {
                 labels: [used_text, remain_text],
              datasets: [
                {
                  backgroundColor: ["#6bd098", "#EDEBEB"],
                  data: [percent,100-percent]
                }
              ]
            },
            options: {
                 hover: {
                    mode: 'index'
                }
            }
        });

        $('#fs-data tbody span:nth(1)').text(total);
        $('#fs-data tbody span:nth(3)').text(used);
        $('#fs-data tbody span:nth(5)').text(free);
    });

    var refresh_usage_fs = function() {
        if (global_refresh && fileSystemChart) {
            request_usage(function(percent, total, used, free) {
                fileSystemChart.data.datasets[0].data[0] = percent;
                fileSystemChart.data.datasets[0].data[1] = 100-percent;  
                fileSystemChart.update();

                $('#ie8_fs_usage_percent').text(percent + ' %');
                $('#fs-data tbody span:nth(1)').text(total);
                $('#fs-data tbody span:nth(3)').text(used);
                $('#fs-data tbody span:nth(5)').text(free);

                global_refresh = true;
            });
        }
        global_refresh = false;
        setTimeout(refresh_usage_fs, 2000);
    };
    setTimeout(refresh_usage_fs, 2000);
};

$(document).ready(function(){
    util_page.disable_cache();
    util_page.enable_locale();
    util_page.render_sidebar();
    // bind server side controls
    bind_server_side_control();

    // update data for whole page
    update_status();

    var refresh_clients = function() {
        if (global_refresh) {
            setTimeout(refresh_clients, 2000);
        }

        if ($('#client-toolbar button').is(':disabled')) {
            return;
        }

        if (global_refresh) {
            util_page.rest_get('/tc/rest/machine.php?online=1', function(result){
                $('#client-list tbody').empty(); 
                load_client_list(result.clients);
                load_client_counters(result.clients);
                global_refresh = true;
            });
        }
        global_refresh = false;
    };

    setTimeout(refresh_clients, 2000);
    var used_text = find_i18n('s_used'),
        remain_text = find_i18n('s_remain');
    var networkChart = new Chart(document.getElementById("network-chart"), {
        type: 'doughnut',
        data: {
             labels: [used_text, remain_text],
          datasets: [
            {
              backgroundColor: ["#6bd098", "#EDEBEB"],
              data: [1,99]
            }
          ]
        },
        options: {
             hover: {
                mode: 'index'
            }
        }
    });

    var refresh_nic_usage = function() {
        if (global_refresh) {
            util_page.rest_get('/tc/rest/network.php/nic_usage', function(result) {
            networkChart.data.datasets[0].data[0] = result.usage_tx_percent;
            networkChart.data.datasets[0].data[1] = 100-result.usage_tx_percent;  
            networkChart.update();
             //   nic_usage_gauge.refresh(result.usage_tx_percent);
                $('#ie8_nic_tx_usage_percent').text(result.usage_tx_percent + ' %');
                global_refresh = true;
            });
        }
        global_refresh = false;
        setTimeout(refresh_nic_usage, 2000);
    };
    setTimeout(refresh_nic_usage, 2000);

    enable_chart_fs();
});

</script>

<?php
    body_end();
    page_end();
?>
