/******************************************************************************
Copyright 2012 - 2020 Intel Corporation

For licensing information, see the file 'LICENSE' in the root folder of
                           this software module.
******************************************************************************/

/*
    language 1 is defined in DB, which is English
*/

var webconsole_locale = 'en';

// empty strings are enough because English is written in HTML as default
var i18n_strings = {
    // general texts
    s_general_disabled: 'Disabled',
    s_general_enabled: 'Enabled',
    s_general_failure: 'Failure',
    s_general_hide: 'Hide',
    s_general_global: 'Global value',
    s_general_ok: 'OK',
    s_general_show: 'Show',
    s_general_success: 'Success',
    s_general_test: 'Test',

    // component texts
    s_backup_contents: 'Backup Contents',
    s_backup_done: 'Backup completed successfully',
    s_backup_headless: 'Headless Backup',
    s_backup_interval: 'Backup Interval (min.)',
    s_backup_local: 'Local Backup',
    s_backup_local_location: 'Local Backup Location',
    s_backup_logs: 'Backup Logs',
    s_backup_mode: 'Backup Mode',
    s_backup_remote: 'Remote Backup',
    s_backup_remote_location: 'Remote Backup Server IP',
    s_backup_settings: 'Backup Settings',
    s_batch_first: 'First Index',
    s_batch_prefix: 'Prefix',
    s_batch_suffix: 'Suffix',
    s_batch_storage_frozen_off: 'Storage Frozen OFF',
    s_batch_storage_frozen_on: 'Storage Frozen ON',
    s_batch_width: 'Width',
    s_bootimage_acl_add: 'Add Group',
    s_bootimage_inuse: 'Cannot edit the image file used by clients',
    s_cci_clear_dialog_title: 'Clear cached image on client',
    s_cci_clear_sent: 'Command for clearing cached image has been sent',
    s_ci_update_reason: 'Input reason for image updating',
    s_client: 'Client',
    s_client_all: 'All registered clients',
    s_client_counter_legend: '(online/total)',
    s_client_error_hardware: 'Hardware Error',
    s_client_error_disk: 'Disk Error',
    s_client_error_initialization: 'Initialization Error',
    s_client_error_reserved_size: 'TC system reserved disk size exceeds the limit',
    s_client_hb_timeout: 'Heartbeat Timeout',
    s_client_hb_timeout_short: '(Timeout)',
    s_client_hb_timeout_title: 'Input timeout value for heartbeat in minute, from 1 to 10',
    s_client_image_pending_uploaded: 'Error: Client image pending data files not found',
    s_client_online_all: 'All online clients',
    s_dashboard_client_naming: 'Sequencing Naming',
    s_dashboard_client_naming_rule: 'Sequencing Rule',
    s_dashboard_client_registration: 'Client Registration',
    s_dhcp_export_done: 'Export DHCP settings file successfully',
    s_dhcp_lease: 'DHCP Lease Records',
    s_dhcp_lease_expiration: 'Expiration',
    s_dhcp_lease_ip: 'IP',
    s_dhcp_lease_mac: 'MAC',
    s_dhcp_subnet_settings: 'Subnet Settings',
    s_display_resolution: 'Resolution',
    s_file_uploading: 'Uploading file',
    s_full_list: 'Full List',
    s_fs_free_size: 'Free Space',
    s_fs_total_size: 'Total Space',
    s_fs_usage_percent: 'Filesystem Usage Percent',
    s_fs_used_size: 'Used Space',
    s_fw_update_done: 'Firmware Updated Successfully',
    s_fw_version_pending: 'Available Version',
    s_initialize: 'Intialize client',
    s_input_auto_login_delay: 'Input new auto login delay, from 3 to 10 seconds',
    s_input_new_client_desc: 'Input new client description',
    s_input_new_client_group: 'Input new client group',
    s_input_new_client_mac: 'Input new MAC address <br><small>MAC address format should be XX-XX-XX-XX-XX-XX</small>',
    s_input_new_client_name: 'Input new client name',
    s_input_new_client_resolution: 'Input new client display resolution, for example 1024x768',
    s_input_new_client_usb_storage: 'Enable client USB storage',
    s_input_new_dhcp_dns: 'Input new DNS address (use default value if empty)',
    s_input_new_dhcp_router: 'Input new DHCP router address',
    s_input_new_group_desc: 'Input new group description',
    s_input_new_group_name: 'Input new group name',
    s_input_new_ip_address: 'Input new IP address',
    s_input_new_netmask: 'Input new net mask',
    s_input_new_role_desc: 'Input new role description',
    s_input_new_role_name: 'Input new role name',
    s_input_server_dns: 'Input new DNS address',
    s_input_server_gateway: 'Input new gateway address',
    s_input_server_tracker_wan_ip: 'Input new WAN address',
    s_input_server_ad_domain_server_name: 'Input new AD domain server name',
    s_input_server_ad_domain_server_ip: 'Input new AD domain server address',
    s_input_new_display_name: 'Input display name',
    s_lic_client_count: 'Clients',
    s_lic_expired_time: 'Expired',
    s_lic_key: 'Please copy the key',
    s_lic_lic: 'Input lines of license, including the last character `',
    s_lic_reg_done: 'Register successfully',
    s_network_nic_speed_unknown: 'unknown speed',
    s_none: '-- none --',
    s_operation_complete: 'Operation complete',
    s_password_old: 'Old Password',
    s_password_new: 'New Password',
    s_password_reset: 'Reset Password',
    s_password_retype: 'Re-type Password',
    s_password_rule: 'Password length should between 10 to 32 characters.',
    s_password_confirm: 'Confirm Password',
    s_password_reset_done: 'Reset password successfully',
    s_password_admin: 'Admin Password',
    s_password_user_new: 'User New Password',

    s_peer_sync_starts: 'Sync between peers starts',
    s_permission_keep: 'Keep data',
    s_ps_background_upload: 'Personal Storage Background Upload',
    s_ps_background_upload_short: 'Client PS Upload',
    s_ps_background_upload_switch: 'Client PS Upload',
    s_ps_group_add: 'Add Group',
    s_reboot_client: 'Reboot client',
    s_role_auth_group: 'Authorized User Groups',
    s_role_auth_url: 'Authorized Web Pages',
    s_role_group_add: 'Add Group',
    s_role_url_add: 'Add Permission',
    s_rp_busy: 'Wait for restore point operation complete',
    s_rp_desc_input: 'Input restore point description',
    s_rp_discard: 'Discard',
    s_rp_ready: 'Ready',
    s_rp_loading: 'Restoring',
    s_rp_restore: 'Restore',
    s_save: 'Save',
    s_second: 'second(s)',
    s_select_client_group: 'Client Group List',
    s_server_wan_tracker: 'WAN Status',
    s_server_wan_tracker_ip: 'WAN Address',
    s_shutdown_client: 'Shutdown client',
    s_speed_limit_download_title: 'Download Speed Limit',
    s_speed_limit_upload_title: 'Upload Speed Limit',
    s_ssl_ca_cert: 'SSL Cert',
    s_unit_minute: 'min.',
    s_update_done_ok: 'Update done successfully',
    s_upload_file: 'Upload File',
    s_upload_select_file: 'Select a file to upload',
    s_usb_storage: 'USB Storage',
    s_usb_storage_enabled: 'Enabled',
    s_usb_storage_disabled: 'Disabled',
    s_user_disabled: 'Disabled',
    s_user_enable: 'Enable',
    s_user_enabled: 'Enabled',
    s_user_online: 'User online',
    s_version: 'Version',
    s_yesno_no: 'No',
    s_yesno_yes: 'Yes',
    s_used: 'Used',
    s_remain: 'Remain',

    c_ci_no_group_selected: 'No group selected for this client image?',
    c_client_group_delete: 'Delete this client group? Clients in it will be moved out.',
    c_client_init: 'Initialize disk on selected client? This operation cannot be cancelled.',
    c_client_init_group: 'Initialize disk on selected client group? This operation cannot be cancelled.',
    c_client_reboot: 'Reboot the selected client?',
    c_client_reboot_group: 'Reboot the selected client group?',
    c_client_shutdown: 'Shutdown the selected client?',
    c_client_shutdown_group: 'Shutdown the selected client group?',
    c_client_wakeup: 'Wakeup the selected client?',
    c_client_wakeup_group: 'Wakeup the selected client group?',
    c_delete_selected_client: 'Delete the selected client? This operation cannot be cancelled.',
    c_delete_selected_peer: 'Delete the selected peer? This operation cannot be cancelled.',
    c_delete_selected_role: 'Delete the selected role? This operation cannot be cancelled.',
    c_delete_group: 'Delete the selected group? This operation cannot be cancelled.',
    c_delete_user_storage: 'Clear personal storage of selected users? This operation cannot be cancelled',
    c_dhcp_empty_leases: 'Empty all DHCP leases and restart DHCP service?',
    c_restore_point_delete: 'Delete this restore point? This operation cannot be cancelled',
    c_restore_point_delete_inuse_head: 'Delete this restore point in use? Select a revision to restore',
    c_restore_point_delete_inuse_middle: 'Delete all history restore points above this revision? Select a revision to restore',
    c_restore_point_delete_middle: 'Delete all history restore points above the selected, including the selected?',
    c_restore_point_revision_max: 'Restore point number reaches quota. Delete the oldest restore point and create new one?',
    c_start_sync_image: 'Start sync selected image?',
    c_web_logout: 'Logout TC web console?',

    e_ad_domain_server_ip: 'Error: Invalid AD domain server IP address',
    e_ad_domain_server_name: 'Error: Invalid AD domain server name',
    e_ajax_failed: 'Error: Cannot connect to TC server',
    e_backup_busy: 'Error: Backup is running',
    e_backup_data: 'Error: Cannot backup TC system data',
    e_backup_headless: 'Error: Invalid input for backup headless flag',
    e_backup_interval: 'Error: Invalid backup interval, must be between 1 and 10080',
    e_backup_load_list: 'Error: Cannot load backup file list',
    e_backup_location_dir: 'Error: Invalid backup location directory',
    e_backup_mode: 'Error: Invalid mode',
    e_backup_location_empty: 'Error: Backup location is empty',
    e_backup_save_list: 'Error: Cannot save backup file list',
    e_backup_server: 'Error: Cannot access backup server address',
    e_backup_server_tunnel: 'Error: Cannot connect to backup server over SSH tunnel',
    e_backup_peer_busy: 'Error: Selected peer is running data backup, please try later',
    e_bad_name: 'Error: Invalid or too long name, only support numbers, letters, and _-.()[]',
    e_bad_desc: 'Error: Invalid or too long description',
    e_bad_client_mac: 'Error: Only support MAC format in hex numbers, like FF-FF-FF-FF-FF-FF',
    e_bad_client_memo: 'Error: Invalid memo format',
    e_bad_client_name: 'Error: Invalid client name, only support numbers and letters and - and _',
    e_bad_ip_address: 'Error: Invalid IP address format',
    e_bad_operation: 'Error: Operaion failed',
    e_bad_password: 'Error: Password length should be 10 to 32',
    e_batch_count: 'Error: Invalid count for batch, only support numbers',
    e_batch_count_max: 'Error: Max count is 200',
    e_batch_first: 'Error: Invalid first index, only support numbers and less then 8 digits',
    e_batch_name: 'Error: User name generated is too long, max is 30',
    e_batch_overflow: 'Error: First index is too big',
    e_batch_prefix: 'Error: Invalid prefix, only numbers, letters and _',
    e_batch_suffix: 'Error: Invalid suffix, only numbers, letters and _',
    e_batch_width: 'Error: Invalid width for batch, only support numbers',
    e_batch_width_small: 'Error: Width is too small for array count',
    e_change_bootimage: 'Error: Cannot change boot image properties',
    e_client_busy: 'Error: Client is busy',
    e_client_group_max: 'Error: Client group count limit is reached',
    e_client_group_name: 'Error: Client group name is empty',
    e_client_image_busy: 'Error: Client image is busy',
    e_client_image_not_found: 'Error: Client image not found',
    e_client_image_register: 'Error: Cannot register the client image',
    e_client_image_status_merging: 'Error: Client image is merging',
    e_client_naming: 'Error: Client sequencing naming rule is invalid',
    e_client_naming_max: 'Error: Client sequencing naming limit is reached',
    e_client_naming_first: 'Error: Invalid first index, should be greater than 0',
    e_client_naming_prefix_suffix: 'Error: Invalid prefix/suffix, only digits, alphabets, and underscore allowed, and no more than 12 characters',
    e_client_naming_width: 'Error: Invalid width, must be between 1 and 6',
    e_client_not_found: 'Error: Client not found',
    e_client_resolution: 'Error: Invalid client resolution, only support format like 1024x768',
    e_database: 'Error: Database operation failed',
    e_dhcp_import: 'Error: Import DHCP settings failed',
    e_dhcp_import_empty: 'Error: Cannot find DHCP settings file to import',
    e_duplicate_value: 'Error: Cannot use duplicate value',
    e_empty_name: 'Error: Empty name',
    e_empty_desc: 'Error: Empty description',
    e_empty_input: 'Error: Input is empty',
    e_fail_change_dhcp_dns: 'Error: Failed to change DNS address',
    e_fail_change_dhcp_router: 'Error: Failed to change DHCP router address',
    e_fail_change_ip: 'Error: Failed to change IP address',
    e_fail_load_groups: 'Error: Failed to load grops',
    e_fail_login: 'Error: User name or password is incorrect',
    e_fail_register_client: 'Error: Failed to register client',
    e_fail_register_user: 'Error: Failed to register user',
    e_firmware_size: 'Error: The firmware size should be less than 64 MiB',
    e_group_create: 'Error: Cannot create this group',
    e_group_desc: 'Error: Invalid group description, less than 40 chars',
    e_group_edit: 'Error: Cannot change the group',
    e_group_name: 'Error: Invalid group name, should be 1 - 16 chars',
    e_group_need_bootimage: 'Error: Need to register a bootimage first',
    e_hb_timeout_value: 'Error: Heartbeat timeout value must be between 1 and 10',
    e_invalid_auto_login_delay: 'Error: Invalid auto login delay, must be between 3 and 10',
    e_invalid_dhcp_router: 'Error: Invalid DHCP router address',
    e_invalid_dhcp_subnet_mask: 'Error: Invalid DHCP subnet mask',
    e_invalid_dhcp_subnet_range: 'Error: Invalid DHCP subnet range',
    e_invalid_download_mbs: 'Error: Invalid download speed limit, must be between 0 and 500, one decimal only',
    e_invalid_format_boolean: 'Error: Invalid format for boolean value',
    e_invalid_license: 'Error: Invalid license file',
    e_invalid_new_password: 'Error: Invalid new password',
    e_invalid_number: 'Error: Invalid number input',
    e_invalid_password: 'Error: Invalid password',
    e_invalid_upload_mbs: 'Error: Invalid upload speed limit, must be between 0 and 500, one decimal only',
    e_lic_count_max: 'Error: Max client count for license',
    e_lic_lic_expired: 'Error: License is expired',
    e_lic_lic_write: 'Error: Cannot not write down license',
    e_lic_reg_write: 'Error: Cannot not write down registration',
    e_login_required: 'Error: Login required',
    e_mac_required: 'Error: MAC address required',
    e_max_selected_image: 'Error: Cannot select more than one client image',
    e_no_available_image: 'Error: No available image',
    e_no_group_selected: 'Error: No group selected',
    e_no_permission: 'Error: No permission',
    e_no_role_selected: 'Error: No role selected',
    e_no_selected_image: 'Error: No client image selected',
    e_operation_denied: 'Error: Operation denied by TC server',
    e_operation_unsupported: 'Error: Operation unsupported',
    e_peer_addr_reserved: 'Error: Cannot use this address',
    e_peer_not_found: 'Error: Peer not found',
    e_ps_busy: 'Error: Personal storage is busy',
    e_ps_db_storage: 'Error: Cannot find personal storage record',
    e_ps_size_predicted: 'Error: The personal storage size has been determined as ',
    e_restore_point_busy: 'Error: Restore point is busy',
    e_restore_point_delete: 'Error: Cannot delete this restore point',
    e_restore_point_delete_middle: 'Error: Delete oldest restore point only',
    e_restore_point_not_found: 'Error: Restore point not found',
    e_restore_point_restore: 'Error: Cannot restore to this restore point',
    e_restore_revision_invalid: 'Error: Invalid revision to restore',
    e_restore_point_del_and_rst_to_min_rev: 'Error: Reached maximum quota, can not restore to the oldest restore point to be deleted',
    e_role_no_group_selected: 'Error: No group selected',
    e_role_no_url_selected: 'Error: No page selected',

    e_shell: 'Error: Shell command failed',
    e_static_ip_binding: 'Error: Failed to assign static address',
    e_static_ip_existed: 'Error: Static address exists',
    e_tracker_wan_busy: 'Error: WAN service is busy',
    e_tracker_wan_ip: 'Error: WAN address is not available',
    e_upload_file: 'Error: Upload file failed',
    e_upload_file_empty: 'Error: Uploaded file not found',
    e_vm_guest_max: 'Error: The number of running bootimage is maximum',

    // client status list
    cs_power_on: 'Booting: Power On',
    cs_power_off: 'Booting: Power Off',
    cs_authenticated: 'Booting: Auth',
    cs_syncing: 'Booting: Sync',
    cs_booting: 'Booting',
    cs_running: 'Running',
    cs_uploading: 'Booting: Commit',
    cs_shutting_down: 'Running: Shutdown',
    cs_unknown: 'Booting: Error',
    cs_initializing_disk: 'Booting: Init',
    cs_updating_firmware: 'Booting: Upgrade',
    cs_updating_firmware_cmd_sent: 'Booting: Upgrade Begin',
    cs_updating_firmware_done: 'Booting: Upgrade Done',
    cs_updating_firmware_failed: 'Booting: Upgrade Failed',

    // client image file status
    cis_file_ready: '',
    cis_file_merging: 'Merging',
    cis_file_pending: 'Pending',
    cis_file_preparing: 'Preparing',

    // client image seed status
    cis_seed_active: 'Seed Ready',
    cis_seed_error: 'Seed Error',
    cis_seed_hashing: 'Seed Hashing',
    cis_seed_missing: 'Seed Missing',
    cis_seed_raw: 'Seed Raw',

    // license status
    ls_unregistered: 'UNREGISTERED',
    ls_verified: 'License Verified',
    ls_expired: 'License Expired',
    ls_invalid: 'License Invalid',

    // tooltips
    tp_group_disabled_delete: 'Disabled, because the group is not empty',
    tp_group_selected_empty: 'Disabled, because no group selected',
    tp_group_selected_multiple: 'Disabled, because multiple selections',

    // end
    zzzzzzzz: ''
};

function update_i18n($scope) {
    function translate() {
        var attr = $(this).attr('i18n');
        if (typeof attr !== typeof undefined && attr !== false) {
            if (attr in i18n_strings) {
                $(this).text(i18n_strings[attr]);
                return;
            }
            // English is the default language
            // $(this).text(attr);
        }
    }
    // search all <span> tags
    $scope.find('span').each(translate);
    // search all <button> tags
    $scope.find('button').each(translate);
    // search all <label> tags
    $scope.find('label').each(translate);
}

function find_i18n(key, default_value) {
    if (default_value === undefined) {
        default_value = key;
    }
    return (key in i18n_strings) ? i18n_strings[key] : default_value;
}