<?php

/******************************************************************************
Copyright 2012 - 2020 Intel Corporation

For licensing information, see the file 'LICENSE' in the root folder of
                           this software module.
******************************************************************************/

require_once('../libs/inc.sugar.php');
require_once("include/inc.lang.php");

$links = array(
    'svr_mgmt' => array(
        'title' => array('en' => "Server Management", 'zh' => '服务器管理'),
        'links' => array(
            'dashboard' => array(
                'title' => array('en' => 'Dashboard', 'zh' => '系统状态'),
                'url' => '/tc/system/dashboard_page.php',
            ),
            'online_clients' => array(
                'title' => array('en' => 'Online Clients', 'zh' => '在线客户端'),
                'url' => '/tc/system/online_clients.php',
//                'show' => FALSE,
            ),
            'unreg_clients'  => array(
                'title' => array('en' => 'Unregistered Clients', 'zh' => '未注册客户端'),
                'url' => '/tc/system/unreg_clients.php',
            ),
            'network_dhcp' => array(
                'title' => array('en' => 'DHCP Settings', 'zh' => 'DHCP 配置'),
                'url' => '/tc/system/network_dhcp.php',
            ),
            'backup' => array(
                'title' => array('en' => 'Data Backup', 'zh' => '数据备份'),
                'url' => '/tc/system/system_backup.php',
            ),
            'update_firmware' => array(
                'title' => array('en' => 'Update Firmware', 'zh' => '固件更新'),
                'url' => '/tc/system/firmware_page.php',
            ),
            'about' => array(
                'title' => array('en' => 'About TC', 'zh' => '关于 TC 系统'),
                'url' => '/tc/system/about.php',
                'show' => FALSE,
            ),
            'role' => array(
                'title' => array('en' => 'User Right Management', 'zh' => '用户权限管理'),
                'url' => '/tc/system/role_page.php',
            ),
        ),
    ),
    'usr_mgmt' => array(
        'title' => array('en' => "Users and Groups", 'zh' => '用户和组'),
        'links' => array(
            'home' => array(
                'title' => array('en' => 'Home', 'zh' => '用户信息'),
                'url' => '/tc/system/home.php',
                'show' => FALSE,
            ),
            'reset_pwd' => array(
                'title' => array('en' => 'Reset Password', 'zh' => '修改密码'),
                'url' => '/tc/system/reset_pwd.php',
                'show' => FALSE,
            ),
            'create_user' => array(
                'title' => array('en' => 'Register User', 'zh' => '注册用户'),
                'url' => '/tc/system/user_create_page.php',
            ),
            'create_group' => array(
                'title' => array('en' => 'Register Group', 'zh' => '注册组'),
                'url' => '/tc/system/group_create_page.php',
            ),                
            'all_users' => array(
                'title' => array('en' => 'User List', 'zh' => '用户列表'),
                'url' => '/tc/system/user_page.php',
            ),
            'all_groups' => array(
                'title' => array('en' => 'Group List', 'zh' => '组列表'),
                'url' => '/tc/system/group_page.php',
            ),
        ),
    ),
    'img_mgmt' => array(
        'title' => array('en' => "Client Images", 'zh' => '客户端镜像'),
        'links' => array(
            'register_image' => array(
                'title' => array('en' => 'Register Image', 'zh' => '注册镜像'),
                'url' => '/tc/system/bootimage_create_page.php',
            ),
            'all_images' => array(
                'title' => array('en' => 'Client Image List', 'zh' => '镜像列表'),
                'url' => '/tc/system/bootimage_page.php',
            ),
            'sync_peers' => array(
                'title' => array('en' => 'Sync Images', 'zh' => '同步镜像'),
                'url' => '/tc/system/peer_sync_page.php',
            ),
            'client_image' => array(
                'title' => array('en' => 'Client Image', 'zh' => '客户端镜像'),
                'url' => '/tc/system/client_image.php',
                'show' => FALSE,
            ),
        ),
    ),
    'clt_mgmt' => array(
        'title' => array('en' => "Client Machines", 'zh' => '客户端管理'),
        'links' => array(
            'register_client' => array(
                'title' => array('en' => 'Register Client', 'zh' => '注册客户端'),
                'url' => '/tc/system/client_create_page.php',
            ),
            'client_full_table' => array(
                'title' => array('en' => 'Client List', 'zh' => '客户端列表'),
                'url' => '/tc/system/client_page.php',
            ),
            'client_groups' => array(
                'title' => array('en' => 'Client Groups', 'zh' => '客户端分组'),
                'url' => '/tc/system/client_group_page.php',
            ),
        ),
    ),
);

$settings_links = array(
    'svr_settings' => array(
        'title' => array('en' => "Settings", 'zh' => '设置'),
        'links' => array(
            'lang_en' => array(
                'title' => array('en' => 'English', 'zh' => 'English'),
                'url' => "javascript:select_lang('en')",
            ),
            'lang_zh' => array(
                'title' => array('en' => '中文', 'zh' => '中文'),
                'url' => "javascript:select_lang('zh')",
            ),
            'log' => array(
                'title' => array('en' => 'Download log', 'zh' => '下载 TC 日志'),
                'url' => '/tc/rest/file.php/logs',
            ),
            'about' => array(
                'title' => array('en' => 'About', 'zh' => '关于 TC 系统'),
                'url' => 'about.php',
            ),
        ),
    ),
);

function locale_title($link) {
    global $links;
    $lang = $GLOBALS['_TC2_']['lang'];
    foreach ($links as $key => $value) {
        if ($link == $key) {
            return $value['title'][$lang];
        }
        foreach ($value['links'] as $key2 => $value2) {
            if ($link == $key2) {
                return $value2['title'][$lang];
            }
        }
    }
    return $link;
}


function page_head_html($title) {
    $html = <<< HTML_END
<head>
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <meta charset="utf-8">
    <link href="../assets/bootstrap/css/bootstrap.min.css" rel="stylesheet" type="text/css">
    <link href="css/webconsole.css" rel="stylesheet" type="text/css">
    <title>$title</title>
</head>
HTML_END;

    return $html;
}

function page_head($link) {
    echo page_head_html(locale_title($link));
}

function page_script_files() {
    $lang_id = global_config_lang_id();
    $html = <<< HTML_END
    <script src="../assets/jquery.min.js"></script>
    <script src="../assets/bootstrap/js/bootstrap.min.js"></script>
    <script src="../assets/bootbox.min.js"></script>
    <script src="../assets/chart.bundle.min.js"></script>
    <script src="js/dialog.js"></script>
    <script src="js/table.js"></script>
    <script src="js/page.js"></script>
    <script src="js/iefix.js"></script>
    <script src='langs/lang.$lang_id.js'></script>
HTML_END;
    echo $html, PHP_EOL;
}

function control_pagination_html() {
    $html = <<< HTML_END
<div class="row" id="page-control">
    <nav class="col-xs-6">
      <ul class="pagination">
      </ul>
    </nav>
    <div class="col-xs-4 col-xs-offset-2 text-right">
        <label style="display: inline-block;">
            <span i18n="s_total">Total</span> <span data-id="total"></span>
        </label>
        &nbsp;
        <label style="display: inline-block;"><span i18n="s_perpage">PerPage</span></label>
        <select>
            <option value="20" selected>20</option>
            <option value="50">50</option>
            <option value="100">100</option>
        </select>
    </div>
</div>
HTML_END;
    return $html;
}

function control_pagination() {
    echo control_pagination_html();
}


function save_cancel_buttons_html() {
    $html = <<< HTML_END
        <div class="form-group">
            <div class="col-sm-offset-2 col-sm-3 col-md-2">
                <button type="button" class="btn btn-default btn-primary btn-block" id="save-button">
                    <span class="glyphicon glyphicon-ok"></span>
                    <span i18n="s_save">Save</span>
                </button>
            </div>
            <div class="col-sm-3 col-md-2">
                <button type="button" class="btn btn-default btn-block" id="cancel-button">
                    <span i18n="s_cancel">Cancel</span>
                </button>
            </div>
        </div>
HTML_END;
    return $html;
}

function save_cancel_buttons() {
    echo save_cancel_buttons_html();
}

function page_begin() {
    echo "<!DOCTYPE html>", PHP_EOL;
    echo "<html>", PHP_EOL;
}

function page_end() {
    echo "</html>", PHP_EOL;
}

function body_begin() {
    echo "<body>", PHP_EOL;
}

function body_end() {
    echo "</body>", PHP_EOL;
}

function container_begin() {
    echo '<div class="container-fluid">', PHP_EOL;
}

function container_end() {
    echo "</div>", PHP_EOL;
}

function rows_begin() {
    echo '<div class="row">', PHP_EOL;
}

function rows_end() {
    echo "</div>", PHP_EOL;
}

/**
 * Generate left sidebar
 *
 * Example:
 * <li>
    <a href="#">About</a>
    <a href="#pageSubmenu" data-toggle="collapse" aria-expanded="false">Pages</a>
    <ul class="collapse list-unstyled" id="pageSubmenu">
        <li><a href="#">Page 1</a></li>
        <li><a href="#">Page 2</a></li>
        <li><a href="#">Page 3</a></li>
    </ul>
   </li>
 *
 * @param  [type] $active_link [description]
 * @return [type]              [description]
 */
function sidebar_item_groups($links, $active_link) {
    $lis = "";
    foreach ($links as $key => $value) {
        if (safe_array_get('show', $value, true) === false) {
            continue;
        }
        $html = "";
        $ul_class = "collapse";
        foreach ($value['links'] as $key2 => $value2) {
            if (safe_array_get('show', $value2, true) === false) {
                continue;
            }
            if ($active_link == $key2) {
                $html .= '<li class="active">';
                $ul_class = "collapse.in";
            } else {
                $html .= '<li>';
            }
            $text = $value2["title"][load_configuration_str("lang")];
            $html .= '<a href="'.$value2['url'].'">'.$text.'</a></li>'.PHP_EOL;
        }
        $text = $value["title"][load_configuration_str("lang")];
        $li_html = <<< HTML_END
<li>
    <a href="#$key" data-toggle="collapse" aria-expanded="false">
        <span>$text</span>
    </a>
    <ul class="$ul_class list-unstyled" id="$key">$html</ul>
</li>
HTML_END;
        $lis .= $li_html;
    }
    return $lis;
}

function license_status_html() {
    $status = lic2_license_status();
    if ($status === "ls_verified") {
        return "";
    }
    $status_text = "";
    if ($status === "ls_unregistered") {
        $status_text = lang_text_i18n("s_license_missing");
    }
    if ($status === "ls_expired") {
        $status_text = lang_text_i18n("s_license_expired");
    }
    if ($status === "ls_invalid") {
        $status_text = lang_text_i18n("s_license_invalid");
    }
    return '<a href="about.php" class="text-error">'."<span>$status_text</span></a>";
}

function sidebar_left($active_link) {
    global $links;
    global $settings_links;
    $lis = sidebar_item_groups($links, $active_link);
    $lis2 = sidebar_item_groups($settings_links, $active_link);

    $brand = "Transparent Computing Management Console";
    $year = date("Y");
    $company = $GLOBALS['_TC2_']['company_name'];
    $logout_text = lang_text_i18n("s_common_logout");
    $ls_html = license_status_html();

    $html = <<< HTML_END
    <nav id="sidebar">
        <div class="sidebar-header">
            <p>
                $brand
            </p>
            $ls_html
        </div>
        <hr class="compact">
        <ul class="list-unstyled" id="sub_title">$lis</ul>
        <hr class="compact">
        <ul class="list-unstyled">$lis2</ul>
        <hr class="compact">
        <ul class="list-unstyled">
            <li>
                <a href="###" id="sidebar_logout">$logout_text</a>
            </li>
        </ul>
        <div class="sidebar-footer">
            <p>&copy; $year $company</p>
        </div>
   </nav>

HTML_END;
    echo $html, PHP_EOL;
}

function content_right_begin($link) {
    $title = locale_title($link);
    $html = <<< HTML_END
    <div id="main-area">
        <div class="row">
            <div class="col-xs-12">
                <h3>$title</h3><hr class="compact">
            </div>
        </div>
HTML_END;
    echo $html, PHP_EOL;
}

function content_right_end() {
    echo "</div>", PHP_EOL;
}

function page_permission_check($link) {
    session_start();
    $auth = current_session_auth();
    if (!can_read($link, $auth["uid"], $auth["gid"])) {
        echo '<script language="javascript">
                window.location = "zpermission_denied.html"
            </script>';
        exit();
    }
}

function browser_compatibility_check(){
    //Deny access request from browser IE5/6/7/8/9/10
    if(!(isset($_SERVER['HTTP_USER_AGENT'])) || (strpos($_SERVER['HTTP_USER_AGENT'], 'MSIE') !== FALSE)){
        echo '<script language="javascript">
            window.location = "zbroswer_denied.html"
            </script>';
        exit();
    }
}

function sidebar_item_home() {
    $auth = current_session_auth();
    $root_gid = load_configuration_int("root_gid");

    if($auth["gid"] > $root_gid) {
        global $links;
        global $settings_links;

        $permissions = read_permissions_by_user($auth["uid"]);
        foreach ($links as $key => $value) {
            $links[$key]['show'] = FALSE;
            foreach ($value['links'] as $key2 => $value2) {
                if (!in_array($key2, $permissions)){
                    $links[$key]['links'][$key2]['show'] = FALSE;
                } else{
                    $links[$key]['show'] = TRUE;
                }
            }
        }
        $links['usr_mgmt']['links']['home']['show'] = TRUE;
        $links['usr_mgmt']['show'] = TRUE;
        
        //Change server setting of sidebar
        $settings_links['svr_settings']['links']['log']['show'] = FALSE;
        $settings_links['svr_settings']['links']['about']['show'] = FALSE;
    }
}

/*
 * Handy functions for most pages as the template
 *
 */

function standard_page_begin($link) {
    browser_compatibility_check();
    page_permission_check($link);

    page_begin();
    page_head($link);
    body_begin();
    container_begin();

    sidebar_item_home();
    sidebar_left($link);
    content_right_begin($link);
}

function standard_page_mid() {
    content_right_end();
    container_end();

    page_script_files();
}

function standard_page_end() {
    body_end();
    page_end();
}

?>