<?php

/******************************************************************************
Copyright 2012 - 2020 Intel Corporation

For licensing information, see the file 'LICENSE' in the root folder of
                           this software module.
******************************************************************************/

    error_reporting(E_ALL);
    require('../libs/libtc.php');
    require("libpage.php");
    require("include/inc.bootstrap.php");

    standard_page_begin('network_dhcp');
?>

<div class="row container-fluid">
<!-- row for toolbar -->
<?php
    $bar = array(
        "button_groups" => array(
            array(
                "buttons" => array(
                    array(
                        "i18n" => "s_common_refresh",
                        "icon" => "glyphicon-refresh",
                        "class" => "btn-primary",
                    ),
                ),
            ),
            array(
                "buttons" => array(
                    array("i18n" => "s_dhcp_import", "icon" => "glyphicon-open"),
                    array("i18n" => "s_dhcp_export", "icon" => "glyphicon-save"),
                ),
            ),
            array(
                "buttons" => array(
                    array(
                        "i18n" => "s_dhcp_empty_leases",
                        "icon" => "glyphicon-warning-sign",
                    ),
                ),
            ),
        ),
    );
    echo html_toolbar($bar);
?>

<div class="row top15">

<!-- left side -->
<div class="col-xs-6">
    <h4><span i18n="s_dhcp_subnet_settings"></span></h4>
    <div class="form-group bottom5">
        <label><span i18n="s_dhcp_subnet_range">Subnet range</span></label>
        <div id="input-dhcp-subnet-range">
            <input type="text" length="32" style="text-align: right" readonly>
            - 
            <input type="text" length="32" style="text-align: right" readonly>
            <button i18n="s_edit" class="btn btn-link">Change</button> 
        </div>
    </div>
    <div class="form-group bottom5">
        <label class="top5"><span i18n="s_dhcp_subnet_mask">Subnet mask</span></label>
        <div id="input-dhcp-subnet-mask">
            <input type="text" length="32" style="text-align: right" readonly>
            <button i18n="s_edit" class="btn btn-link">Change</button> 
        </div>
    </div>
    <div class="form-group bottom5">
        <label><span i18n="s_dhcp_routers">Subnet router</span></label>
        <div id="input-dhcp-router">
            <input type="text" length="32" style="text-align: right" readonly>
            <button i18n="s_edit" class="btn btn-link">Change</button> 
        </div>
    </div>
    <div class="form-group bottom5">
        <label><span i18n="s_dhcp_dns">Subnet DNS</span></label>
        <div id="input-dhcp-dns">
            <input type="text" length="32" style="text-align: right" readonly disabled>
            <button i18n="s_edit" class="btn btn-link">Change</button> 
        </div>
    </div>
</div>

<!-- Right side for ip static assignment  -->
<div class="col-xs-6">
    <div class="row">
        <h4 class="col-xs-6"><span i18n="s_static_ip_assignment">Static IP Assignment</span></h4>
        <div class="col-xs-6">
            <div class="btn-toolbar tc-toolbar pull-right" role="toolbar">            
                <div class="btn-group" role="group">
                    <button type="button" class="btn btn-default btn-sm" id="add-sip">
                        <span class="glyphicon glyphicon-plus"></span> 
                        <span i18n="s_add">Add</span>
                    </button>
                    <button type="button" class="btn btn-default btn-sm" id="del-sip">
                        <span class="glyphicon glyphicon-minus"></span> 
                        <span i18n="s_delete_selected">Delete Selected</span>
                    </button>
                </div>
            </div>
        </div>
    </div>
    <div class="row">
        <div class="col-xs-12">
            <table class="table tc-table" id="sip-table">
                <thead>
                    <tr>
                        <th> <input type="checkbox"> </th>
                        <th> <span i18n="s_client"></span> </th>
                        <th> <span i18n="s_ip_address"> IP Address </span> </th>
                        <th> <span i18n="s_mac_address"> MAC Address </span> </th>
                    </tr>
                </thead>
                <tbody>
                </tbody>
            </table>
        </div>
        <div class="col-xs-12">
            <?php control_pagination(); ?>
        </div>
    </div>
</div>

    <div class="col-xs-6">
        <h4><span i18n="s_dhcp_lease"></span></h4>
        <table class="table table-striped" id="lease_table">
            <thead>
                <tr>
                    <th></th>
                    <th> <span i18n="s_client"></span> </th>
                    <th> <span i18n="s_dhcp_lease_ip"></span> </th>
                    <th> <span i18n="s_dhcp_lease_mac"></span> </th>
                    <th> <span i18n="s_dhcp_lease_expiration"></span> </th>
                </tr>
            </thead>
            <tbody>
            </tbody>
        </table>
    </div>

<!-- top layout row ending -->
</div>
<!-- top container ending -->
</div>

<div style="display: none;">
    <div id="dialog-add-sip">
        <div class="btn-group" data-toggle="buttons" id="toolbar_add_sip">
            <button type="button" class="btn btn-default"><span i18n="s_client">Client</span></button>
            <button type="button" class="btn btn-default"><span i18n="s_mac_address">MAC Address</span></button>
        </div>
        <hr>
        <div class="form-group">
            <label><span i18n="s_client">Client</span></label>
            <select class="form-control"></select>
        </div>
        <div class="form-group" style="display: none;">
            <label><span i18n="s_mac_address">MAC Address</span></label>
            <input type="text" class="form-control"></input>
        </div>
        <div class="form-group">
            <label><span i18n="s_ip_address">IP Address</span></label>
            <input type="text" class="form-control"></input>
        </div>
    </div>
    <div id="dialog-input-range">
        <div class="form-group">
            <label><span i18n="s_dhcp_subnet_begin">Subnet Begin</span></label>
            <input type="text" class="form-control"></input>
        </div>
        <div class="form-group">
            <label><span i18n="s_dhcp_subnet_end">Subnet End</span></label>
            <input type="text" class="form-control"></input>
        </div>
    </div>
</div>
<div id="form_upload_file" style="display: none;">
    <div class="form-group">
        <label i18n="s_dhcp_import_title">Select DHCP settings file</label>
        <hr class="compact">
        <input type="file" id="file-0" name="file-0">
    </div>
</div>

<?php standard_page_mid(); ?>

<script language="javascript">

"use strict";

function enable_input_dhcp_subnet(subnet_begin, subnet_end, subnet_mask) {
    //dhcp configs
    var $subnet_begin = $('#input-dhcp-subnet-range').find('input:nth(0)'),
        $subnet_end = $('#input-dhcp-subnet-range').find('input:nth(1)'),
        $subnet_mask = $('#input-dhcp-subnet-mask').find('input');

    $subnet_begin.val(subnet_begin);
    $subnet_end.val(subnet_end);
    $subnet_mask.val(subnet_mask);

    var send_subnet = function(begin, end, mask, fn_done, fn_error) {
        util_page.rest_put(
            '/tc/rest/network.php', 
            {
                dhcp_subnet_begin: begin,
                dhcp_subnet_end: end,
                dhcp_subnet_mask: mask
            }, 
            fn_done,
            fn_error);
    }

    $('#input-dhcp-subnet-range').find('button').click(function(){
        var $dialog = util_page.dialog_confirm_builder(
            $('#dialog-input-range').html(),
            find_i18n('s_save'),
            function(){
                var begin = $dialog.find('input:nth(0)').val(),
                    end = $dialog.find('input:nth(1)').val();
                $subnet_begin.val(begin);
                $subnet_begin.removeClass('bg-danger');
                $subnet_end.val(end);
                $subnet_end.removeClass('bg-danger');

                send_subnet(
                    begin,
                    end,
                    $subnet_mask.val(),
                    function(){
                    },
                    function(error){
                        $subnet_begin.addClass('bg-danger');
                        $subnet_end.addClass('bg-danger');
                        util_page.dialog_message_error(error);
                    }
                );
            });
        $dialog.find('input:nth(0)').val($subnet_begin.val());
        $dialog.find('input:nth(0)').focus();
        $dialog.find('input:nth(1)').val($subnet_end.val());
    });

    $('#input-dhcp-subnet-mask').find('button').click(function(){
        util_page.dialog_prompt_required(find_i18n('s_input_new_netmask'), function(mask){
            $subnet_mask.removeClass('bg-danger');
            send_subnet($subnet_begin.val(), $subnet_end.val(), mask, 
                function() {
                    $subnet_mask.val(mask);
                },
                function(error){
                    $subnet_mask.addClass('bg-danger');
                    util_page.dialog_message_i18n(error.error);
                }
            );
        }).find('input').val($subnet_mask.val());
    });
}

function enable_input_router(router) {
    // dhcp router
    $('#input-dhcp-router').find('input').val(router);
    $('#input-dhcp-router').find('button').click(function(){
        var $dialog = util_page.dialog_prompt_required(find_i18n('s_input_new_dhcp_router'), function(value){
            $('#input-dhcp-router').find('input').removeClass('bg-danger');
            $('#input-dhcp-router').find('input').val(value);
            util_page.rest_put('/tc/rest/network.php', {dhcp_router: value}, function(){
            }, function(error){
                $('#input-dhcp-router').find('input').addClass('bg-danger');
                util_page.dialog_message_i18n(error.error);
            });
        });
        $dialog.find('input').val($('#input-dhcp-router').find('input').val());
    });
}

function enable_input_dhcp_dns(dhcp_dns) {
    // dhcp router
    var $input_dns = $('#input-dhcp-dns input');

    $input_dns
        .attr('disabled', util_page.is_empty(dhcp_dns))
        .val(dhcp_dns);

    $('#input-dhcp-dns button').click(function(){
        var $dialog = util_page.dialog_prompt(find_i18n('s_input_new_dhcp_dns'), function(value){
            $input_dns
                .attr('disabled', util_page.is_empty(value))
                .removeClass('bg-danger')
                .val(value);

            util_page.rest_put('/tc/rest/network.php', {dhcp_dns: value}, $.noop, function(error){
                $input_dns.addClass('bg-danger');
                util_page.dialog_message_error(error);
            });
        });
        $dialog.find('input').val($input_dns.val());
    });
}

function fill_ethers(ethers) {
    function parse_record() {
        var records = [],
            $select = $('#dialog-add-sip').find('select:nth(0)');
        $select.empty();
        $.map(ethers, function(r) {
            var $option = $('<option></option').val(r.id);

            if (r.ip) {
                records.push({
                    key: r.id,
                    row: [r.name, r.ip, r.mac],
                    checkable: true
                });
                $option.text(r.name + ', ' + r.mac + ', ' + r.ip);
            } else {
                $option.text(r.name + ', ' + r.mac);
            }

            $option.appendTo($select);
        });
        return records;
    }

    util_table.load(parse_record());
    $('#del-sip').prop('disabled', true);
}

function load_ethers() {
    util_page.rest_get('/tc/rest/ethers.php', function(data){
        fill_ethers(data);
    });
}

function load_leases(leases) {
    $('#lease_table tbody').empty();
    var count = 1;
    $.map(leases, function(lease) {
        var html = '';
        html += '<td>' + count + '</td>';
        html += '<td>' + lease.tc_client + '</td>';
        html += '<td>' + lease.ipv4_addr + '</td>';
        html += '<td>' + lease.hw_addr + '</td>';
        html += '<td>' + lease.expiration + '</td>';
        html = '<tr>' + html + '</tr>';
        count = count + 1;
        $('#lease_table tbody').append(html);
    });
}

function page_init() {
    util_page.disable_cache();
    util_page.enable_locale();
    util_page.render_sidebar();

    // load network configurations
    util_page.rest_get('/tc/rest/network.php/dhcp', function(data){
        enable_input_dhcp_subnet(data.dhcp_subnet_begin, data.dhcp_subnet_end, data.dhcp_subnet_mask);
        enable_input_router(data.dhcp_router);
        enable_input_dhcp_dns(data.dhcp_dns);

        load_leases(data.dhcp_leases);
    });

    // load Static IP assignment SIP
    util_table.create($('.tc-table'));
    util_table.enable_pagination($('#page-control'));
    util_table.enable_sort();
    util_table.bind_checked(function($trs){
        if ($trs.length == 0) {
            $('#del-sip').prop('disabled', true);
        } else {
            $('#del-sip').prop('disabled', false);
        }
    });

    load_ethers();

    // bind buttons handler
    $('#add-sip').click(function(){
        var $dialog = util_page.dialog_confirm_builder(
            $('#dialog-add-sip').html(),
            find_i18n('s_save'),
            function() {
                var use_mac = $dialog.find('input:nth(0)').parent().is(':visible'),
                    cid = $dialog.find('select').val();

                if (use_mac) {
                    cid = null;
                    var mac = $.trim($dialog.find('input:nth(0)').val());
                    if (mac === '') {
                        util_page.dialog_message_i18n('e_empty_mac');
                        return false;
                    }
                    mac = util_page.parse_mac(mac);
                    $dialog.find('option').map(function(){
                        var ws = $(this).text().split(',');
                        if (ws[1].trim() === mac) {
                            cid = $(this).val();
                        }
                    });
                }
                if (cid) {
                    var ip = $dialog.find('input:nth(1)').val();
                    util_page.rest_delete(
                        '/tc/rest/ethers.php/' + cid,
                        '',
                        function(){
                            util_page.rest_post(
                                '/tc/rest/ethers.php/' + cid,
                                {'ip': ip},
                                function() {
                                    load_ethers();
                                }
                            );
                        });
                } else {
                    util_page.dialog_message_i18n('e_static_ip_binding');
                }
            }
        );
        $dialog.find('#toolbar_add_sip button:nth(0)').click(function() {
            $dialog.find('.form-group').eq(0).css('display', '');
            $dialog.find('.form-group').eq(1).css('display', 'none');
        });
        $dialog.find('#toolbar_add_sip button:nth(1)').click(function() {
            $dialog.find('.form-group').eq(0).css('display', 'none');
            $dialog.find('.form-group').eq(1).css('display', '');
        });

        function fill_ip_input($dialog, text) {
            $dialog.find('input:nth(1)').val('');
            var ws = text.split(',');
            if (ws.length > 2) {
                $dialog.find('input:nth(1)').val(ws[2]);
            }
        }
        function fill_mac_input($dialog, text) {
            var ws = text.split(',');
            if (ws.length > 1) {
                $dialog.find('input:nth(0)').val(ws[1].trim());
            }
        }
        var $select = $dialog.find('select');
        $select.val(0).change(function(){
            fill_ip_input($dialog, $select.find('option:selected').text());
            fill_mac_input($dialog, $select.find('option:selected').text());
        });
    });
    $('#del-sip').click(function(){
        var bags = util_table.checked();
        var urls = $.map(bags, function(bag){
            return '/tc/rest/ethers.php/' + bag.key;
        });

        util_page.rest_delete(urls, null, load_ethers);
    });

    // refresh button
    $('.btn-toolbar button:nth(0)').click(function() {
        util_page.page_refresh();
    });
    // import button
    $('.btn-toolbar button:nth(1)').click(function() {
        util_page.dialog_upload('/tc/rest/network.php', function() {
            util_page.dialog_message(find_i18n('s_dhcp_import_done'), function() {
                location.reload();
            });
        });
    });
    // export button
    $('.btn-toolbar button:nth(2)').click(function() {
        util_page.navi_page('/tc/rest/file.php/network');
        util_page.dialog_message_i18n('s_dhcp_export_done');
    });
    // empty leases button
    $('.btn-toolbar button:nth(3)').click(function() {
        util_page.dialog_confirm(find_i18n('c_dhcp_empty_leases'), function(){
            util_page.rest_delete(
                '/tc/rest/network.php/dhcp',
                {option: 'empty_leases'}, 
                function() {
                    util_page.page_refresh();
                }
            );
        });
    });
}

$(document).ready(page_init);

</script>

<?php standard_page_end(); ?>