<?php

/******************************************************************************
Copyright 2012 - 2020 Intel Corporation

For licensing information, see the file 'LICENSE' in the root folder of
                           this software module.
******************************************************************************/

    error_reporting(E_ALL);
    require('../libs/libtc.php');
    require("libpage.php");
    require("include/inc.bootstrap.php");

    standard_page_begin('all_users');
?>
<div class="container-fluid">
<!-- toolbar beginning -->
    <div class="row">
<?php
    $bar = array(
        "button_groups" => array(
            array(
                "buttons" => array(
                    array("i18n" => "s_user_add", "icon" => "glyphicon-plus"),
                    array("i18n" => "s_user_remove", "icon" => "glyphicon-minus"),
                ),
            ),
            array(
                "buttons" => array(
                    array("i18n" => "s_user_edit_status", "icon" => "glyphicon-edit"),
                    array("i18n" => "s_user_edit_group", "icon" => "glyphicon-edit"),
                    array("i18n" => "s_user_edit_passwd", "icon" => "glyphicon-edit"),
                    array("i18n" => "s_user_edit_ps", "icon" => "glyphicon-edit"),
                    array("i18n" => "s_user_edit_ps_del", "icon" => "glyphicon-trash"),
                ),
            ),
            array(
                "buttons" => array(
                    array("i18n" => "s_group_edit_ps_upload", "icon" => "glyphicon-upload"),
                ),
            ),
        ),
        "search_control" => array(
            "class" => "pull-right",
            "id" => "search_control",
        ),
        "id" => "crud_control",
    );
    echo html_toolbar($bar);
?>
    </div>

    <div class="row">
        <table class="table tc-table">
            <thead>
                <tr>
                    <th> <input type="checkbox"> </th>
                    <th> <span i18n="s_name"> Name </span> </th>
                    <th> <span i18n="s_user_display"> Display </span> </th>
                    <th> <span i18n="s_group"> Group </span> </th>
                    <th> <span i18n="s_ps_size_alloc"> Storage Alloc </span> </th>
                    <th> <span i18n="s_ps_size_image"> Storage Image </span> </th>
                    <th> <span i18n="s_ps_frozen"> Storage Frozen </span> </th>
                    <th> <span i18n="s_user_status"> Status </span> </th>
                    <th> </th>
                </tr>
            </thead>
            <tbody>
            </tbody>
        </table>
    </div>
</div>

<div style="display: none;">
    <div id="dialog_change_password">
        <div class="form-group">
            <label for="old_password" class="sr-only">Admin Password</label>
            <input type="password" class="form-control" id="admin_password" placeholder="Admin Password" autocomplete="off">
        </div>
        <div class="form-group">
            <label for="new_password" class="sr-only">User New password</label>
            <input type="password" class="form-control" id="user_new_password" placeholder="User New password" autocomplete="off">
        </div>
        <div class="form-group">
            <label for="repeat_password" class="sr-only">Re-type Password</label>
            <input type="password" class="form-control" id="repeat_password" placeholder="Re-type Password" autocomplete="off">
        </div>
    </div>
</div>
<?php control_pagination(); ?>

<?php standard_page_mid(); ?>

<script language="javascript">

"use strict";

var uid = <?php echo $_SESSION["uid"] ?>,
    user_name = '<?php echo $_SESSION["user_name"] ?>';

function page_load() {
    util_page.disable_cache();
    util_page.enable_locale();
    util_page.render_sidebar();

    util_table.create($('.tc-table'));
    util_table.enable_search($('#search_control input'), $('#search_control button'));
    util_table.enable_pagination($('#page-control'));
    util_table.enable_sort();
    // button list: create, delete, batch enabling, batch disabling, change group, change password
    util_table.bind_checked(function($trs){
        if ($trs.length == 0) {
            $('#crud_control button:nth(1)').prop('disabled', true);
            $('#crud_control button:nth(2)').prop('disabled', true);
            $('#crud_control button:nth(3)').prop('disabled', true);
            $('#crud_control button:nth(4)').prop('disabled', true);
            $('#crud_control button:nth(5)').prop('disabled', true);
            $('#crud_control button:nth(6)').prop('disabled', true);
        } else if ($trs.length == 1) {
            $('#crud_control button:nth(1)').prop('disabled', false);
            $('#crud_control button:nth(2)').prop('disabled', false);
            $('#crud_control button:nth(3)').prop('disabled', false);
            $('#crud_control button:nth(4)').prop('disabled', false);
            $('#crud_control button:nth(5)').prop('disabled', false);
            $('#crud_control button:nth(6)').prop('disabled', false);
        } else if ($trs.length > 1) {
            $('#crud_control button:nth(1)').prop('disabled', false);
            $('#crud_control button:nth(2)').prop('disabled', false);
            $('#crud_control button:nth(3)').prop('disabled', false);
            $('#crud_control button:nth(4)').prop('disabled', false);
            $('#crud_control button:nth(5)').prop('disabled', false);
            $('#crud_control button:nth(6)').prop('disabled', false);
        }
    });

    load_table();

    // bind button handlers
    // create
    $('#crud_control button:nth(0)').click(function() {
        util_page.navi_page('user_create_page.php');
    });

    init_buttons_status();
    // delete
    $('#crud_control button:nth(1)').click(delete_users);
    // batch enabling
    $('#crud_control button:nth(2)').click(function() {
        var selections = util_page.dialog_select_selections('EYN');
        util_page.dialog_select(find_i18n('s_user_enable'), selections, function(sel) {
            change_user({enable: sel});
        });
    });
    // change group
    $('#crud_control button:nth(3)').click(change_group);
    // change password
    $('#crud_control button:nth(4)').click(change_password);
    // frozen storage on
    $('#crud_control button:nth(5)').click(function() {
        var selections = util_page.dialog_select_selections('EYN');
        util_page.dialog_select(find_i18n('s_ps_frozen'), selections, function(sel) {
            change_user({storage_frozen: sel});
        });
    });
    // delete PS file
    $('#crud_control button:nth(6)').click(function() {
        var bags = util_table.checked(),
            message = find_i18n('c_delete_user_storage');

        util_page.dialog_confirm(message, function() {
            var urls = $.map(bags, function(bag){
                return '/tc/rest/user.php/' + bag.key + '/storage';
            });
            util_page.rest_delete(urls, {}, function() {
                load_table();
                util_page.dialog_message(find_i18n('s_operation_complete'));                
            });
        });
    });

    $('#crud_control button:nth(7)').click(change_global_ps_background_upload);
}

var change_global_ps_background_upload = function() {
    util_page.rest_get('/tc/rest/system.php/settings', function(settings) {
        util_page.dialog_select(
            find_i18n('s_ps_background_upload'),
            util_page.dialog_select_selections('YN'),
            function(v) {
                util_page.rest_put(
                    '/tc/rest/system.php/settings',
                    {ps_background_upload: v}
                );
            }
        ).find('select').val(settings.ps_background_upload.toString());
    });
}

var init_buttons_status = function() {
    // delete
    $('#crud_control button:nth(1)').prop('disabled', true);
    // batch enabling
    $('#crud_control button:nth(2)').prop('disabled', true);
    // batch disabling
    $('#crud_control button:nth(3)').prop('disabled', true);
    $('#crud_control button:nth(4)').prop('disabled', true);
    $('#crud_control button:nth(5)').prop('disabled', true);
    $('#crud_control button:nth(6)').prop('disabled', true);
};

var delete_users = function() {
    var bags = util_table.checked(),
        message = find_i18n('c_delete_user', 'Delete selected users?');

    util_page.dialog_confirm(message, function() {
        var urls = $.map(bags, function(bag){
            return '/tc/rest/user.php/' + bag.key;
        });

        util_page.rest_delete(urls, null, load_table);
    });
};

var change_group = function() {
    util_page.rest_get('/tc/rest/group.php', function(groups) {
        var group_options = [{text: find_i18n('s_select_user_group', 'Select a new user group'), value: ''}];
        $.map(groups, function(group){
            group_options.push({
                text: group.name,
                value: group.id
            });
        });
        util_page.dialog_select(
            find_i18n('s_change_user_group', 'Change user group'),
            group_options,
            function(result) {
                if (result) {
                    change_user({group: result});
                } else {
                    util_page.dialog_message_i18n('e_no_group_selected');
                }
            }
        );
    });
};

var change_password = function() {
    var admin_pwd_string = find_i18n('s_password_admin'),
        user_new_password_string = find_i18n('s_password_user_new'),
        repeat_password_string = find_i18n('s_password_retype');
        $('#admin_password').attr("placeholder", admin_pwd_string);
        $('#user_new_password').attr("placeholder", user_new_password_string);
        $('#repeat_password').attr("placeholder", repeat_password_string);

    var html = $('#dialog_change_password').html(),
        btn_text = find_i18n('s_save');

    var $dialog = util_page.dialog_confirm_builder(html, btn_text, function() {
        var admin_password =  $dialog.find('input:nth(0)').val();
        var user_new_password = $dialog.find('input:nth(1)').val();
        var repeat_user_new_password = $dialog.find('input:nth(2)').val();

        if (user_new_password.length < 10 || user_new_password.length > 32) {
            util_page.dialog_message_i18n('e_bad_password');
            return false;
        }
        if (user_new_password !== repeat_user_new_password) {
            util_page.dialog_message_i18n('e_bad_password_mismatch');
            return false;
        }

        util_page.hash_password(user_name, admin_password).then(function(hash_pwd_admin) {

            var checked_rows = util_table.checked();

            var results = [],
                rest_error;

            checked_rows.reduce(function(prev, cur, index) {
                return prev.then(function(data) {
                    return util_page.hash_password(cur.row[0], user_new_password)
                        .then(function(hash_result) {
                            var options = {
                                cipher_auth: hash_pwd_admin,
                                uid: cur.key,
                                cipher_user: hash_result,
                            };

                            util_page.rest_put('/tc/rest/user.php', options, function() {
                                results.push(data);
                            }, function(error) {
                                if (rest_error) {
                                    return;
                                }
                                rest_error = error;
                                util_page.dialog_message_error(rest_error);
                            });
                        });
                })
            }, $().promise()).done(function() {

            });
        });
    });

};

var change_user = function(user_data) {
    var checked_rows = util_table.checked();
    var urls = $.map(checked_rows, function(bag){
        return '/tc/rest/user.php/' + bag.key;
    });

    util_page.rest_put(urls, user_data, function() {
        util_page.dialog_message_i18n('s_update_done_ok');
        load_table();
    });
};

function load_table() {
    util_page.rest_get('/tc/rest/user.php', function(data) {
        util_table.load(parse_record(data));
    });
    init_buttons_status();
}

function parse_record(result) {
    var records = [];
    $.map(result, function(r) {
        var checkable = !r.online,
            enabled_text = '';

        if (r.enabled === '1') {
            enabled_text = find_i18n('s_user_enabled');
        } else {
            enabled_text = find_i18n('s_user_disabled');
        }

        var image_size = find_i18n('s_general_disabled'),
            alloc_size = find_i18n('s_general_disabled'),
            frozen = find_i18n('s_general_disabled');

        if (r.storage) {
            image_size = parseInt(r.storage[0].image_size);
            if (image_size > 0) {
                image_size = util_page.print_size(image_size, 'MiB');
            } else {
                image_size = '0 MiB';
            }
            alloc_size = parseInt(r.storage[0].user_size);
            if (alloc_size > 0) {
                alloc_size = util_page.print_size(alloc_size, 'MiB');
            } else {
                alloc_size = '0 MiB';
            }

            frozen = r.storage_frozen ? JSON.parse(r.storage_frozen) : false;
            frozen = frozen ? find_i18n('s_yesno_yes') : find_i18n('s_yesno_no');
        }

        records.push({
            key: r.id,
            row: [r.name, r.display, r.group_name, alloc_size, image_size, frozen, enabled_text],
            checkable: checkable
        });
    });
    return records;
}

$(document).ready(page_load);

</script>

<?php standard_page_end(); ?>